<?
/*
--------------------------------------------------------------------------
|   Musicbox Version 2.3.5
|   ========================================
|
|   (c) 2007
|   MAFiASCRiPTS
|   ========================================
|   Web:
|   Email:
|   Licence Info:
---------------------------------------------------------------------------  
*/
include_once('../sources/configure.php');
 

class Music {


	/*** Continue configuring here ***/

	// Location of the top of your template of your website (path)
	var $page_header = "template/header.php";

	// Location of the bottom of your website (path)
	var $page_footer = "template/footer.php";

	// Location of the top of your template for pop-ups (path)
	var $popup_header = "template/popup_header.html";

	// Location of the footer popup
	var $popup_footer = "template/popup_footer.html";


	/**************************** From configure.php*****************/
	// MySQL Information
	// Please dont forget to enter mysql information here
	var $mysqlHostname = DB_SERVER;
	var $mysqlUsername = DB_USER;//var $mysqlUsername = "database details here";
	var $mysqlPassword = DB_PASS;//var $mysqlPassword = "database details here";
	var $mysqlDbName = DB_NAME;//var $mysqlDbName = "database details here";

	// Title of your Page
	var $page_title = PGTITLE; //"My website";

	// Path of folder to place your M3U,RPM,RAM playlists (no slashes /)
	var $m3u_folder = "temp";

	// Path to where you are storing mp3,ram or rpm (without trailing slash /)
	var $musicpath = AUDIO_DIR;//var $musicpath = "/home/username/public_html/music/audio";

	// Path to the root of your music directory (without trailing slash /)
	var $siteroot= ROOT_DIR;//var $siteroot= "/home/username/public_html/music";

	// Website URL to the music directory (without trailing slash /)
	var $url = URL;//var $url = "http://www.yoursitename.com/music";

	// Please edit this line
	// Your email for mail a song
	var $email = EMAIL;


	// Name of this file
	// If you renamed index.php to somepage.php then also rename in template/js/juke.js
	var $thisfile = "index.php";

	/**** No need to edit anything below this line ****/

	var $mailextra;
	var $extensions;
	var $username;
	var $mysqlConn;

	function Music($action, $username)
	{
		global $HTTP_POST_VARS,$HTTP_GET_VARS,$HTTP_SERVER_VARS,$HTTP_SESSION_VARS,$HTTP_COOKIE_VARS,$HTTP_POST_FILES;

		$this->username = $username;
		$this->mailextra = "From: ".$this->email."\r\n";

		// Connect to the database
		$this->dbConnect();

		//include($page_header);
		?> 
		<?

		if( $action == 'song' || $action == 'lyrics' || $action == 'playlist' || $action == 'rate' || $action == 'mailfriend' || $action == 'removefromplaylist' ) {
			@include($this->popup_header);
		} else {
			@include($this->page_header);
		}

		// Determine Action
		switch( $action ) {
		case 'genre':
			$this->genre();
			break;
		case 'lyrics':
			$this->lyrics();
			break;
		case 'mailfriend':
			$this->mailfriend();
			break;
		case 'top':
			$this->topx();
			break;
		case 'rate':
			$this->rateSong();
			break;
		case 'album':
			$this->Album();
			break;
		case 'song':
			$this->song();
			break;
		case 'playlist':
			$this->playlist();
			break;
		case 'removefromplaylist':
			$this->removefromplaylist();
			break;
		case 'viewplaylist':
			$this->viewPlaylist();
			break;
		case 'viewallplaylists':
			$this->viewAllPlaylists();
			break;
		case 'showallplaylists':
			$this->showAllPlaylists();
			break;
		case 'showUsersplaylists':
			$this->showUsersPlaylists();
			break;
		case 'artist':
			$this->artist();
			break;
        case 'viewgallery':
			$this->viewgallery();
			break;
		case 'search':
			$this->search();
			break;
		case 'viewmailfriend':
			$this->viewmailfriend();
			break;
		case 'addlyrics':
			$this->addlyrics();
			break;
		case 'download':
			$this->download_songs();
			break;
		case 'upolad_songs':
			$this->songupload();
			break;
        case 'upload_artist':
			$this->upload_artist();
			break;
        case 'upload_album':
			$this->upload_album();
			break;
		case 'songlink':
			$this->songlink();
			break;
		case 'adddownload':
			$this->AddDownload();
			break;
		case 'viewallsongs':
			$this->viewallsongs();
			break;
		default:
			$this->Album();
		}

		if( $action == 'song' || $action == 'lyrics' || $action == 'playlist' || $action == 'rate' || $action == 'mailfriend' || $action == 'removefromplaylist' ) {
			@include(ROOT_DIR.$this->popup_footer);
		} else {
			@include($this->page_footer);
		}

	}

	/********** Database Functions **********/
	function dbConnect()
	{
		$this->mysqlConn = mysql_connect( $this->mysqlHostname, $this->mysqlUsername, $this->mysqlPassword )
								or die("Error: Unable to connect to MySQL server.");

		mysql_select_db( $this->mysqlDbName, $this->mysqlConn ) or die("Error: Unable to connect to MySQL database.");
	} 
	  

	function mysqlTable($resource,$headers,$base_url,$include_id)
	{
		$rowid = 0;
		$idcol = 0;

		// Resource is empty!
		if( !(mysql_num_rows($resource) > 0) )
		{
			print("<p>No records found</p>");
			exit;
		}

		// Get First Row for Fields
		$row = mysql_fetch_assoc($resource);

		// Print Fields
		print("<table cellspacing='1' cellpadding='4'>\n");
		print("  <tr>\n");
		$count = 0;
		while ($field = current($row)) {

			$count++;
			if( key($row) == 'id' ) {
				$idcol = $count;
			}

			if( !(key($row) == 'id' && !$include_id) ) {
				print("     <th>".preg_replace("/_/"," ",key($row))."</th>\n");
			}
			next($row);

		}

		// Print Extra Headers
		while( $header = current($headers) ) {
				print("     <th>".key($headers)."</th>\n");
				next($headers);
		}

		print("  </tr>\n");

		$id=0;
		do {

			print("  <tr id='row".$rowid."' onMouseOver=\"this.bgColor='#00CC66'\" onMouseOut=\"this.bgColor=''\">\n");

				$count = 0;
				foreach( $row as $field ) {

					$count++;
					if( $count == $idcol ) { $id = $field; }

					if( !( $count == $idcol && !$include_id) ) {


						if( preg_match("/http:\/\//",$field ) ) {
							$field = "<a href='".$field."'>".$field."</a>";
						}

						print("     <td>".$field."</td>\n");
					}
				}

				foreach( $headers as $field ) {
					print("     <td style='text-align: center'>[ <a href='".preg_replace("/\[id\]/",$id,$base_url).$field."'>X</a> ]</td>\n");
				}

			print("  </tr>\n");
			$rowid++;

		} while( $row = mysql_fetch_assoc($resource) );

		print("</table>\n");

	}
 

	/********** Top X Functions **********/
	function topx() {
	global $HTTP_POST_VARS,$HTTP_GET_VARS,$HTTP_SERVER_VARS,$HTTP_SESSION_VARS,$HTTP_COOKIE_VARS,$HTTP_POST_FILES;

		$sortby = ($HTTP_POST_VARS['sort']);
		$show = ($HTTP_GET_VARS['show']);
		$type = ($HTTP_GET_VARS['type']);
		//$type = $HTTP_GET_VARS['type'];
		$genre_id = ($HTTP_GET_VARS['genre']);

		if( $type == '' ) {
			print("<p>Possible usage (replace number by show by any number doesn't just have to be 5)</p>");
			print("<p>Top 5 Artists<br><a href='".$this->thisfile."?action=top&show=5&type=Artists'>".$this->thisfile."?action=top&show=5&type=Artists</a><br>");
			print("Also can display specific by just saying genre id number <a href='".$this->thisfile."?action=top&show=5&type=Artists&genre=1'>".$this->thisfile."?action=top&show=5&type=Artists&genre=1</a></p>");
			print("<p>Top 5 Songs<br><a href='".$this->thisfile."?action=top&show=5&type=Songs'>".$this->thisfile."?action=top&show=5&type=Songs</a><br>");
			print("Also can display specific by just saying genre id number <a href='".$this->thisfile."?action=top&show=5&type=Songs&genre=1'>".$this->thisfile."?action=top&show=5&type=Songs&genre=1</a></p>");
			print("<p>Top 5 Albums<br><a href='".$this->thisfile."?action=top&show=5&type=albums'>".$this->thisfile."?action=top&show=5&type=albums</a><br>");
			print("Also can display specific by just saying genre id number <a href='".$this->thisfile."?action=top&show=5&type=albums&genre=1'>".$this->thisfile."?action=top&show=5&type=albums&genre=1</a></p>");
			print("<p>Top 5 Genres<br><a href='".$this->thisfile."?action=top&show=5&type=Genres'>".$this->thisfile."?action=top&show=5&type=Genres</a></p>");
			return;
		}

		// Display Title

		 

		//$this->sortby("action=top&show=".$show."&genre=".$genre_id."&type=".$type);

		// Query
		if( $genre_id != "" ) {
			$where = "album.genre_id = '".$genre_id."' AND ";
		}

		if( $type == "albums" ) {
			$query = "SELECT album.id as album_id, SUM(song.plays) as total_plays, TO_DAYS(now())-TO_DAYS(album.post_date)as date_diff, COUNT(song.id) as total_songs, AVG(song.rating/song.num_rating) as average_rating, album.album_name as album, album.id as album_id, artist.id as artist_id, artist.name AS artist_name FROM song, album, artist WHERE ".(($genre_id!="")?$where:"")."album.id = song.album_id AND artist.id = song.artist_id GROUP BY song.album_id ORDER BY Total_Plays DESC, album.album_name ASC";
		} else if( $type == "Artists" ) {
			$query = "SELECT SUM(song.plays) as total_plays, COUNT(song.id) as total_songs, AVG(song.rating/song.num_rating) as average_rating, artist.id AS artist_id, artist.name as artist_name FROM song, artist, album WHERE ".(($genre_id!="")?$where:"")."album.id = song.album_id AND artist.id = song.artist_id GROUP BY song.artist_id ORDER BY Total_Plays DESC, artist.name ASC";
		} else if( $type == "Songs" ) {
			$query = "SELECT SUM(song.plays) as total_plays, AVG(song.rating/song.num_rating) as average_rating, song.id as song_id, song.lyric_id as lyric_id, song.lyrics_approved as lyrics, song.song_name as song_name, album.album_name as album_name, artist.name AS artist_name, artist.id as artist_id, album.id as album_id FROM song, album, artist WHERE ".(($genre_id!="")?$where:"")."album.id = song.album_id AND artist.id = song.artist_id GROUP BY song.id ORDER BY Total_Plays DESC, song.song_name ASC";
		} else if( $type == "Genres" ) {
			$query = "SELECT SUM(song.plays) as total_plays, COUNT(song.id) as total_songs, COUNT(album.id) as total_albums, genre.genre AS genre_name, genre.id as genre_id FROM song, album, genre WHERE ".(($genre_id!="")?$where:"")."genre.id = album.genre_id AND album.id = song.album_id GROUP BY album.genre_id ORDER BY Total_Plays DESC, genre.genre ASC";
		}
		$result = mysql_query($query." LIMIT ".$show) or die(mysql_error());

		print("<form name='topten' action='".$this->thisfile."?action=launch' method='post'>\n"); 
		print("<table border='0' style='width:100%'>\n");
		for( $i = 1 ; $row = mysql_fetch_assoc($result) ; $i++ ) {
			if( $type == "Albums" ) {
				print("<tr><td style='font-weight:bold; width:20px; text-align:center'>$i</span></td><td> <a href='".$this->thisfile."?action=album&id=".$row['album_id']."'>".$row['album']."</a> <a href='#'><img src='images/".((round($row['average_rating'])<1)?'1':round($row['average_rating']))."_s.gif' alt='".round($row['average_rating'],2)."' border='0'></a> ".(($row['date_diff'] < 14)?"<img src='images/new.png' alt='New!'>":"")."</td><td style='text-align: right;' onClick='javascript:mailFriend(".$row['album_id'].",0,0,0)'><a href='#'> <img src='images/mail.gif' alt='Mail a Friend' border='0'></a></td></tr>\n");
				print("<tr><td colspan='1'>&nbsp;</td><td colspan='1'><span style='font-weight:bold;'>Artist:</span> <a href='".$this->thisfile."?action=artist&id=".$row['artist_id']."'>".$row['artist_name']."</a></td></tr>\n");
				print("<tr><td colspan='1'>&nbsp;</td><td colspan='1'><span style='font-weight:bold;'>Total Songs:</span> ".$row['total_songs']."</td></tr>\n");
				print("<tr><td colspan='1'>&nbsp;</td><td colspan='1'><span style='font-weight:bold;'>Total Plays:</span> ".$row['total_plays']."</td></tr>\n");
			} else if( $type == "Artists" ) {
				print("<tr><td style='font-weight:bold; width:20px; text-align:center'>$i</span></td><td><a href='".$this->thisfile."?action=artist&id=".$row['artist_id']."'>".$row['artist_name']."</a> <img src='images/".((round($row['average_rating'])<1)?'1':round($row['average_rating']))."_s.gif' alt='".round($row['average_rating'],2)."' border='0'></td><td style='text-align: right;' onClick='javascript:mailFriend(0,".$row['artist_id'].",0,0)'><a href='#'> <img src='images/mail.gif' alt='Mail a Friend' border='0'></a></td></tr>\n");
				print("<tr><td colspan='1'>&nbsp;</td><td colspan='1'><span style='font-weight:bold;'>Total Songs:</span> ".$row['total_songs']."</td></tr>\n");
				print("<tr><td colspan='1'>&nbsp;</td><td colspan='1'><span style='font-weight:bold;'>Total Plays:</span> ".$row['total_plays']."</td></tr>\n");
			} else if( $type == "Songs" ) {
				print("<tr><td style='font-weight:bold; width:20px; text-align:center'>$i</span></td><td><a href='#' onClick=\"javascript:playSong(".$row['song_id'].")\">".$row['song_name']."</a> </td><td>".(($row['lyrics']!=0)?"<img src='images/lyrics.gif' onClick='javascript:showLyrics(".$row['lyric_id'].");' alt='Lyrics'>":"&nbsp;")."</td><td style='text-align: right;'><a href='javascript:mailFriend(0,0,".$row['song_id'].",0);'><a href='#'> <img src='images/small_mail.gif' alt='Mail a Friend' border='0'></a></td></tr>\n");
				print("<tr><td colspan='5'>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;by <a href='".$this->thisfile."?action=artist&id=".$row['artist_id']."'>".$row['artist_name']."</a></td></tr>\n");
				print("<tr><td colspan='3'>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<font face='arabic transparent' size='-2'>Times Played :  ".$row['total_plays']."</font></td></tr>\n");
			} else if( $type == "Genres" ) {
				print("<tr><td style='font-weight:bold; width:20px; text-align:center'>$i</span></td><td><a href='".$this->thisfile."?action=genre&id=".$row['genre_id']."'>".$row['genre_name']."</a> <img src='images/".((round($row['average_rating'])<1)?'1':round($row['average_rating']))."_s.gif' alt='".round($row['average_rating'],2)."' border='0'></td><td style='text-align: right;' onClick='javascript:mailFriend(0,0,0,".$row['genre_id'].")'><a href='#'> <img src='images/mail.gif' alt='Mail a Friend' border='0'></a></td></tr>\n");
				print("<tr><td colspan='1'>&nbsp;</td><td colspan='2'><span style='font-weight:bold;'>Total Songs:</span> ".$row['total_songs']."</td></tr>\n");
				print("<tr><td colspan='1'>&nbsp;</td><td colspan='2'><span style='font-weight:bold;'>Total Plays:</span> ".$row['total_plays']."</td></tr>\n");
			}
		}
		print("</table>\n"); 
		print("</form>\n");
}
						
	}
/********** Musicbox Top Ten Songs Mod **********/
	 
 
// Create Class
$mymusic = new Music($HTTP_GET_VARS['action'], $session['username']);


?> 
