<?
/*
--------------------------------------------------------------------------
|   Musicbox Version 2.3.5
|   ========================================
|
|   (c) 2007
|   MAFiASCRiPTS
|   ========================================
|   Web:
|   Email:
|   Licence Info:
---------------------------------------------------------------------------  
*/

    function addslashes_recursive($value) {
        if (is_array($value)) {
            foreach ($value as $index => $val) {
                $value[$index] = addslashes_recursive($val);
            }
            return $value;
        } else {
            return addslashes($value);
        }
    }
    if (!get_magic_quotes_gpc()) {
        // Recursively apply addslashes() to all data
        $_GET = addslashes_recursive($_GET);
        $_POST = addslashes_recursive($_POST);
        $_COOKIE = addslashes_recursive($_COOKIE);
        $_REQUEST = addslashes_recursive($_REQUEST);
        $HTTP_POST_VARS = addslashes_recursive($HTTP_POST_VARS);
        $HTTP_GET_VARS = addslashes_recursive($HTTP_GET_VARS);
        $HTTP_SERVER_VARS = addslashes_recursive($HTTP_SERVER_VARS);
        $HTTP_SESSION_VARS = addslashes_recursive($HTTP_SESSION_VARS);
        $HTTP_COOKIE_VARS = addslashes_recursive($HTTP_COOKIE_VARS);
//        $HTTP_POST_FILES = addslashes_recursive($HTTP_POST_FILES);
    }
    if (!ini_get('register_globals')) 
    {
        @extract($HTTP_SERVER_VARS);
        @extract($HTTP_SESSION_VARS);
        @import_request_variables("GPC");
    }

include_once("configure.php");


require_once(ROOT_DIR."/sources/database.php");
require_once(ROOT_DIR."/sources/mailer.php");
require_once(ROOT_DIR."/sources/form.php");
/*
include(ROOT_DIR."/sources/database.php");
include(ROOT_DIR."/sources/mailer.php");
include(ROOT_DIR."/sources/form.php");
*/
class Session
{  

   var $username;     //Username given on sign-up
   var $userid;       //Random value generated on current login
   var $userlevel;    //The level to which the user pertains
   var $time;         //Time user was last active (page loaded)
   var $logged_in;    //True if user is logged in, false otherwise
   var $userinfo = array();  //The array holding all user info
   var $url;          //The page url current being viewed
   var $referrer;     //Last recorded site page viewed
   var $review;	//true if review is active false otherwise
   /**
    * Note: referrer should really only be considered the actual
    * page referrer in process.php, any other time it may be
    * inaccurate.
    */

   /* Class constructor */
   function Session(){
	   session_start(); 
	   session_register('username');
	   session_register('userid');
	   session_register('url');

	   session_register('value_array');
	   session_register('error_array');
	   session_register('reguname');

	   session_register('regsuccess');
	   session_register('forgotpass');
	   session_register('useredit');

	    session_register('session_counter');	// useful in counters

	  /* session_register('value_array');
	   session_register('error_array');
	   session_register('reguname');
	   
	   ;*/

      $this->time = time();
      $this->startSession();
	  #$this->get_active(); 
   }

   /**
    * startSession - Performs all the actions necessary to 
    * initialize this session object. Tries to determine if the
    * the user has logged in already, and sets the variables 
    * accordingly. Also takes advantage of this page load to
    * update the active visitors tables.
    */
   function startSession(){
      global $database;  //The database connection
	 global $HTTP_POST_VARS,$HTTP_GET_VARS,$HTTP_SERVER_VARS,$HTTP_SESSION_VARS,$HTTP_COOKIE_VARS,$HTTP_POST_FILES;
		
	  //global $username,$userid,$url;

      session_start();   //Tell PHP to start the session 
	   
      /* Determine if user is logged in */
	  $this->get_active(); 
      $this->logged_in = $this->checkLogin();

      /**
       * Set guest value to users not logged in, and update
       * active guests table accordingly.
       */
      if(!$this->logged_in){ 
         $this->username = $HTTP_SESSION_VARS['username'] = GUEST_NAME;
         $this->userlevel = GUEST_LEVEL;
         $database->addActiveGuest($HTTP_SERVER_VARS['REMOTE_ADDR'], $this->time);
      }
      /* Update users last active timestamp */
      else{
         $database->addActiveUser($this->username, $this->time);
      }
      
      /* Remove inactive visitors from database */
      $database->removeInactiveUsers();
      $database->removeInactiveGuests();
      
      /* Set referrer page */
      if(isset($HTTP_SESSION_VARS['url'])){
         $this->referrer = $HTTP_SESSION_VARS['url'];
      }else{
         $this->referrer = "/";
      }

      /* Set current url */
     // $this->url = $HTTP_SESSION_VARS['url'] = $HTTP_SERVER_VARS['PHP_SELF'];
	 $this->url =  $HTTP_SERVER_VARS['PHP_SELF'];	
	 $HTTP_SESSION_VARS['url']= $this->url;
	 //
	 // to set the active values like review,subscription
   }

   /**
    * checkLogin - Checks if the user has already previously
    * logged in, and a session with the user has already been
    * established. Also checks to see if user has been remembered.
    * If so, the database is queried to make sure of the user's 
    * authenticity. Returns true if the user has logged in.
    */
   function checkLogin(){
       //The database connection
	  global $HTTP_POST_VARS,$HTTP_GET_VARS,$HTTP_SERVER_VARS,$HTTP_SESSION_VARS,$HTTP_COOKIE_VARS,$HTTP_POST_FILES;
	  global $username,$userid,$url;

      /* Check if user has been remembered */
      if(isset($HTTP_COOKIE_VARS['cookname']) && isset($HTTP_COOKIE_VARS['cookid'])){
         $this->username = $HTTP_SESSION_VARS['username'] = $HTTP_COOKIE_VARS['cookname'];
         $this->userid   = $HTTP_SESSION_VARS['userid']   = $HTTP_COOKIE_VARS['cookid'];
      }
//echo("checkLogin : ".$HTTP_SESSION_VARS['username']."<br>");
      /* Username and userid have been set and not guest */
      if(isset($HTTP_SESSION_VARS['username']) && isset($HTTP_SESSION_VARS['userid']) &&
         $HTTP_SESSION_VARS['username'] != GUEST_NAME){
         /* Confirm that username and userid are valid */
		 global $database; 
         if($database->confirmUserID($HTTP_SESSION_VARS['username'], $HTTP_SESSION_VARS['userid']) != 0){
            /* Variables are incorrect, user not logged in */
            //unset($HTTP_SESSION_VARS['username']);
           // unset($HTTP_SESSION_VARS['userid']);
            return false;
         }

         /* User is logged in, set class variables */
         $this->userinfo  = $database->getUserInfo($HTTP_SESSION_VARS['username']);
         $this->username  = $this->userinfo['username'];
         $this->userid    = $this->userinfo['userid'];
         $this->userlevel = $this->userinfo['userlevel'];
         return true;
      }
      /* User not logged in */
      else{
         return false;
      }
   }
  

   /**
    * login - The user has submitted his username and password
    * through the login form, this function checks the authenticity
    * of that information in the database and creates the session.
    * Effectively logging in the user if all goes well.
    */
   function login($subuser, $subpass, $subremember){
      global $database, $form;  //The database and form object
	 
	  global $HTTP_POST_VARS,$HTTP_GET_VARS,$HTTP_SERVER_VARS,$HTTP_SESSION_VARS,$HTTP_COOKIE_VARS,$HTTP_POST_FILES;
	  global $username,$userid,$url;

      /* Username error checking */
      $field = "user";  //Use field name for username
      if(!$subuser || strlen($subuser = trim($subuser)) == 0){
         $form->setError($field, "* Username not entered");
      }
      else{
         /* Check if username is not alphanumeric */
         if(!eregi("^([0-9a-z])*$", $subuser)){
            $form->setError($field, "* Username not alphanumeric");
         }
      }

      /* Password error checking */
      $field = "pass";  //Use field name for password
      if(!$subpass){
         $form->setError($field, "* Password not entered");
      }
      
      /* Return if form errors exist */
      if($form->num_errors > 0){
         return false;
      }

      /* Checks that username is in database and password is correct */
      $subuser = stripslashes($subuser);


     $result = $database->confirmUserPass($subuser, md5($subpass));

      /* Check error codes */
      if($result == 1){
         $field = "user";
		 
         $form->setError($field, "* Username not found");
      }
      else if($result == 2){
         $field = "pass";
         $form->setError($field, "* Invalid password");
      }
      
      /* Return if form errors exist */
      if($form->num_errors > 0){
         return false;
      }

      /* Username and password correct, register session variables */
      $this->userinfo  = $database->getUserInfo($subuser);
     $this->username   = $this->userinfo['username'];
	 //$this->username=$HTTP_SESSION_VARS['username']= $this->userinfo['username'];
     $this->userid     = $this->generateRandID();// $this->userid    = $HTTP_SESSION_VARS['userid']   = $this->generateRandID();
      $this->userlevel = $this->userinfo['userlevel'];

	  /**************************************************************/ 				
		
		session_start();
		$HTTP_SESSION_VARS['username'] = $this->username;
		$HTTP_SESSION_VARS['userid'] = $this->userid;			
		
		$HTTP_SESSION_VARS['pass'] = $subpass;

	  /**************************************************************/

      /* Insert userid into database and update active users table */
      $database->updateUserField($this->username, "userid", $this->userid);
      $database->addActiveUser($this->username, $this->time);
      $database->removeActiveGuest($HTTP_SERVER_VARS['REMOTE_ADDR']);

      /**
       * This is the cool part: the user has requested that we remember that
       * he's logged in, so we set two cookies. One to hold his username,
       * and one to hold his random value userid. It expires by the time
       * specified in constants.php. Now, next time he comes to our site, we will
       * log him in automatically, but only if he didn't log out before he left.
       */
      if($subremember){
         setcookie("cookname", $this->username, time()+COOKIE_EXPIRE, COOKIE_PATH);
         setcookie("cookid",   $this->userid,   time()+COOKIE_EXPIRE, COOKIE_PATH);
      }

      /* Login completed successfully */
	  $HTTP_SESSION_VARS['pass'] = $subpass;
      return true;
   }

   /**
    * logout - Gets called when the user wants to be logged out of the
    * website. It deletes any cookies that were stored on the users
    * computer as a result of him wanting to be remembered, and also
    * unsets session variables and demotes his user level to guest.
    */
   function logout(){
      global $database;  //The database connection
	  global $HTTP_POST_VARS,$HTTP_GET_VARS,$HTTP_SERVER_VARS,$HTTP_SESSION_VARS,$HTTP_COOKIE_VARS,$HTTP_POST_FILES;
      /**
       * Delete cookies - the time must be in the past,
       * so just negate what you added when creating the
       * cookie.
       */
      if(isset($HTTP_COOKIE_VARS['cookname']) && isset($HTTP_COOKIE_VARS['cookid'])){
         setcookie("cookname", "", time()-COOKIE_EXPIRE, COOKIE_PATH);
         setcookie("cookid",   "", time()-COOKIE_EXPIRE, COOKIE_PATH);
      }

      /* Unset PHP session variables */
      unset($HTTP_SESSION_VARS['username']);
      unset($HTTP_SESSION_VARS['userid']);
		
      /* Reflect fact that user has logged out */
      $this->logged_in = false;
	  //$PHORUM["args"]["logout"]=1;
	  //require_once("forum/login.php");
      
      /**
       * Remove from active users table and add to
       * active guests tables.
       */
      $database->removeActiveUser($this->username);
	 
      $database->addActiveGuest($HTTP_SERVER_VARS['REMOTE_ADDR'], $this->time);
   
      /* Set user level to guest */
      $this->username  = GUEST_NAME;
      $this->userlevel = GUEST_LEVEL;
   }
	function add_actions($action,$user)
	{		
		if($action=="d") $action="downloaded";
		if($action=="l") $action="listened";
		$sql="SELECT * FROM user_actions WHERE username='$user'";
		$rs=mysql_query($sql) or die(mysql_error());	
		if(mysql_num_rows($rs)==0)
		{
			$q="INSERT INTO user_actions(username,$action) VALUES('".$_SESSION['username']."',1)";
			$x=mysql_query($q);
		}
		else
		{
			$query="UPDATE user_actions SET $action=$action+1 WHERE username='$user'";
			$rs1=mysql_query($query) or die(mysql_error());
		}
	}

   /**
    * register - Gets called when the user has just submitted the
    * registration form. Determines if there were any errors with
    * the entry fields, if so, it records the errors and returns
    * 1. If no errors were found, it registers the new user and
    * returns 0. Returns 2 if registration failed.
    */
   function register($subuser, $subpass, $subpass_confirm, $subemail, $sex, $country, $newsletter, $terms){
      global $database, $form, $mailer;  //The database, form and mailer object
	  global $HTTP_POST_VARS,$HTTP_GET_VARS,$HTTP_SERVER_VARS,$HTTP_SESSION_VARS,$HTTP_COOKIE_VARS,$HTTP_POST_FILES;
/*print("FIRST <br>");
echo("Username : ".$subuser."<br>");
echo("pass : ". $subpass."<br>");
echo("pass_confirm : ".$subpass."<br>");
echo("email : ".$subemail."<br>");
echo("sex : ".$sex."<br>");
echo("country : ".$country."<br>");
echo("newsletter : ".$newsletter."<br>");
echo("avatar : ".$avatar."<br>");
*/
      /* Username error checking */
      $field = "user";  //Use field name for username
      if(!$subuser || strlen($subuser = trim($subuser)) == 0){
         $form->setError($field, "* Username not entered");
      }
      else{
         /* Spruce up username, check length */
         $subuser = stripslashes($subuser);
         if(strlen($subuser) < 3){
            $form->setError($field, "* Username below 3 characters");
         }
         else if(strlen($subuser) > 30){
            $form->setError($field, "* Username above 30 characters");
         }
         /* Check if username is not alphanumeric */
         else if(!eregi("^([0-9a-z])+$", $subuser)){
            $form->setError($field, "* Username not alphanumeric");
         }
         /* Check if username is reserved */
         else if(strcasecmp($subuser, GUEST_NAME) == 0){
            $form->setError($field, "* Username reserved word");
         }
         /* Check if username is already in use */
         else if($database->usernameTaken($subuser)){
            $form->setError($field, "* Username already in use");
         }
         /* Check if username is banned */
         else if($database->usernameBanned($subuser)){
            $form->setError($field, "* Username banned");
         }
      }
//print("SECOND <br>");
      /* Password Confirmation error checking */
      $field = "pass_confirm";  //Use field name for password
      if(!$subpass_confirm){
         $form->setError($field, "* Password not entered");
      }

      /* Password error checking */
      $field = "pass";  //Use field name for password
      if(!$subpass){
         $form->setError($field, "* Password not entered");
      }
	  /* Make sure passwords match */
      else if(!($subpass == $subpass_confirm)){
         $form->setError($field, "* Your passwords do not match");
	  }
      else{
         /* Spruce up password and check length*/
         $subpass = stripslashes($subpass);
         if(strlen($subpass) < 3){
            $form->setError($field, "* Password too short");
         }
         /* Check if password is not alphanumeric */
         else if(!eregi("^([0-9a-z])+$", ($subpass = trim($subpass)))){
            $form->setError($field, "* Password not alphanumeric");
         }
         /**
          * Note: I trimmed the password only after I checked the length
          * because if you fill the password field up with spaces
          * it looks like a lot more characters than 4, so it looks
          * kind of stupid to report "password too short".
          */
      }
// print("THIRD <br>");     
      /* Email error checking */
      $field = "email";  //Use field name for email
      if(!$subemail || strlen($subemail = trim($subemail)) == 0){
         $form->setError($field, "* Email not entered");
      }
      else{
         /* Check if valid email address */
         $regex = "^[_+a-z0-9-]+(\.[_+a-z0-9-]+)*"
                 ."@[a-z0-9-]+(\.[a-z0-9-]{1,})*"
                 ."\.([a-z]{2,}){1}$";
         if(!eregi($regex,$subemail)){
            $form->setError($field, "* Email invalid");
         }
         $subemail = stripslashes($subemail);
      }

//print("FOURTH <br>");  		   
	  /* Avatar error checking */
	  $field = "avatar"; //Use field name for avatar
	  echo $subavatar_type;
	  /* Upload Failed */
	  if ($HTTP_POST_VARS['avatar_type'] == 'upload' && !$HTTP_POST_FILES['avatar_file']['name'])
	  {
	  	$form->setError($field, "* You must upload an avatar.");
	  }
	  else if ($HTTP_POST_VARS['avatar_type'] == 'upload' && !is_uploaded_file($HTTP_POST_FILES['avatar_file']['tmp_name']))
	  {
	  	$form->setError($field, "* Your avatar failed to upload successfully; please try again.");
	  }
	  /* Avatar was not selected */
	  else if ($HTTP_POST_VARS['avatar_type'] == 'choose' && !$HTTP_POST_VARS['avatar'])
	  {
	  	$form->setError($field, "* You must choose an avatar from the list.");
	  }
	  else if ($HTTP_POST_VARS['avatar_type'] == 'upload')
	  {
	  	/** Ensure the file is really and image & that the dimensions are correct */
	  	$sizeinfo = getimagesize($HTTP_POST_FILES['avatar_file']['tmp_name']);
	  	if (!$sizeinfo)
			$form->setError($field, "* The file you uploaded does not appear to be an image.");
		elseif (!($sizeinfo[0] == 30 && $sizeinfo[1] == 30))
			$form->setError($field, "* The image you uploaded does not measure 30x30 pixels.");
	  } 
      /* Terms Of Service error checking */
      $field = "terms";  //Use field name for terms
      if(!$terms){
         $form->setError($field, "* You must read and accept the terms of service");
      }

//print("FIFTH <br>");  		 
      /* Errors exist, have user correct them */
      if($form->num_errors > 0){
//print("SIXTH  ERROR <br>"); 
         return 1;  //Errors with form
      }
      /* No errors, add the new account to the */
      else{
	     /** Move uploaded avatar */

		 if ($HTTP_POST_VARS['avatar_type'] == 'upload')
		 {			
		 	move_uploaded_file($HTTP_POST_FILES['avatar_file']['tmp_name'], AVATARS_DIR.'/'.$HTTP_POST_FILES['avatar_file']['name']);
			chmod(AVATARS_DIR.'/'.$HTTP_POST_FILES['avatar_file']['name'], 777);
			$avatar = $HTTP_POST_FILES['avatar_file']['name'];
			 
		 }
		 else
		 	$avatar = $HTTP_POST_VARS['avatar'];

/*echo("Username : ".$subuser."<br>");
echo("pass : ". $subpass."<br>");
echo("pass_confirm : ".$subpass."<br>");
echo("email : ".$subemail."<br>");
echo("sex : ".$sex."<br>");
echo("country : ".$country."<br>");
echo("newsletter : ".$newsletter."<br>");
echo("avatar : ".$avatar."<br>");
*/
         if($database->addNewUser($subuser, md5($subpass), $subemail, $avatar, $sex, $country, $newsletter))
		 {
//		 	if($database->addFrmuser($subuser,md5($subpass),$subemail))
//                return 0;  //New user added succesfully
        	if(EMAIL_WELCOME) $mailer->sendWelcome($subuser,$subemail,$subpass);
            return 0;
		} else{
            return 2;  //Registration attempt failed
         }
		
      }
      return 2;
   }
   
   /**
    * editAccount - Attempts to edit the user's account information
    * including the password, which it first makes sure is correct
    * if entered, if so and the new password is in the right
    * format, the change is made. All other fields are changed
    * automatically.
    */
   function editAccount($subcurpass, $subnewpass, $subnewpass_confirm, $subemail, $subsex, $subcountry, $subnewsletter){
      global $database, $form;  //The database and form object
	  global $HTTP_POST_VARS,$HTTP_GET_VARS,$HTTP_SERVER_VARS,$HTTP_SESSION_VARS,$HTTP_COOKIE_VARS,$HTTP_POST_FILES;

      /* New password entered */
      if($subnewpass){
         /* Current Password error checking */
         $field = "curpass";  //Use field name for current password
         if(!$subcurpass){
            $form->setError($field, "* Current Password not entered");
         }
         else{
            /* Check if password too short or is not alphanumeric */
            $subcurpass = stripslashes($subcurpass);
            if(strlen($subcurpass) < 4 ||
               !eregi("^([0-9a-z])+$", ($subcurpass = trim($subcurpass)))){
               $form->setError($field, "* Current Password incorrect");
            }
            /* Password entered is incorrect */
            if($database->confirmUserPass($this->username,md5($subcurpass)) != 0){
               $form->setError($field, "* Current Password incorrect");
            }
         }
         
	     /* Password Confirmation error checking */
		 $field = "newpass_confirm";  //Use field name for password
		 if(!$subnewpass_confirm){
			$form->setError($field, "* Password not entered");
		 }
	
         /* New Password error checking */
         $field = "newpass";  //Use field name for new password
         /* Spruce up password and check length*/
         $subpass = stripslashes($subnewpass);
         if(strlen($subnewpass) < 4){
            $form->setError($field, "* New Password too short");
         }
		  /* Make sure passwords match */
		  else if(!($subnewpass == $subnewpass_confirm)){
			 $form->setError($field, "* Your new passwords do not match");
		  }
         /* Check if password is not alphanumeric */
         else if(!eregi("^([0-9a-z])+$", ($subnewpass = trim($subnewpass)))){
            $form->setError($field, "* New Password not alphanumeric");
         }
      }
      /* Change password attempted */
      else if($subcurpass){
         /* New Password error reporting */
         $field = "newpass";  //Use field name for new password
         $form->setError($field, "* New Password not entered");
      }
      
      /* Email error checking */
      $field = "email";  //Use field name for email
      if($subemail && strlen($subemail = trim($subemail)) > 0){
         /* Check if valid email address */
         $regex = "^[_+a-z0-9-]+(\.[_+a-z0-9-]+)*"
                 ."@[a-z0-9-]+(\.[a-z0-9-]{1,})*"
                 ."\.([a-z]{2,}){1}$";
         if(!eregi($regex,$subemail)){
            $form->setError($field, "* Email invalid");
         }
         $subemail = stripslashes($subemail);
      }
      
	  /* Avatar error checking */
	  $field = "avatar"; //Use field name for avatar
	  echo $subavatar_type;
	  /* Upload Failed */
	  if ($HTTP_POST_VARS['avatar_type'] == 'upload' && !$HTTP_POST_FILES['avatar_file']['name'])
	  {
	  	$form->setError($field, "* You must upload an avatar.");
	  }
	  else if ($HTTP_POST_VARS['avatar_type'] == 'upload' && !is_uploaded_file($HTTP_POST_FILES['avatar_file']['tmp_name']))
	  {
	  	$form->setError($field, "* Your avatar failed to upload successfully; please try again.");
	  }
	  /* Avatar was not selected */
	  else if ($HTTP_POST_VARS['avatar_type'] == 'choose' && !$HTTP_POST_VARS['avatar'])
	  {
	  	$form->setError($field, "* You must choose an avatar from the list.");
	  }
	  else if ($HTTP_POST_VARS['avatar_type'] == 'upload')
	  {
	  	/** Ensure the file is really and image & that the dimensions are correct */
	  	$sizeinfo = getimagesize($HTTP_POST_FILES['avatar_file']['tmp_name']);
	  	if (!$sizeinfo)
			$form->setError($field, "* The file you uploaded does not appear to be an image.");
		elseif (!($sizeinfo[0] == 30 && $sizeinfo[1] == 30))
			$form->setError($field, "* The image you uploaded does not measure 30x30 pixels.");
	  }
	  
      /* Errors exist, have user correct them */
      if($form->num_errors > 0){
         return false;  //Errors with form
      }
      
      /* Update password since there were no errors */
      if($subcurpass && $subnewpass){
         $database->updateUserField($this->username,"password",md5($subnewpass));
		 $database->updateFrmuserfield($this->username,"password",md5($subnewpass));
      }
      
      /* Change Email */
      if($subemail){
         $database->updateUserField($this->username,"email",$subemail);
		 $database->updateFrmuserfield($this->username,"email",$subemail);
      }
      
	  /* Change Avatar */
	  if ($HTTP_POST_VARS['avatar_type'] == 'upload')
	  {
	  	move_uploaded_file($HTTP_POST_FILES['avatar_file']['tmp_name'], AVATARS_DIR.'/'.$HTTP_POST_FILES['avatar_file']['name']);
		$avatar = $HTTP_POST_FILES['avatar_file']['name'];
	  }
	  else if ($HTTP_POST_VARS['avatar_type'] == 'choose')
	  	$avatar = $HTTP_POST_VARS['avatar'];
	  if ($HTTP_POST_VARS['avatar_type'] != 'keep')
	  {
         $database->updateUserField($this->username,"avatar",$avatar);
		
      }
	  
	  /* Change Sex */
      if($subsex){
         $database->updateUserField($this->username,"sex",$subsex);
      }
	  
	  /* Change Country */
      if($subcountry){
         $database->updateUserField($this->username,"country",$subcountry);
      }
	  
	  /* Change Newsletter */
      $database->updateUserField($this->username,"newsletter",$subnewsletter);
	  
      /* Success! */
      return true;
   }
   
   /**
    * isAdmin - Returns true if currently logged in user is
    * an administrator, false otherwise.
    */
   function isAdmin(){
      return ($this->userlevel == ADMIN_LEVEL ||
              $this->username  == ADMIN_NAME);
   }
   
   /**
    * generateRandID - Generates a string made up of randomized
    * letters (lower and upper case) and digits and returns
    * the md5 hash of it to be used as a userid.
    */
   function generateRandID(){
      return md5($this->generateRandStr(16));
   }
   
   /**
    * generateRandStr - Generates a string made up of randomized
    * letters (lower and upper case) and digits, the length
    * is a specified parameter.
    */
   function generateRandStr($length){
      $randstr = "";
      for($i=0; $i<$length; $i++){
         $randnum = mt_rand(0,61);
         if($randnum < 10){
            $randstr .= chr($randnum+48);
         }else if($randnum < 36){
            $randstr .= chr($randnum+55);
         }else{
            $randstr .= chr($randnum+61);
         }
      }
      return $randstr;
   }
   # function to get what options are avtive
   function get_active()
   {
   		$active=mysql_query("SELECT * FROM config WHERE value=1") or die(" No config value Set yet in session");
	while($values=mysql_fetch_array($active))
	{
		if($active['id']==2) $this->review=true;
		if($active['id']==3) $this->subscription=true;
	}
   }
};


/**
 * Initialize session object - This must be initialized before
 * the form object because the form uses session variables,
 * which cannot be accessed unless the session has started.
 */

$session = new Session;

/* Initialize form object */
$form = new Form;

if (AUTOMATIC_MODE) {
	include_once("automatic_addon.php"); 
}

?>
