<?
/*
--------------------------------------------------------------------------
|   Musicbox Version 2.3.5
|   ========================================
|
|   (c) 2007
|   MAFiASCRiPTS
|   ========================================
|   Web:
|   Email:
|   Licence Info:
---------------------------------------------------------------------------  
*/

include_once("../sources/session.php");
if(!$session->logged_in){
	header("location:../admin/adminpanel.php");
}
 
class Admin {


	/**** Please Enter You Database Details here ****/
    
	// MySQL Information
	// Please dont forget to enter mysql information here 
	var $mysqlHostname = DB_SERVER;
	var $mysqlUsername = DB_USER;
	var $mysqlPassword = DB_PASS;
	var $mysqlDbName = DB_NAME; 
	
	// Root path to start looking for songs in for browse add!!!
	var $musicpath = AUDIO_DIR;//"/home/username/public_html/musicboxv2/audio";
 


	
/**** Nothing Else needs to be setup here  ****/
	
	var $mysqlConn;
	var $extensions;

	function Admin($action)
	{
		global $HTTP_POST_VARS,$HTTP_GET_VARS,$HTTP_SERVER_VARS,$HTTP_SESSION_VARS,$HTTP_COOKIE_VARS;

		// Connect to the database
		$this->dbConnect();
		
		// Get the File Types
		$this->getExtensions();
		
		$this->openHTML();
		
		// Print the Menu
		$this->menu();
		
		// Print the body area
		$this->openBody();
		
		// Determine Action

		switch( $action ) {
		case 'genre':
			$this->genre();
			break;
		case 'artistgallery':
			$this->artistgallery();
			break;
        case 'albumgallery':
			$this->albumgallery();
			break;
        case 'avaitingartistgallery':
			$this->avaitingartistgallery();
			break;
        case 'avaitingalbumgallery':
			$this->avaitingalbumgallery();
			break;
		case 'song':
			$this->song();
			break;
		case 'format':
			$this->format();
			break;
		case 'artist':
			$this->artist();
			break;
		case 'album':
			$this->album();
			break;
		case 'songdir':
			if( $HTTP_GET_VARS['dir'] == "" ) { $dir = $this->musicpath;}
			else { $dir = $HTTP_GET_VARS['dir']; }
			$this->songDirListing($dir);
			break;
		case 'playlist':
			$this->playlist();
			break;
		case 'mailfriend':
			$this->mailfriend();
			break;
		case 'addlyrics':
			$this->addlyrics();
			break;
		case 'upolad_songs':	
			$this->songupload();
			break;
		case 'viewsongs':	
			$this->viewsongs();
			break;
		case 'brokenlink':
			$this->brokenlink();
			break;
		case 'automatic_mode':
			$this->automatic_mode();
			break;
		case 'download_mode':
			$this->download_mode();
			break;
		case 'flashplayer_mode':
			$this->flashplayer_mode();
			break;
		default:
			$this->login();		
		}
		
		// Close the body area
		$this->closeBody();
		$this->closeHTML();
		
	}
	
	/********** Database Functions **********/
	function dbConnect()
	{
		global $HTTP_POST_VARS,$HTTP_GET_VARS,$HTTP_SERVER_VARS,$HTTP_SESSION_VARS,$HTTP_COOKIE_VARS;		


		$this->mysqlConn = mysql_connect( $this->mysqlHostname, $this->mysqlUsername, $this->mysqlPassword )
								or die("Error: Unable to connect to MySQL server.");
		mysql_select_db( $this->mysqlDbName, $this->mysqlConn ) or die("Error: Unable to connect to MySQL database.");
	}
	
	function getExtensions() {
		global $HTTP_POST_VARS,$HTTP_GET_VARS,$HTTP_SERVER_VARS,$HTTP_SESSION_VARS,$HTTP_COOKIE_VARS;

		$query = "SELECT extension FROM format WHERE 1";
		$result = mysql_query( $query );
		for( $i = 0 ; $row = mysql_fetch_assoc($result) ; $i++ ) {
			$this->extensions[$i] = $row['extension'];
		}
	}
	
	
	/********** Login Functions **********/
	function login()
	{
		#print("login");
	}
	
	function menu()
	{
		global $session;
		global $HTTP_POST_VARS,$HTTP_GET_VARS,$HTTP_SERVER_VARS,$HTTP_SESSION_VARS,$HTTP_COOKIE_VARS;

#		print("<div id='menu' style='position: absolute; top: 10px; left: 10px; width: 					   160px;font-size:.7em'>"); 
   if($session->isAdmin()){ 

   }
 
#		print("</div>");	
	}
	
	function openBody()
	{
#		print("<div id='body' style='position: absolute; top: 10px; left: 120px;'>");
	}
	
	function closeBody()
	{
#		print("</div>");
	}
	
	function openHTML()
	{
		print("<html>\n");
		print("<head>\n");
		print("<title>Admin Control Panel</title>\n");
		print("<meta http-equiv='Content-Type' content='text/html; charset=iso-8859-1'>\n");
		print("<link rel='stylesheet' type='text/css' media='all' href='../template/css/admintheme.css' /> ");
		print("</head>\n");
		print("<body bgcolor=#FFFFFF>\n");	
	}
	
	function closeHTML()
	{
		print("</body>\n");
		print("</htm1>\n");
	}
	/********** GUI Functions **********/
	 
	function mysqlTable($resource,$headers,$base_url,$include_id)
	{
		global $HTTP_POST_VARS,$HTTP_GET_VARS,$HTTP_SERVER_VARS,$HTTP_SESSION_VARS,$HTTP_COOKIE_VARS;

		$rowid = 0;
		$idcol = 0;
/*
echo("<br>upflag : ".$HTTP_GET_VARS["upflag"]);
echo("<br>action : ".$HTTP_GET_VARS["action"]);
*/
		// Resource is empty!
		if( !(mysql_num_rows($resource) > 0) )
		{
			print("<tr><td class='tdrow2'  width='40%'  valign='middle'>No records found</td>");
			exit;
		}
	
		// Get First Row for Fields
		$row = mysql_fetch_assoc($resource);
		
		// Print Fields 
		print("<table class='tdrow1' border = '0' style='width:100%;border-collapse:collapse;border-spacing:0px;' cellspacing='0' cellpadding='5'>\n");
		print("  <tr>\n");
		$count = 0;
		while ($field = current($row)) {
		
			$count++;
			if( key($row) == 'id' ) {
				$idcol = $count;				
			}
			
			if( !(key($row) == 'id' && !$include_id) ) {
				print(" <td class='tdrow5' valign='middle'><b>".preg_replace("/_/"," ",key($row))."</b></th>\n");
			}
			next($row);			
				
		}
		
		// Print Extra Headers
		while( $header = current($headers) ) {
				print("<th class='tdrow5'><b>".key($headers)."</b></th>\n");
				next($headers);	
		}
		
		print("  </tr>\n");		
		$id=0;
		do {
		
			print("  <tr id='row".$rowid."' onMouseOver=\"this.bgColor='#DFE7EF'\" onMouseOut=\"this.bgColor=''\">\n");
			
				$count = 0;
		

				foreach( $row as $field ) {
				
					$count++;
					if( $count == $idcol ) { $id = $field; }
					
					if( !( $count == $idcol && !$include_id) ) {
					
				
						if( preg_match("/http:\/\//",$field ) ) {
							$field = "<a href='".$field."'>".$field."</a>";
						}
					
						print("<td class='tdrow4'>".$field."</td>\n");
					}
				}
				
				if($HTTP_GET_VARS["upflag"] == 1)
				{

				
				}
				else
				{	
					foreach( $headers as $field ) {
						print("<td class='tdrow4' style='text-align: center'>[ <a href='".preg_replace("/\[id\]/",$id,$base_url).$field."'><b>X</b></a> ]</td>\n");				
					}	
				}

			print("  </tr>\n");
			$rowid++;
					
				
		} while( $row = mysql_fetch_assoc($resource) );
		  
	}
	

	function automatic_mode()
	{
		@include("../sources/configure.php");
		$str_hostname	=	DB_SERVER;	
		$str_user		=	DB_USER;
		$str_pass		=	DB_PASS;
		$str_db			=	DB_NAME;
		$str_rootdir	=	ROOT_DIR;
		$str_audiodir	=	AUDIO_DIR;
		$str_url		=	URL;
		$str_email		=	EMAIL;
		$str_avatardir	=	AVATAR_DIR;
		$str_pgtitle	=	PGTITLE;
		$str_automatic_mode = AUTOMATIC_MODE;
		$str_download_mode = DOWNLOAD_MODE;
		$str_flashplayer_mode = FLASHPLAYER_MODE;
		if ($str_automatic_mode) {
			$selected[0] = "selected";
		} else {
			$selected[1] = "selected";
		}
		print("<div id='logomain'><div id='logotopmain'><div style='font-weight:bold;font-size:12px;color:#000;padding-top:14px;padding-left:4px'>Automatic Addon</div></div></div><table width='100%' cellspacing='6' id='submenu'><tr><td align='left'><a href='adminpanel.php?action=download_mode'>Direct Linking On/Off</a></td><td align='right'><a href='news.php'>Admin Home</a></td></tr></table>");
print("<div id='description'>This section will allow you to switch on/off automatic addon genre/artist/album/songs from audio folder to database. This is new feature in Musicbox, we suggest you to read documentation.</div>");
print("<div class='tableborder'><div class='maintitle'>Automatic Addon Genre/Artist/Album/Songs into database</div>\n");
		?> 
		<FORM action="settings_install.php?install=1" name = 'frm' method = 'post' enctype = 'application/x-www-urlencoded'>
			<input type = 'hidden' name = 'hostname' value = '<?=$str_hostname?>'>
			<input type = 'hidden' name = 'user' value = '<?=$str_user?>'>
			<input type = 'hidden' name = 'pass' value = '<?=$str_pass?>'>
			<input type = 'hidden' name = 'db' value = '<?=$str_db?>'>
			<input type = 'hidden' name = 'rootdir' value = '<?=$str_rootdir?>'>
			<input type = 'hidden' name = 'audiodir' value = '<?=$str_audiodir?>'>
			<input type = 'hidden' name = 'avatardir' value = '<?=$str_avatardir?>'>
			<input type = 'hidden' name = 'url' value = '<?=$str_url?>'>
			<input type = 'hidden' name = 'email' value = '<?=$str_email?>'>
			<input type = 'hidden' name = 'pgtitle' value = '<?=$str_pgtitle?>'>
			<input type = 'hidden' name = 'download_mode' value = '<?=$str_download_mode?>'>
<input type = 'hidden' name = 'flashplayer_mode' value = '<?=$str_flashplayer_mode?>'>
			<table width='100%' cellspacing='0' cellpadding='5' align='center' border='0'>
			<td class='tdrow1'width='40%' valign='middle'>
								&nbsp;&nbsp;&nbsp;<b>Switch &nbsp;&nbsp;</b> <br>
							</td>
							<td class='tdrow2'  width='60%'  valign='middle'>
								<SELECT name='automatic_mode'>
									<OPTION value='1' <?=$selected[0]?>>On</OPTION>
									<OPTION value='0' <?=$selected[1]?>>Off</OPTION>
								</SELECT>
							</td>
						</tr> 
			</TABLE>
			<table width='100%' cellspacing='0' cellpadding='5' align='center' border='0'>
				<tr>
				<td  height = '40' align = 'left' valign = 'center' class = 'tdrow1' width="50%">
					<b>What is Automatic Addon Feature ?</b> If you have so many genre/artist/albums/songs and dont want to add them manually into database from administration then you need to switch on this feature and just create folder names in audio folder as >genre>artist>album>songs and all folder information will be added in your database. 
<br>
<b><i>Note :</i></b> You can name folder genre>artist>album>songs as anything 
<br><u><i>Eg</i></u> : Classic>Artist Musicbox>Album Hits>Songs for more information please read <a href="documentation/index.html" target="_blank">documentation</a>.  
				</td>
			</tr>
		</table>
			<table width='100%' cellspacing='0' cellpadding='5' align='center' border='0'>
				<tr>
				<td align = 'center' height = '40' class = 'tdrow1' width="100%">
					<input type = 'submit' value = 'Submit' class = 'shape'>
				</td>
			</tr>
		</table>
		</FORM>
		<?

	}

	
	function download_mode()
	{
		@include("../sources/configure.php");
		$str_hostname	=	DB_SERVER;	
		$str_user		=	DB_USER;
		$str_pass		=	DB_PASS;
		$str_db			=	DB_NAME;
		$str_rootdir	=	ROOT_DIR;
		$str_audiodir	=	AUDIO_DIR;
		$str_url		=	URL;
		$str_email		=	EMAIL;
		$str_avatardir	=	AVATAR_DIR;
		$str_pgtitle	=	PGTITLE;
		$str_automatic_mode = AUTOMATIC_MODE;
		$str_download_mode = DOWNLOAD_MODE;
		$str_flashplayer_mode = FLASHPLAYER_MODE;
		if ($str_download_mode) {
			$selected[0] = "selected";
		} else {
			$selected[1] = "selected";
		}
		print("<div id='logomain'><div id='logotopmain'><div style='font-weight:bold;font-size:12px;color:#000;padding-top:14px;padding-left:4px'>Direct Linking</div></div></div><table width='100%' cellspacing='6' id='submenu'><tr><td align='left'><a href='../player.php'>Set Default Player</a></td><td align='right'><a href='news.php'>Admin Home</a></td></tr></table>");
print("<div id='description'>This section will allow you to switch on/off direct linking for songs links on album pages. This is new feature in Musicbox, we suggest you to read documentation.</div>");
print("<div class='tableborder'><div class='maintitle'>Direct Linking</div>\n");
		?>
		<FORM action="settings_install.php?install=1" name = 'frm' method = 'post' enctype = 'application/x-www-urlencoded'>
			<input type = 'hidden' name = 'hostname' value = '<?=$str_hostname?>'>
			<input type = 'hidden' name = 'user' value = '<?=$str_user?>'>
			<input type = 'hidden' name = 'pass' value = '<?=$str_pass?>'>
			<input type = 'hidden' name = 'db' value = '<?=$str_db?>'>
			<input type = 'hidden' name = 'rootdir' value = '<?=$str_rootdir?>'>
			<input type = 'hidden' name = 'audiodir' value = '<?=$str_audiodir?>'>
			<input type = 'hidden' name = 'avatardir' value = '<?=$str_avatardir?>'>
			<input type = 'hidden' name = 'url' value = '<?=$str_url?>'>
			<input type = 'hidden' name = 'email' value = '<?=$str_email?>'>
			<input type = 'hidden' name = 'pgtitle' value = '<?=$str_pgtitle?>'>
			<input type = 'hidden' name = 'automatic_mode' value = '<?=$str_automatic_mode?>'>
			<input type = 'hidden' name = 'flashplayer_mode' value = '<?=$str_flashplayer_mode?>'>
			<table width='100%' cellspacing='0' cellpadding='5' align='center' border='0'>
			<td class='tdrow1'  width='40%' valign='middle'>
								&nbsp;&nbsp;&nbsp;<b>Switch  &nbsp;&nbsp;</b> <br>
							</td>
							<td class='tdrow2'  width='60%'  valign='middle'>
								<SELECT name='download_mode'>
									<OPTION value='1' <?=$selected[0]?>>On</OPTION>
									<OPTION value='0' <?=$selected[1]?>>Off</OPTION>
								</SELECT>
							</td>
						</tr> 
			</TABLE>
			<table width='100%' cellspacing='0' cellpadding='5' align='center' border='0'>
				<tr>
				<td  height = '40' align = 'left' valign = 'center' class = 'tdrow1' width="50%">
					<b>What is Direct Linking ?</b> On Album pages song links opens in popup window with embedded player if you want to show song links to be directly opened in users computer players then turn this feature on.
<br>
<b><i>Note :</i></b> When you turn on this feature you must also change the embedded player to <a href="../player.php?action=def&id=8">Direct Linking</a>. 
<br> 
				</td>
			</tr>
		</table>
			<table width='100%' cellspacing='0' cellpadding='5' align='center' border='0'>
				<tr>
				<td align='center' height = '40'  class = 'tdrow1' width="100%">
					<input type = 'submit' value = 'Submit' class = 'shape'>
				</td>
			</tr>
		</table>
		</FORM>
		
		
		<?

	}

	
	function flashplayer_mode()
	{
		@include("../sources/configure.php");
		$str_hostname	=	DB_SERVER;	
		$str_user		=	DB_USER;
		$str_pass		=	DB_PASS;
		$str_db			=	DB_NAME;
		$str_rootdir	=	ROOT_DIR;
		$str_audiodir	=	AUDIO_DIR;
		$str_url		=	URL;
		$str_email		=	EMAIL;
		$str_avatardir	=	AVATAR_DIR;
		$str_pgtitle	=	PGTITLE;
		$str_automatic_mode = AUTOMATIC_MODE; 
		$str_download_mode = DOWNLOAD_MODE;
		$str_flashplayer_mode = FLASHPLAYER_MODE;
		if ($str_flashplayer_mode) {
			$selected[0] = "selected";
		} else {
			$selected[1] = "selected";
		}
		print("<div id='logomain'><div id='logotopmain'><div style='font-weight:bold;font-size:12px;color:#000;padding-top:14px;padding-left:4px'>Flash Button</div></div></div><table width='100%' cellspacing='6' id='submenu'><tr><td align='left'><a href='../player.php'>Set Default Player</a></td><td align='right'><a href='news.php'>Admin Home</a></td></tr></table>");
print("<div id='description'>This section will allow you to switch on/off direct linking for songs links on album pages. This is new feature in Musicbox, we suggest you to read documentation.</div>");
print("<div class='tableborder'><div class='maintitle'>Flash Button</div>\n");
		?>
		<FORM action="settings_install.php?install=1" name = 'frm' method = 'post' enctype = 'application/x-www-urlencoded'>
			<input type = 'hidden' name = 'hostname' value = '<?=$str_hostname?>'>
			<input type = 'hidden' name = 'user' value = '<?=$str_user?>'>
			<input type = 'hidden' name = 'pass' value = '<?=$str_pass?>'>
			<input type = 'hidden' name = 'db' value = '<?=$str_db?>'>
			<input type = 'hidden' name = 'rootdir' value = '<?=$str_rootdir?>'>
			<input type = 'hidden' name = 'audiodir' value = '<?=$str_audiodir?>'>
			<input type = 'hidden' name = 'avatardir' value = '<?=$str_avatardir?>'>
			<input type = 'hidden' name = 'url' value = '<?=$str_url?>'>
			<input type = 'hidden' name = 'email' value = '<?=$str_email?>'>
			<input type = 'hidden' name = 'pgtitle' value = '<?=$str_pgtitle?>'>
			<input type = 'hidden' name = 'automatic_mode' value = '<?=$str_automatic_mode?>'>
			<input type = 'hidden' name = 'download_mode' value = '<?=$str_download_mode?>'>
			<table width='100%' cellspacing='0' cellpadding='5' align='center' border='0'>
			<td class='tdrow1'  width='40%' valign='middle'>
								&nbsp;&nbsp;&nbsp;<b>Switch  &nbsp;&nbsp;</b> <br>
							</td>
							<td class='tdrow2'  width='60%'  valign='middle'>
								<SELECT name='flashplayer_mode'>
									<OPTION value='1' <?=$selected[0]?>>On</OPTION>
									<OPTION value='0' <?=$selected[1]?>>Off</OPTION>
								</SELECT>
							</td>
						</tr> 
			</TABLE>
			<table width='100%' cellspacing='0' cellpadding='5' align='center' border='0'>
				<tr>
				<td  height = '40' align = 'left' valign = 'center' class = 'tdrow1' width="50%">
					<b>What is Direct Linking ?</b> On Album pages song links opens in popup window with embedded player if you want to show song links to be directly opened in users computer players then turn this feature on.
<br>
<b><i>Note :</i></b> When you turn on this feature you must also change the embedded player to <a href="../player.php?action=def&id=8">Direct Linking</a>. 
<br> 
				</td>
			</tr>
		</table>
			<table width='100%' cellspacing='0' cellpadding='5' align='center' border='0'>
				<tr>
				<td align='center' height = '40'  class = 'tdrow1' width="100%">
					<input type = 'submit' value = 'Submit' class = 'shape'>
				</td>
			</tr>
		</table>
		</FORM>
		<?

	}

	
	
	function brokenlink()
	{
	
		global $HTTP_GET_VARS;
	
		//Code for Remove Broken Link
		$id = $HTTP_GET_VARS['id'];
		$flag = $HTTP_GET_VARS['flag'];
		

		if (trim($flag)=='DENY') 
		{
				$q_brlink0 = "select song_id from tbl_brokenlinks where id = $id ";
			$q_brlink_result0 = mysql_query($q_brlink0) or die(mysql_error());
			$q_brlink_rows = @mysql_fetch_array($q_brlink_result0);
			$iid = $q_brlink_rows["song_id"];
				
			//Remove Selected link by Admin from song table
			$q_brlink1 = "DELETE FROM song  WHERE id in($iid)";	
			$q_brlink_result1 = mysql_query($q_brlink1) or die(mysql_error());

			//Remove Selected link by Admin
			$q_brlink2 = "DELETE FROM tbl_brokenlinks WHERE id in($id)";
			$q_brlink_result2 = mysql_query($q_brlink2) or die(mysql_error());

			
		}
		else if (trim($flag)=='APP') 
		{
			$q_brlink2 = "DELETE FROM tbl_brokenlinks WHERE id in($id)";
			$q_brlink_result2 = mysql_query($q_brlink2) or die(mysql_error());
		}
		
	//******************
	
	
	//Select Links from database
	$q = "SELECT a.song_name,a.song_path,a.url,b.id,c.name,d.album_name FROM song as a,tbl_brokenlinks as b, artist as c, album as d WHERE a.id=b.song_id and c.id = a.artist_id and d.id = a.album_id";
	$q_result = mysql_query($q) or die(mysql_error());
 
  
$vcount = 0;
$count = 0;
$numofrows = @mysql_num_rows($q_result);
print("<div id='logomain'><div id='logotopmain'><div style='font-weight:bold;font-size:12px;color:#000;padding-top:14px;padding-left:4px'>Broken Links</div></div></div><table width='100%' cellspacing='6' id='submenu'><tr><td align='left'><a href='adminpanel.php?action=brokenlink'>Broken Links</a></td><td align='right'><a href='news.php'>Admin Home</a></td></tr></table><div id='description'>This section will allow you to remove download songs link which are broken and reported by users.</div>");
print("<div class='tableborder'><div class='maintitle'>Broken Links List</div>");
	if($numofrows == 0)
	{
		print("<br>No Records Found...");
	}

	while($row = mysql_fetch_array($q_result))
	{
		
	//	print("<tr><td class=tdrow5>".$row[0]."</td>");	
	
		$surl	=	$row[2];

		$filename = $row[1];								
		$str = strtolower(substr($filename,0,4));
		if( ($str == "http") || ($str == "www.") ) 
		{
			if($str == "www.")
			{
				$download_path = "http://".$filename ;
			}
			else
			{
				$download_path = $filename ;
			}
		}
		else
		{
			$download_path = SITE_NAME."/audio/".$filename ;
		}
		
	

	/*	$tmp_str1 = strpos($download_path,"/",7);		
		$spath = substr($download_path,0,$tmp_str1);$surl
		*/

		$tmp_str1 = strpos($surl,"/",7);		
		$spath = substr($surl,0,$tmp_str1);


		/**********************************************/
			
			$id = $row['id'];
											print("<form name='listing' action='javascript:func_move($vcount,$id);' method='post'>\n");
											print("<table style='width: 100%; border: 5px;'>\n");			
											print("<tr><td>Link Ok: <input type='checkbox' name='song_".$count."' value='".$row['id']."' style='width:15px' onclick = 'javascript:func_app1($vcount);' >&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Delete Song: <input type='checkbox' name='den_".$count."' value='".$row['id']."' style='width:15px' onclick = 'javascript:func_deny1($vcount);' checked>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Song: <input type= 'hidden' name = 'song_name' value = ".$row['song_name']."><a href='".$download_path."'>".$row['song_name']."</a></td></tr>\n");
											print("<tr><td><span style='font-weight:bold;'>Artist Name:</span> ".$row['name']."</td></tr>\n");
											print("<tr><td><span style='font-weight:bold;'>Album Name:</span> ".$row['album_name']."</td></tr>\n");
											print("<tr><td><span style='font-weight:bold'><b>Download URL Link: </b></span>\n");
											print("&nbsp;<span style='font-weight:bold'><a href='".$surl."'>"./*$spath*/$surl."</a></span> </td></tr>\n"); 			
											print("<tr><td></td></tr>\n");	
											print("<tr><td colspan='2'><input type='hidden' name='num' value=".$count."> <input type='submit' value='Submit'></td></tr>\n");
print("<input type = 'hidden' name = 'txtaction'  value = 'DENY'>");
											print("<tr><td></td></tr>\n");	
											print("<tr ><td><hr></td></tr>\n");	
											print("</table></form>\n"); 
											$count++;
											$vcount++;												
									
												
		/***********************************************/
	}
?>
<script language = 'javascript'>
						function func_app1(formno)
						{

							if(document.forms[formno].elements[0].checked)
							{
								document.forms[formno].elements[1].checked = false;
								document.forms[formno].txtaction.value = "APP";
							}
							
						}
													function func_deny1(formno)
													{											
																											
														if(document.forms[formno].elements[1].checked)
														{
															document.forms[formno].elements[0].checked = false;
															document.forms[formno].txtaction.value = "DENY";
														}
														
													}
													function func_move(formno,id)
													{														
														var str = document.forms[formno].txtaction.value
														document.forms[formno].action = "?action=brokenlink&flag="+str+"&id="+id;
														document.forms[formno].submit();

													}
												</script>
												<?
	print("</table></td></tr>");

	print("</table></form>");
	
	}

	


	/********** Album Functions **********/
	
	function album()
	{
		global $HTTP_POST_VARS,$HTTP_GET_VARS,$HTTP_SERVER_VARS,$HTTP_SESSION_VARS,$HTTP_COOKIE_VARS;

		$page = $HTTP_GET_VARS['page'];
		
		switch( $page ) {
		case 'del':
			$this->delalbum($HTTP_GET_VARS['id']);
			break;
		case 'edit':
			$this->infoalbum('edit');
			break;
		default:	// default new
			$this->infoalbum('new');
			break;		
		}
		
		$query = "SELECT al.id as id, al.album_name as Album_Name, ar.name as Artist_Name, al.album_release as Release_Date FROM album as al, artist as ar WHERE al.artist_id = ar.id ORDER BY al.album_name ASC";
		if( $result = mysql_query($query) ) { $this->mysqlTable($result,array('Delete'=>'page=del','Edit'=>'page=edit'),"?action=album&id=[id]&",false); }
	
	}
	

	function infoalbum($type)
	{
		global $HTTP_POST_VARS,$HTTP_GET_VARS,$HTTP_SERVER_VARS,$HTTP_SESSION_VARS,$HTTP_COOKIE_VARS;

		$id = addslashes($HTTP_GET_VARS['id']);
	    
		print("<div id='logomain'><div id='logotopmain'><div style='font-weight:bold;font-size:12px;color:#000;padding-top:14px;padding-left:4px'>Add a Album</div></div></div><table width='100%' cellspacing='6' id='submenu'><tr><td align='left'><a href='adminpanel.php?action=album'>Add New Album</a></td><td align='right'><a href='news.php'>Admin Home</a></td></tr></table><div id='description'>This section will allow you to add or edit an existing album. If you wish to edit or delete the albums, scroll down and edit or delete album by clicking on X link.</div>");
		print("<div id='info'>\n");
		
		// Save Information?
		if( $HTTP_GET_VARS['save'] == 'yes' ) {
			$album_name = $HTTP_POST_VARS['album_name'];
			$artist_id = addslashes($HTTP_POST_VARS['artist_id']);
			$genre_id = addslashes($HTTP_POST_VARS['genre_id']);
			$album_release = addslashes($HTTP_POST_VARS['date_year'])."-".addslashes($HTTP_POST_VARS['date_month'])."-15";
			$album_photo = ($HTTP_POST_VARS['album_photo'] ? (ereg('^http://', $HTTP_POST_VARS['album_photo']) ? '' : './covers/').addslashes($HTTP_POST_VARS['album_photo']) : './covers/notavailable.gif');
 
			$album_info = $HTTP_POST_VARS['album_info'];
			$album_price = addslashes($HTTP_POST_VARS['album_price']);
			$album_tax = addslashes($HTTP_POST_VARS['album_tax']);
		
			if( $type == 'new' ) {
				$query = "INSERT INTO album ( album_name , artist_id , genre_id , album_release , album_photo , album_info , price, tax, post_date ) ";
				$query .= "VALUES ('".$album_name."', '".$artist_id."', '".$genre_id."', '".$album_release."','".$album_photo."','".$album_info."','".$album_price."','".$album_tax."',  NOW())";
			} else {
				$query = "UPDATE album SET album_name = '".$album_name."', artist_id = '".$artist_id."', genre_id = '".$genre_id."', album_release = '".$album_release."', album_photo = '".$album_photo."', album_info = '".$album_info."',price='$album_price',tax='$album_tax',post_date=NOW() WHERE id = '".$id."'";
			}
			 
			// Run Query
			if( mysql_query($query) ) {
				print("<br><table width='500' border='0' cellspacing='0' cellpadding='0'   align='center'><tr><td><div align='left'><img src='../template/images/target_left.jpg' width='13' height='26' border=0></div></td><td width='500' class='target'><div align='center'><p><b><img src='../template/images/success.gif' width='16' height='16' alt='Success' border='0'>&nbsp; Success! We were able to ".(($type=='new')?"create a new":"edit the specified")." Album.</b></p></td><td><div align='right'><img src='../template/images/target_right.jpg' width='13' height='26' border=0></div></td></tr></table>");
			} else {
				print("<br><table width='500' border='0' cellspacing='0' cellpadding='0' align='center'><tr><td><div align='left'><img src='../template/images/targetred_left.jpg' width='13' height='26' border=0></div></td><td width='500' class='targetred'><div align='center'><p><b><img src='../template/images/fail.gif' width='16' height='16' alt='Success' border='0'>&nbsp; Warning: We were unable to ".(($type=='new')?"create a new":"edit the specified")." Album.</b></p></td><td><div align='right'><img src='../template/images/targetred_right.jpg' width='13' height='26' border=0></div></td>     </tr></table>");
			}
			
		}
		
		// Determine Type of Form
		if( $type == 'new' ) {
			print("<div class='tableborder'><div class='maintitle'>New Album</div>\n");
			$album_name = "";
			$artist_id = "";
			$genre_id = "";
			$date_month = "";
			$date_year = "2007";
			$album_photo = "";
			$album_info = ""; 
			$album_price="0.00";
			$album_tax="0.00";
		} else {
					
			print("<div class='tableborder'><div class='maintitle'>Edit Album</div>\n");
			
			$query = "SELECT * FROM album WHERE id = '".$id."'";
			$row = mysql_fetch_assoc( mysql_query($query) );
			
			$album_name = $row['album_name'];
			$artist_id = $row['artist_id'];
			$genre_id = $row['genre_id'];
			$date_month = date('m',strtotime($row['album_release']." CST"));
			$date_year = date('Y',strtotime($row['album_release']." CST"));
			$album_photo = $row['album_photo'];
			$album_info = $row['album_info'];
			
			$album_price=$row['price'];
			$album_tax=$row['tax'];
		}
		
		// Form 
		print("<form action='?action=album&page=".$type."&save=yes&id=".$id."' method='post' name='form' id='form'>\n");
		print("<table width='100%' cellspacing='0' cellpadding='5' align='center' border='0'><tr>\n"); 
		print(" <td class='tdrow1'  width='40%'  valign='middle'><label for='album_name'><b>Album Name</b></label></td>\n");
		print("<td class='tdrow2'  width='60%'  valign='middle'><input name='album_name' id='album_name' type='text' maxlength='255' value='".$album_name."'></td>\n");
		print("</tr>\n");
		print("<tr>\n");
		print(" <td class='tdrow1'  width='40%'  valign='middle'><label for='artist_id'><b>Artist Name</b></label></td>\n");
		print("<td class='tdrow2'  width='60%'  valign='middle'><select name='artist_id' id='artist_id'>\n");
		$query = "SELECT * FROM artist WHERE 1";
		$result = mysql_query($query);
		while( $row = mysql_fetch_assoc($result) ) {
			print("        <option value='".$row['id']."' ".(($row['id']==$artist_id)?'SELECTED':'').">".$row['name']."</option>\n");
		}
		print("</select></td>\n");
		print("</tr>\n");
		print("<tr>\n");
		print("<td class='tdrow1'  width='40%'  valign='middle'><label for='genre_id'><b>Genre</b></label></td>\n");
		print("<td class='tdrow2'  width='60%'  valign='middle'><select name='genre_id' id='genre_id'>\n");
		$query = "SELECT * FROM genre WHERE 1";
		$result = mysql_query($query);
		while( $row = mysql_fetch_assoc($result) ) {
			print("        <option value='".$row['id']."' ".(($row['id']==$genre_id)?'SELECTED':'').">".$row['genre']."</option>\n");
		}
		print("</select></td>\n");
		print("</tr>\n");
		print("<tr>\n");
		print("<td class='tdrow1'  width='40%'  valign='middle'><label><b>Release Date</b></label></td>\n");
		print("<td class='tdrow2'  width='60%'  valign='middle'><span id='date'>\n");
		print("<select name='date_month' class='month' id='date_month'>\n");
		print("<option value='01' ".(($date_month=='01')?'SELECTED':'').">January</option>\n");
		print("        <option value='02' ".(($date_month=='02')?'SELECTED':'').">February</option>\n");
		print("        <option value='03' ".(($date_month=='03')?'SELECTED':'').">March</option>\n");
		print("        <option value='04' ".(($date_month=='04')?'SELECTED':'').">April</option>\n");
		print("        <option value='05' ".(($date_month=='05')?'SELECTED':'').">May</option>\n");
		print("        <option value='06' ".(($date_month=='06')?'SELECTED':'').">June</option>\n");
		print("        <option value='07' ".(($date_month=='07')?'SELECTED':'').">July</option>\n");
		print("        <option value='08' ".(($date_month=='08')?'SELECTED':'').">August</option>\n");
		print("        <option value='09' ".(($date_month=='09')?'SELECTED':'').">September</option>\n");
		print("        <option value='10' ".(($date_month=='10')?'SELECTED':'').">October</option>\n");
		print("        <option value='11' ".(($date_month=='11')?'SELECTED':'').">November</option>\n");
		print("        <option value='12' ".(($date_month=='12')?'SELECTED':'').">December</option>\n");
		print("</select><br>\n"); 
		print("<input name='date_year' type='text' class='year' id='date_year' value='".$date_year."' maxlength='255'>\n");
		print("</span></td>\n");
		print("</tr>\n");
		print("<tr>\n");
		print("<td class='tdrow1' width='40%'  valign='middle'><label for='album_photo'><b>Photo URL</b></label></td>\n");
		print("<td class='tdrow2'  width='60%'  valign='middle'><input name='album_photo' id='album_photo' type='text' maxlength='255' value='".$album_photo."'></td>\n");
		print("</tr>\n");
		print("<tr>\n");
		print("<td class='tdrow1'  width='40%'  valign='middle'><label for='album_info'><b>Album Information</b></label></td>\n");
		print("<td class='tdrow2'  width='60%'  valign='middle'><textarea name='album_info' rows=5 cols=40 id='album_info'>".$album_info."</textarea></td>\n"); 
        	print("</tr>\n");
	    if(is_store_active())
		{
		 print("<tr>\n");
		 print("<td class='tdrow1'  width='40%'  valign='middle'><label for='album_Price'><b>Album Price</b></label></td>\n");
		 print("<td class='tdrow2'  width='60%'  valign='middle'><input name='album_price' id='album_price' type='text' maxlength='255' value='".$album_price."'></td>\n");
		 print("</tr>\n");
		 print("<tr>\n");
		 print("<td class='tdrow1'  width='40%'  valign='middle'><label for='album_tax'><b>Album Tax</b></label></td>\n");
		 print("<td class='tdrow2'  width='60%'  valign='middle'><input name='album_tax' id='album_tax' type='text' maxlength='255' value='".$album_tax."'></td>\n");
		 print("</tr>\n");
		}
		else //if(is_store_active())
		{
		 print("<input name='album_price' id='album_price' type='hidden' maxlength='255' value='".$album_price."'>");
		 print("<input name='album_tax' id='album_tax' type='hidden' maxlength='255' value='".$album_tax."'>");
		} //if(is_store_active()) 
		print("</tr></table>\n");
		print("<table width='100%'>\n"); 
		print("<td class='tdrow1' align=center valign='middle'><input name='Reset' type='reset' class='year' id='Reset' value='Reset'></td><td class='tdrow2' align=center valign='middle'><input name='Submit' type='submit' class='year' id='Submit' value='Submit'></td>\n");
		print("</tr>\n");
		print("</table>\n"); 
		print("</div>\n");
	}
	
	
	function delalbum($id)
	{
		global $HTTP_POST_VARS,$HTTP_GET_VARS,$HTTP_SERVER_VARS,$HTTP_SESSION_VARS,$HTTP_COOKIE_VARS;

		if( $HTTP_GET_VARS['page'] ) {
			$query = "DELETE FROM album WHERE id = '".$id."'";
			mysql_query($query);
			print("<div id='logomain'><div id='logotopmain'><div style='font-weight:bold;font-size:12px;color:#000;padding-top:14px;padding-left:4px'>Add a Album</div></div></div><table width='100%' cellspacing='6' id='submenu'><tr><td align='left'><a href='adminpanel.php?action=album'>Add New Album</a></td><td align='right'><a href='news.php'>Admin Home</a></td></tr></table>
	  <div id='description'>This section will allow you to add or edit an existing album. If you wish to edit or delete the albums, scroll down and edit or delete album by clicking on X link.</div>");
		print("<table width='500' border='0' cellspacing='0' cellpadding='0'   align='center'><tr><td><div align='left'><img src='../template/images/target_left.jpg' width='13' height='26' border=0></div></td><td width='500' class='target'><div align='center'><p><b>Album deleted successfully &nbsp; <img src='../template/images/success.gif' width='16' height='16' alt='Success' border='0'></b></p></td><td><div align='right'><img src='../template/images/target_right.jpg' width='13' height='26' border=0></div></td></tr></table>");								
		} else {
			$query = "SELECT * FROM album WHERE id = '".$id."'";
			$row = mysql_fetch_assoc( mysql_query($query) );
			
			$album = $row['album_name'];
		
			// Form
			print("<form action='?action=album&page=del&save=yes&id=".$id."' method='post' name='form' id='form'>\n");
			print("<p>Are you sure that you would like to delete the Album <b>\"".$album."\"</b>?");
			print("<input type='hidden' name='album' value='".$album."'></p>\n");
			print("<p><input name='Submit' type='submit' class='year' id='Submit' value='Confirm Delete'>\n");
			print("</p></form>\n");
			
		}
	}
	
	
	/********** Artist Functions **********/
	
	function artist()
	{
		global $HTTP_POST_VARS,$HTTP_GET_VARS,$HTTP_SERVER_VARS,$HTTP_SESSION_VARS,$HTTP_COOKIE_VARS;

		$page = $HTTP_GET_VARS['page'];
		
		switch($HTTP_GET_VARS[page]) {
		case 'del':
			$this->delArtist($HTTP_GET_VARS['id']);
			break;
		case 'edit':
			$this->infoArtist('edit');
			break;
		default:	// default new
			$this->infoArtist('new');
			break;		
		}
		
		$query = "SELECT id, name as Artist_Name, url as Website FROM artist ORDER BY name ASC";
		if( $result = mysql_query($query) ) { $this->mysqlTable($result,array('Delete'=>'page=del','Edit'=>'page=edit'),"?action=artist&id=[id]&",false); }
		
	}
	
	function infoArtist($type)
	{
	
		global $HTTP_POST_VARS,$HTTP_GET_VARS,$HTTP_SERVER_VARS,$HTTP_SESSION_VARS,$HTTP_COOKIE_VARS;

		$id = addslashes($HTTP_GET_VARS['id']);
	      print("<div id='logomain'><div id='logotopmain'><div style='font-weight:bold;font-size:12px;color:#000;padding-top:14px;padding-left:4px'>Add Artist</div></div></div><table width='100%' cellspacing='6' id='submenu'><tr><td align='left'><a href='adminpanel.php?action=artist'>Add New Artist</a></td><td align='right'><a href='news.php'>Admin Home</a></td></tr></table><div id='description'>This section will allow you to add or edit an existing artist. If you wish to edit or delete the artists, scroll down and edit or delete artist by clicking on X link.</div>");
		print("<div id='info'>\n");
		
		// Save Information?
		if( $HTTP_GET_VARS['save'] == 'yes' ) {
			$artist_name = addslashes($HTTP_POST_VARS['artist_name']);
			$url = addslashes($HTTP_POST_VARS['url']);
			$photo_url = ($HTTP_POST_VARS['artist_photo'] ? (ereg('^http://', $HTTP_POST_VARS['artist_photo']) ? '' : './covers/').addslashes($HTTP_POST_VARS['artist_photo']) : './covers/notavailable.gif');

			$artist_info = $HTTP_POST_VARS['artist_info'];
		
			if( $type == 'new' ) {
				$query = "INSERT INTO artist ( name , url , artist_photo , artist_info ) ";
				$query .= "VALUES ('".$artist_name."', '".$url."', '".$photo_url."', '".$artist_info."')";
			} else {
				$query = "UPDATE artist SET name = '".$artist_name."', url = '".$url."', artist_photo = '".$photo_url."', artist_info = '".$artist_info."' WHERE id = '".$id."'";			
			}
			
			// Run Query
			if( mysql_query($query) ) {
			    
				print("<table width='500' border='0' cellspacing='0' cellpadding='0'   align='center'><tr><td><div align='left'><img src='../template/images/target_left.jpg' width='13' height='26' border=0></div></td><td width='500' class='target'><div align='center'><p><b>Success! We were able to ".(($type=='new')?"create a new":"edit the specified")." Artist &nbsp; <img src='../template/images/success.gif' width='16' height='16' alt='Success' border='0'></b></p></td><td><div align='right'><img src='../template/images/target_right.jpg' width='13' height='26' border=0></div></td></tr></table>");
			} else { 
				print("<br><table width='500' border='0' cellspacing='0' cellpadding='0' align='center'><tr><td><div align='left'><img src='../template/images/targetred_left.jpg' width='13' height='26' border=0></div></td><td width='500' class='targetred'><div align='center'><p><b><img src='../template/images/fail.gif' width='16' height='16' alt='Success' border='0'>&nbsp;Warning: We were unable to ".(($type=='new')?"create a new":"edit the specified")." Artist &nbsp; <img src='../template/images/fail.gif' width='16' height='16' alt='Fail' border='0'></b></p></td><td><div align='right'><img src='../template/images/targetred_right.jpg' width='13' height='26' border=0></div></td>     </tr></table>");
			}
			
		}
		
		// Determine Type of Form
		if( $type == 'new' ) {
			print("<div class='tableborder'><div class='maintitle'>New Artist</div>\n");
			$artist_name = "";
			$url = "http://";
			$photo_url = "";
			$artist_info = "";
		} else {
					
			print("<div class='tableborder'><div class='maintitle'>Edit Artist</div>\n");
			
			$query = "SELECT * FROM artist WHERE id = '".$id."'";
			$row = mysql_fetch_assoc( mysql_query($query) );
			
			$artist_name = $row['name'];
			$url = $row['url'];
			$photo_url = $row['artist_photo'];
			$artist_info = $row['artist_info'];			
		}
		
		// Form
		print("<form action='?action=artist&page=".$type."&save=yes&id=".$id."' method='post' name='form' id='form'>\n");
		print("<table width='100%' cellspacing='0' cellpadding='5' align='center' border='0'><tr>\n");
		print("<tr>\n");
		print("<td class='tdrow1'  width='40%'  valign='middle'><label for='artist_name'><b>Artist Name</b></label></td>\n");
		print("<td class='tdrow2'  width='60%'  valign='middle'><input name='artist_name' id='artist_name' type='text' maxlength='255' value='".$artist_name."'></td>\n");
		print("</tr>\n");
		print("<tr>\n");
		print("<td class='tdrow1'  width='40%'  valign='middle'><label for='url'><b>Website</b></label></td>\n");
		print("<td class='tdrow2'  width='60%'  valign='middle'><input name='url' id='url' type='text' maxlength='255' value='".$url."'></td>\n");
		print("</tr>\n");
		print("<tr>\n");
		print("<td class='tdrow1'  width='40%'  valign='middle'><label for='artist_photo'><b>Photo URL</b></label></td>\n");
		print("<td class='tdrow2'  width='60%'  valign='middle'><input name='artist_photo' id='artist_photo' type='text' maxlength='255' value='".$photo_url."'></td>\n");
		print("</tr>\n");
		print("<tr>\n");
		print("<td class='tdrow1'  width='40%'  valign='middle'><label for='artist_info'><b>Artist Biography</b></label></td>\n");
		print("<td class='tdrow2'  width='60%'  valign='middle'><textarea name='artist_info' id='artist_info'>".$artist_info."</textarea></td>\n"); 
		print("</tr></table>\n");
		print("<table width='100%'>\n"); 
		print("<td class='tdrow1' align=center valign='middle'><input name='Reset' type='reset' class='year' id='Reset' value='Reset'></td>\n");
		print("<td class='tdrow2' align=center valign='middle'><input name='Submit' type='submit' class='year' id='Submit' value='Submit'>\n");
		print("</td>\n");
		print("</tr>\n");
		print("</table>\n");
		print("</form>\n");
		print("</div><br>\n");
	}
	
	
	function delArtist($id)
	{
		$query = "DELETE from artist where id='".$id."'";
		 print("<div id='logomain'><div id='logotopmain'><div style='font-weight:bold;font-size:12px;color:#000;padding-top:14px;padding-left:4px'>Add Artist</div></div></div><table width='100%' cellspacing='6' id='submenu'><tr><td align='left'><a href='adminpanel.php?action=artist'>Add New Artist</a></td><td align='right'><a href='news.php'>Admin Home</a></td></tr></table><div id='description'>This section will allow you to add or edit an existing artist. If you wish to edit or delete the artists, scroll down and edit or delete artist by clicking on X link.</div><table width='500' border='0' cellspacing='0' cellpadding='0'   align='center'><tr><td><div align='left'><img src='../template/images/target_left.jpg' width='13' height='26' border=0></div></td><td width='500' class='target'><div align='center'><p><b>Success! We were able to delete the Artist&nbsp; <img src='../template/images/success.gif' width='16' height='16' alt='Success' border='0'></b></p></td><td><div align='right'><img src='../template/images/target_right.jpg' width='13' height='26' border=0></div></td></tr></table>");
		$result = mysql_query($query);
	}
	
	/********** Format Functions **********/
	
	function format()
	{

		global $HTTP_POST_VARS,$HTTP_GET_VARS,$HTTP_SERVER_VARS,$HTTP_SESSION_VARS,$HTTP_COOKIE_VARS;

		$page = $HTTP_GET_VARS['page'];
	
		switch( $page ) {
		case 'del':
			$this->delFormat(addslashes($HTTP_GET_VARS['id']));
			break;
		case 'edit':
			$this->infoFormat('edit');
			break;
		default:	// default new		
			$this->infoFormat('new');			
			break;		
		}
		
		$query = "SELECT id, format as Format_Type, extension as Extension, format_url as Website FROM format WHERE 1";
		if( $result = mysql_query($query) ) { $this->mysqlTable($result,array('Delete'=>'page=del','Edit'=>'page=edit'),"?action=format&id=[id]&",false); }
				
	}
	
	
	function infoFormat($type)
	{

		global $HTTP_POST_VARS,$HTTP_GET_VARS,$HTTP_SERVER_VARS,$HTTP_SESSION_VARS,$HTTP_COOKIE_VARS;

		$id = addslashes($HTTP_GET_VARS['id']);
	    print("<div id='logomain'><div id='logotopmain'><div style='font-weight:bold;font-size:12px;color:#000;padding-top:14px;padding-left:4px'>Add Format</div></div></div><table width='100%' cellspacing='6' id='submenu'><tr><td align='left'><a href='adminpanel.php?action=format'>Add New Format</a></td><td align='right'><a href='news.php'>Admin Home</a></td></tr></table><div id='description'>This section will allow you to add or edit an existing format. If you wish to edit or delete the formats, scroll down and edit or delete format by clicking on X link.</div>");
		print("<div id='info'>\n");
		
		// Save Information?
		if( $HTTP_GET_VARS['save'] == 'yes' ) {
			$format = addslashes($HTTP_POST_VARS['format_name']);
			$extension = addslashes($HTTP_POST_VARS['format_ext']);
			$url = addslashes($HTTP_POST_VARS['format_url']);
		
			if( $type == 'new' ) {
				$query = "INSERT INTO format ( format , extension, format_url ) VALUES ('".$format."', '".$extension."', '".$url."')";
			} else {
				$query = "UPDATE format SET format = '".$format."', extension = '".$extension."', format_url = '".$url."' WHERE id = '".$id."'";			
			}
			
			// Run Query
			if( mysql_query($query) ) {
				print("<table width='500' border='0' cellspacing='0' cellpadding='0'   align='center'><tr><td><div align='left'><img src='../template/images/target_left.jpg' width='13' height='26' border=0></div></td><td width='500' class='target'><div align='center'><p><b>Success! We were able to ".(($type=='new')?"create a new":"edit the specified")." format &nbsp; <img src='../template/images/success.gif' width='16' height='16' alt='Success' border='0'></b></p></td><td><div align='right'><img src='../template/images/target_right.jpg' width='13' height='26' border=0></div></td></tr></table>");
			} else { 	 
				print("<br><table width='500' border='0' cellspacing='0' cellpadding='0' align='center'><tr><td><div align='left'><img src='../template/images/targetred_left.jpg' width='13' height='26' border=0></div></td><td width='500' class='targetred'><div align='center'><p><b><img src='../template/images/fail.gif' width='16' height='16' alt='Success' border='0'>&nbsp;Warning: We were unable to ".(($type=='new')?"create a new":"edit the specified")." format &nbsp; <img src='../template/images/fail.gif' width='16' height='16' alt='Fail' border='0'></b></p></td><td><div align='right'><img src='../template/images/targetred_right.jpg' width='13' height='26' border=0></div></td>     </tr></table>");
			}

			
		}
		
		// Determine Type of Form
		if( $type == 'new' ) {
			print("<div class='tableborder'><div class='maintitle'>New Format</div>\n");
			$format = "";
			$format_url = "http://";
			$format_ext = "";
		} else {
					
			print("<div class='tableborder'><div class='maintitle'>Edit Format</div>\n");
			
			$query = "SELECT * FROM format WHERE id = '".$id."'";
			$row = mysql_fetch_assoc( mysql_query($query) );
			
			$format = $row['format'];
			$format_url = $row['format_url'];
			$format_ext = $row['extension'];
			
		}
		
		// Form
		print("<form action='?action=format&page=".$type."&save=yes&id=".$id."' method='post' name='form' id='form'>\n");
		print("<table width='100%' cellspacing='0' cellpadding='5' align='center' border='0'><tr>\n"); 
		print("<td class='tdrow1'  width='40%'  valign='middle'><label for='format_name'><b>Format Name</b><br>example : Real Player</label></td>\n");
		print("<td class='tdrow2'  width='60%'  valign='middle'><input name='format_name' id='format_name' type='text' maxlength='255' value='".$format."'></td>\n");
		print("</tr>\n");
		print("<tr>\n");
		print("<td class='tdrow1'  width='40%'  valign='middle'><label for='format_url'><b>Format Extension</b><br>example : Mp3</label></td>\n");
		print("<td class='tdrow2'  width='60%'  valign='middle'><input name='format_ext' id='format_ext' type='text' maxlength='255' value='".$format_ext."'></td>\n");
		print("</tr>\n");
		print("<tr>\n");
		print("<td class='tdrow1'  width='40%'  valign='middle'><label for='format_url'><b>Format URL</b><br>example : http://www.real.com</label></td>\n");
		print("<td class='tdrow2'  width='60%'  valign='middle'><input name='format_url' id='format_url' type='text' maxlength='255' value='".$format_url."'></td>\n");
		print("</tr></table>\n");
		print("<table width='100%' >\n"); 
		print("<td class='tdrow1' align=center valign='middle'><input name='Reset' type='reset' class='year' id='Reset' value='Reset'></td>\n");
		print("<td class='tdrow2' align=center valign='middle'><input name='Submit' type='submit' class='year' id='Submit' value='Submit'></td>\n"); 
		print("</tr>\n");
		print("</table>\n");
		print("</form>\n"); 
		print("</div><br>\n");
	}
	
	
	function delFormat($id)
	{
		global $HTTP_POST_VARS,$HTTP_GET_VARS,$HTTP_SERVER_VARS,$HTTP_SESSION_VARS,$HTTP_COOKIE_VARS;

		if( $HTTP_GET_VARS['save'] ) {
			$query = "DELETE FROM format WHERE id = '".$id."'";
			mysql_query($query);
			 print("<div id='logomain'><div id='logotopmain'><div style='font-weight:bold;font-size:12px;color:#000;padding-top:14px;padding-left:4px'>Add Format</div></div></div><table width='100%' cellspacing='6' id='submenu'><tr><td align='left'><a href='adminpanel.php?action=format'>Add New Format</a></td><td align='right'><a href='news.php'>Admin Home</a></td></tr></table><div id='description'>This section will allow you to add or edit an existing format. If you wish to edit or delete the formats, scroll down and edit or delete format by clicking on X link.</div>");
			print("<table width='100%' bgcolor='#ff9dbb'><tr><td align=center>Format <b>\"".$HTTP_POST_VARS['format']."\"</b> deleted succesfully.</td></tr></table>");								
		} else {
			$query = "SELECT * FROM format WHERE id = '".$id."'";
			$row = mysql_fetch_assoc( mysql_query($query) );
			
			$format = $row['format'];
		
			// Form
			print("<div id='logomain'><div id='logotopmain'><div style='font-weight:bold;font-size:12px;color:#000;padding-top:14px;padding-left:4px'>Add Format</div></div></div><table width='100%' cellspacing='6' id='submenu'><tr><td align='left'><a href='adminpanel.php?action=format'>Add New Format</a></td><td align='right'><a href='news.php'>Admin Home</a></td></tr></table><div id='description'>This section will allow you to add or edit an existing format. If you wish to edit or delete the formats, scroll down and edit or delete format by clicking on X link.</div>");
			print("<form action='?action=format&page=del&save=yes&id=".$id."' method='post' name='form' id='form'>\n");
			print("<table width='100%' bgcolor='#ff9dbb'><tr><td align=center>Are you sure that want to delete format <b>\"".$format."\"</b>?</td></tr></table>");
			print("<input type='hidden' name='format' value='".$format."'></p>\n");
			print("<center><p><input name='Submit' type='submit' class='year' id='Submit' value='Confirm Delete'></center>\n");
			print("</p></form>\n");
		}
	}
	
	
	/********** Playlist Functions ***********/
	function playlist()
	{
			
		$query = "SELECT playlist.id as id, playlist.playlist_name, playlist.user_id FROM playlist, playlistsong WHERE playlist.id = playlistsong.playlist_id GROUP BY playlistsong.playlist_id ORDER BY playlist.playlist_name ASC";
		if( $result = mysql_query($query) ) { $this->mysqlTable($result,array('View'=>'&'),"index.php?action=viewplaylist&id=[id]",false); }
		if( mysql_num_rows($result) == 0 ) { print("No playlists found"); }
	
	}
	
	/********** Mail a Friend Functions ***********/
	function mailfriend()
	{
		global $HTTP_POST_VARS,$HTTP_GET_VARS,$HTTP_SERVER_VARS,$HTTP_SESSION_VARS,$HTTP_COOKIE_VARS;
			
		$start = $HTTP_GET_VARS['start'];
		if( $start == '' ) { $start = 0; }
		$query = "SELECT user_id, sent_to, subject, message FROM mailfriend ORDER BY id DESC LIMIT ".$start.",30";
		$result = mysql_query($query);
		
		$i=0;
		for( $i=0 ; $row = mysql_fetch_assoc($result) ; $i++)
		{
			print("<p>User ID: ".$row['user_id']."<br>\n");
			print("Sent to: ".$row['sent_to']."<br>\n");
			print("Subject: ".$row['subject']."<br>\n");
			print($row['message']."</p>\n");
			print("<hr>");
		}
		print("<p>\n");
		if( $start != 0 ) {
			print("<a href='admin.php?action=mailfriend&start=".($start-30)."'>Previous Page</a>  || ");
		}
		if( $i > 25 ) {
			print("<a href='admin.php?action=mailfriend&start=".($start+30)."'>Next Page</a>");
		}
		print("</p>\n");
	
	}
	
	
	/********** Genre Functions **********/
	
	function genre()
	{
		global $HTTP_POST_VARS,$HTTP_GET_VARS,$HTTP_SERVER_VARS,$HTTP_SESSION_VARS,$HTTP_COOKIE_VARS;

		$page = $HTTP_GET_VARS['page'];
		
		switch( $page ) {
		case 'del':
			$this->delGenre(addslashes($HTTP_GET_VARS['id']));
			break;
		case 'edit':
			$this->infoGenre('edit');
			break;
		default:	// default new
			$this->infoGenre('new');
			break;		
		}
		
		$query = "SELECT id, genre as Genre_Name FROM genre WHERE 1";
		if( $result = mysql_query($query) ) { $this->mysqlTable($result,array('Delete'=>'page=del','Edit'=>'page=edit'),"?action=genre&id=[id]&",false); }
		
	
	}
	
	function infoGenre($type)
	{
		global $HTTP_POST_VARS,$HTTP_GET_VARS,$HTTP_SERVER_VARS,$HTTP_SESSION_VARS,$HTTP_COOKIE_VARS;

		$id = addslashes($HTTP_GET_VARS['id']);
	     print("<div id='logomain'><div id='logotopmain'><div style='font-weight:bold;font-size:12px;color:#000;padding-top:14px;padding-left:4px'>Add Genre</div></div></div><table width='100%' cellspacing='6' id='submenu'><tr><td align='left'><a href='adminpanel.php?action=genre'>Add New Genre</a></td><td align='right'><a href='news.php'>Admin Home</a></td></tr></table><div id='description'>This section will allow you to add or edit an existing genre. If you wish to edit or delete the genres, scroll down and edit or delete genre by clicking on X link.</div>");
		print("<div id='info'>\n");
		
		// Save Information?
		if( $HTTP_GET_VARS['save'] == 'yes' ) {
			$genre = addslashes($HTTP_POST_VARS['genre']);
		
			if( $type == 'new' ) {
				$query = "INSERT INTO genre ( genre ) VALUES ('".$genre."')";
			} else {
				$query = "UPDATE genre SET genre = '".$genre."' WHERE id = '".$id."'";			
			}
			
			// Run Query
			if( mysql_query($query) ) { 
				print("<table width='500' border='0' cellspacing='0' cellpadding='0'   align='center'><tr><td><div align='left'><img src='../template/images/target_left.jpg' width='13' height='26' border=0></div></td><td width='500' class='target'><div align='center'><p><b>Success! We were able to ".(($type=='new')?"create a new":"edit the specified")." Genre &nbsp; <img src='../template/images/success.gif' width='16' height='16' alt='Success' border='0'></b></p></td><td><div align='right'><img src='../template/images/target_right.jpg' width='13' height='26' border=0></div></td></tr></table>");
			} else { 
				print("<br><table width='500' border='0' cellspacing='0' cellpadding='0' align='center'><tr><td><div align='left'><img src='../template/images/targetred_left.jpg' width='13' height='26' border=0></div></td><td width='500' class='targetred'><div align='center'><p><b><img src='../template/images/fail.gif' width='16' height='16' alt='Success' border='0'>&nbsp;Warning: We were unable to ".(($type=='new')?"create a new":"edit the specified")." Genre.</b></p></td><td><div align='right'><img src='../template/images/targetred_right.jpg' width='13' height='26' border=0></div></td>     </tr></table>");
			}
			
		}
		
		// Determine Type of Form
		if( $type == 'new' ) {
			print("<div class='tableborder'><div class='maintitle'>New Genre</div>\n");
			$genre = "";
		} else {
		
			print("<div class='tableborder'><div class='maintitle'>Edit Genre</div>\n");
			$query = "SELECT * FROM genre WHERE id = '".$id."'";
			$row = mysql_fetch_assoc( mysql_query($query) );
			
			$genre = $row['genre'];
			
		}
		
		// Form
		print("<form action='?action=genre&page=".$type."&save=yes&id=".$id."' method='post' name='form' id='form'>\n");
		print("<table width='100%' cellspacing='0' cellpadding='5' align='center' border='0'><tr>\n"); 
		print("<tr>\n");
		print("<td class='tdrow1'  width='40%'  valign='middle'><label for='genre'><b>Genre Name</b></label></td>\n");
		print("<td class='tdrow2'  width='60%'  valign='middle'><input name='genre' id='genre' type='text' maxlength='255' value='".$genre."'></td>\n");
		print("</tr></table>\n");
		print("<table width='100%'>\n"); 
		print("<td class='tdrow1' align=center valign='middle'><input name='Reset' type='reset' class='year' id='Reset' value='Reset'></td>\n");
		print("<td class='tdrow2' align=center valign='middle'><input name='Submit' type='submit' class='year' id='Submit' value='Submit'>\n");
		print("</td>\n");
		print("</tr>\n");
		print("</table>\n");
		print("</form>\n"); 
		print("</div>\n");
	}
	
	
	function delGenre($id)
	{
		global $HTTP_POST_VARS,$HTTP_GET_VARS,$HTTP_SERVER_VARS,$HTTP_SESSION_VARS,$HTTP_COOKIE_VARS;

		if( $HTTP_GET_VARS['save'] ) {
			$query = "DELETE FROM genre WHERE id = '".$id."'";
			mysql_query($query); 
				print("<table width='500' border='0' cellspacing='0' cellpadding='0'   align='center'><tr><td><div align='left'><img src='../template/images/target_left.jpg' width='13' height='26' border=0></div></td><td width='500' class='target'><div align='center'><p><b>Genre \"".$HTTP_POST_VARS['genre']."\" deleted succesfully.&nbsp; <img src='../template/images/success.gif' width='16' height='16' alt='Success' border='0'></b></p></td><td><div align='right'><img src='../template/images/target_right.jpg' width='13' height='26' border=0></div></td></tr></table>");							
		} else {
			$query = "SELECT * FROM genre WHERE id = '".$id."'";
			$row = mysql_fetch_assoc( mysql_query($query) );
			
			$genre = $row['genre'];
		
			// Form
			 print("<div id='logomain'><div id='logotopmain'><div style='font-weight:bold;font-size:12px;color:#000;padding-top:14px;padding-left:4px'>Add Genre</div></div></div><table width='100%' cellspacing='6' id='submenu'><tr><td align='left'><a href='adminpanel.php?action=genre'>Add New Genre</a></td><td align='right'><a href='news.php'>Admin Home</a></td></tr></table><div id='description'>This section will allow you to add or edit an existing genre. If you wish to edit or delete the genres, scroll down and edit or delete genre by clicking on X link.</div>");
			print("<form action='?action=genre&page=del&save=yes&id=".$id."' method='post' name='form' id='form'>\n"); 
			print("<br><table width='500' border='0' cellspacing='0' cellpadding='0' align='center'><tr><td><div align='left'><img src='../template/images/targetred_left.jpg' width='13' height='26' border=0></div></td><td width='500' class='targetred'><div align='center'><p><b><img src='../template/images/fail.gif' width='16' height='16' alt='Success' border='0'>&nbsp;Are you sure that you would like to delete the genre <b>\"".$genre."\"</b>?</b></p></td><td><div align='right'><img src='../template/images/targetred_right.jpg' width='13' height='26' border=0></div></td>     </tr></table>");
			print("<table width=100% align=center><tr><td align=center><input type='hidden' name='genre' value='".$genre."'></p>\n");
			print("<p><input name='Submit' type='submit' class='year' id='Submit' value='Confirm Delete'>\n");
			print("</p></form></td></tr></table>\n");
		}
	}
	
	/********** Song Functions **********/
	
	function song()
	{
		global $HTTP_POST_VARS,$HTTP_GET_VARS,$HTTP_SERVER_VARS,$HTTP_SESSION_VARS,$HTTP_COOKIE_VARS;

		$page = $HTTP_GET_VARS['page'];
		
		switch( $page ) {
		case 'del':
			$this->delSong(addslashes($HTTP_GET_VARS['id']));
			break;
		case 'edit':
			$this->infoSong('edit');
			break;
		default:	// default new
			$this->infoSong('new');
			break;		
		}
		   
		print("<div class='tableborder'><div class='maintitle'>List of All Songs</div>");
		
		$query = "SELECT song.id as id, song.song_name as Song_Name, ar.name as Artist_Name, al.album_name as album_Name FROM album as al, artist as ar, song WHERE song.artist_id = ar.id AND song.album_id = al.id ORDER BY ar.name ASC, al.album_name ASC, song.song_name ASC";
		if( $result = mysql_query($query) ) { $this->mysqlTable($result,array('Delete'=>'page=del','Edit'=>'page=edit'),"?action=song&id=[id]&",false); }
	
	}
	
	function infoSong($type)
	{
		global $HTTP_POST_VARS,$HTTP_GET_VARS,$HTTP_SERVER_VARS,$HTTP_SESSION_VARS,$HTTP_COOKIE_VARS;

		$id = addslashes($HTTP_GET_VARS['id']);
	
	      print("<div id='logomain'><div id='logotopmain'><div style='font-weight:bold;font-size:12px;color:#000;padding-top:14px;padding-left:4px'>Add Songs</div></div></div><table width='100%' cellspacing='6' id='submenu'><tr><td align='left'><a href='adminpanel.php?action=songdir&org=1'>Add Multiple Songs at once</a></td><td align='right'><a href='news.php'>Admin Home</a></td></tr></table><div id='description'>This section will allow you to add or edit an existing song. If you wish to edit or delete the songs, scroll down and edit or delete song by clicking on X link.</div>");
		print("<div id='info'>\n");
		
		// Save Information?
		if( $HTTP_GET_VARS['save'] == 'yes' ) {
		
			if( $type == 'new' ) {
				
				if($HTTP_GET_VARS["mod"] == 1)
				{
					if($HTTP_POST_VARS["txtchk"] == 1)
					{

						$query = "INSERT INTO song ( song_name, artist_id, album_id, format_id, song_path ,url,price,tax) VALUES ";
						$query .= "('".addslashes($HTTP_POST_VARS['song_name'])."','".$HTTP_POST_VARS['artist_id']."','".$HTTP_POST_VARS['album_id']."','".$HTTP_POST_VARS['format_id']."','".addslashes($HTTP_POST_VARS['song_path'])."','".$HTTP_POST_VARS["downloadurl"]."','".$HTTP_POST_VARS["price"]."','".$HTTP_POST_VARS["tax"]."')";
					}
					else
					{
						$query = "INSERT INTO song ( song_name, artist_id, album_id, format_id, song_path,price,tax ) VALUES ";
						$query .= "('".addslashes($HTTP_POST_VARS['song_name'])."','".$HTTP_POST_VARS['artist_id']."','".$HTTP_POST_VARS['album_id']."','".$HTTP_POST_VARS['format_id']."','".addslashes($HTTP_POST_VARS['song_path'])."','".$HTTP_POST_VARS["price"]."','".$HTTP_POST_VARS["tax"]."')";
					}
				}
				else
				{
					$query = "INSERT INTO song ( song_name, artist_id, album_id, format_id, song_path ,url,price,tax) VALUES ";
					$query .= "('".addslashes($HTTP_POST_VARS['song_name'])."','".$HTTP_POST_VARS['artist_id']."','".$HTTP_POST_VARS['album_id']."','".$HTTP_POST_VARS['format_id']."','".addslashes($HTTP_POST_VARS['song_path'])."','".$HTTP_POST_VARS["downloadurl"]."','".$HTTP_POST_VARS["price"]."','".$HTTP_POST_VARS["tax"]."')";
					
					$cp = copy($_FILES['song_path']['tmp_name'],"../audio/".addslashes($_FILES['song_path']['name']));
					/*
					print_r($cp);
					
					if($cp) print "DONE:"; else print "NOT DONE";
					
					exit;
					*/
				}
 
			} else {
				$query = "UPDATE song SET song_name = '".addslashes($HTTP_POST_VARS['song_name'])."', artist_id = '".$HTTP_POST_VARS['artist_id']."', album_id='".$HTTP_POST_VARS['album_id']."', format_id='".$HTTP_POST_VARS['format_id']."', song_path='".addslashes($HTTP_POST_VARS['song_path'])."', url = '".$HTTP_POST_VARS["downloadurl"]."',price='".$HTTP_POST_VARS["price"]."',tax='".$HTTP_POST_VARS["tax"]."'  WHERE id = '".$id."'";			
			}
			
			// Run Query
			if( mysql_query($query) ) {
				print("<br><table width='500' border='0' cellspacing='0' cellpadding='0'   align='center'><tr><td><div align='left'><img src='../template/images/target_left.jpg' width='13' height='26' border=0></div></td><td width='500' class='target'><div align='center'><p><b><img src='../template/images/success.gif' width='16' height='16' alt='Success' border='0'>&nbsp;Success! We were able to ".(($type=='new')?"add a new":"edit the specified")." Song</b></p></td><td><div align='right'><img src='../template/images/target_right.jpg' width='13' height='26' border=0></div></td></tr></table>");
			} else {
				print("<br><table width='500' border='0' cellspacing='0' cellpadding='0' align='center'><tr><td><div align='left'><img src='../template/images/targetred_left.jpg' width='13' height='26' border=0></div></td><td width='500' class='targetred'><div align='center'><p><b><img src='../template/images/fail.gif' width='16' height='16' alt='Success' border='0'>&nbsp; Warning: We were unable to ".(($type=='new')?"create a new":"edit the specified")." Song</b></p></td><td><div align='right'><img src='../template/images/targetred_right.jpg' width='13' height='26' border=0></div></td>     </tr></table>");
			}
			
		}
		
		// Determine Type of Form
		if( $type == 'new' ) {
			print("<div class='tableborder'><div class='maintitle'>Add New Song Manually</div>\n");
			$song_name = "";
			$artist_id = "";
			$album_id = "";
			$length_min = 0;
			$length_sec = 0;
			$format_id = "";
			//$song_path = $this->musicpath;
			$song_path = "";
			$price="0.00";
			$tax="0.00";
		} else {
		
			print("<div class='tableborder'><div class='maintitle'>Edit Song</div>\n");
			$query = "SELECT * FROM song WHERE id = '".$id."'";
			$row = mysql_fetch_assoc( mysql_query($query) );
			
			$song_name = $row['song_name'];
			$artist_id = $row['artist_id'];
			$album_id = $row['album_id'];
			$length_min = floor($row['length']/60);
			$length_sec = $row['length']%60;
			$format_id = $row['format_id'];
			$song_path = $row['song_path'];
			$downloadurl = $row['url'];
			$price = $row['price'];
			$tax= $row['tax'];
			
		}
		
		// Form
		?>
		<script>
		/*window.onerror = "onerr()";
		function onerr()
		{
		alert('err');
		}
		*/
		function validate()
		{
		var y = document.getElementById("song_path").value;
		var imglen = y.length;
		var imgdotpos = y.lastIndexOf(".");
		var imgext = y.substring(imgdotpos+1,imglen);
		//alert(imgext);
		
		if ( <?php $query = "SELECT * FROM format ORDER BY format ASC";
		$result = mysql_query($query);
		$res = Array();
		while( $row = mysql_fetch_assoc($result) ) 
		{
			$res[] = "imgext == '".$row["extension"]."'";
		}
		echo (implode('||',$res ));?>)
		{
		return true;
		}
		else 
		alert("You can upload only audio/video files types");
		return false;
		}
		</script>
		<?php
		print("<form action='?action=song&page=".$type."&save=yes&id=".$id."' method='post' name='form' id='form' enctype = 'multipart/form-data' onsubmit = 'return validate();'>\n");
		//print("<form  method='post' name='form1' id='form1' enctype = 'multipart/form-data'>\n");
		print("<table width='100%' cellspacing='0' cellpadding='5' align='center' border='0'><tr>\n"); 
		print("<td class='tdrow1'  width='40%'  valign='middle'><b>Song Name</b></td>\n");
		print("<td class='tdrow2'  width='60%'  valign='middle'><input name='song_name' type='text' id='song_name' maxlength='255' value='".$song_name."'></td>\n");
		print("</tr>\n");
		print("<tr>\n");
		print("<td class='tdrow1'  width='40%'  valign='middle'><b>Artist Name</b></td>\n");
		print("<td class='tdrow2'  width='60%'  valign='middle'><select name='artist_id' id='artist_id'>\n");
		$query = "SELECT * FROM artist ORDER BY name ASC";
		$result = mysql_query($query);
		while( $row = mysql_fetch_assoc($result) ) {
			print("<option value='".$row['id']."' ".(($row['id']==$artist_id)?'SELECTED':'').">".$row['name']."</option>\n");
		}
		print("</select></td>\n");
		print("</tr>\n");
		print("<tr>\n");
		print("<td class='tdrow1'  width='40%'  valign='middle'><b>Album Name</b></td>\n");
		print("<td class='tdrow2'  width='60%'  valign='middle'><select name='album_id' id='album_id'>\n");		
		$query = "SELECT * FROM album ORDER BY album_name ASC";
		$result = mysql_query($query);
		while( $row = mysql_fetch_assoc($result) ) {
			print("<option value='".$row['id']."' ".(($row['id']==$album_id)?'SELECTED':'').">".$row['album_name']."</option>\n");
		}
		print("</select></td>\n");
		print("</tr>\n");
		print("<tr>\n");
		print("<td class='tdrow1'  width='40%'  valign='middle'><b>Format</b></td>\n");
		print("<td class='tdrow2'  width='60%'  valign='middle'><select name='format_id' id='format_id'>\n");
		$query = "SELECT * FROM format ORDER BY format ASC";
		$result = mysql_query($query);
		while( $row = mysql_fetch_assoc($result) ) {
			print("        <option value='".$row['id']."' ".(($row['id']==$format_id)?'SELECTED':'').">".$row['format']."</option>\n");
		}
		print("</select></td>\n");
		print("</tr>\n");
		print("<tr>\n");
		$smod = $HTTP_GET_VARS["mod"];
		if($smod == 1)
		{
			//$sstr = "Song Path / Remote Url:"; 
			$sstr = "Song Path:"; 	
		}
		else
		{
			$sstr = "Song Path:"; 
		}			
		print("<td class='tdrow1'  width='40%'  valign='middle'><b>".$sstr."</b></td>\n");
		print("<td class='tdrow2'  width='60%'  valign='middle'><input name='song_path' type='file' id='song_path'  amaxlength='255' value='".$song_path."'></td>\n");
		print("</tr>\n");
		
		$smod = 1;

	//	if($smod == 1)
	//	{
			
			print("<tr>\n");
			print("<td class='tdrow1'  width='40%'  valign='middle'><b>Allow Download</b>  </td>\n");
			if($downloadurl == "")
			{
				print("<td class='tdrow2'  width='60%'  valign='middle'><input name='chkdownloadurl' type='checkbox' id='chkdownloadurl' onclick = 'javascript:func_onclick();'><input name='txtmod' type='hidden' id='txtmod' value = '".$smod."'><input name='txtchk' type='hidden' id='txtchk' ><input name='txtsitename' type='hidden' id='txtsitename'  value = '".SITE_NAME."'></td>\n");
				print("</tr>\n");
			}
			else
			{
				print("<td class='tdrow2'  width='60%'  valign='middle'><input name='chkdownloadurl' type='checkbox' id='chkdownloadurl'  onclick = 'javascript:func_onclick();' checked><input name='txtmod' type='hidden' id='txtmod' value = '".$smod."'><input name='txtchk' type='hidden' id='txtchk' ><input name='txtsitename' type='hidden' id='txtsitename'  value = '".SITE_NAME."'></td>\n");
				print("</tr>\n");
			}
	
		/***********************************************************************/
			print("<tr>\n");
			print("<td class='tdrow1'  width='40%'  valign='middle'><b>Download Url</b> </td>\n");
			print("<td class='tdrow2'  width='60%'  valign='middle'><input name='downloadurl' type='text' id='downloadurl' maxlength='255' value='".$downloadurl."'></td>\n");			
			print("</tr>\n");
		/***********************************************************************/
        if(is_store_active())
		{
		 print("<tr>\n");
		 print("<td class='tdrow1'  width='40%'  valign='middle'><b>Song Price</b></td>\n");
		 print("<td class='tdrow2'  width='60%'  valign='middle'><input name='price' type='text' id='price' maxlength='255' value='".$price."'></td>\n");
		 print("</tr>\n");
		 print("<tr>\n");
		 print("<td class='tdrow1'  width='40%'  valign='middle'><b>Song Tax</b></td>\n");
		 print("<td class='tdrow2'  width='60%'  valign='middle'><input name='tax' type='text' id='tax' maxlength='255' value='".$tax."'></td>\n");
		 print("</tr>\n");
		}
		else
		{
		 print("<input name='price' type='hidden' id='price' maxlength='255' value='".$price."'>");
		 print("<input name='taxt' type='hidden' id='tax' maxlength='255' value='".$tax."'>");
		} 
		print("</table>\n");
		print("<table width='100%'>\n"); 
		print("<td class='tdrow1' align=center valign='middle'><input name='Reset' type='reset' class='year' id='Reset' value='Reset'></td>\n");
		print("<td class='tdrow2' align=center valign='middle'><input name='Submit' type='submit' class='year' id='Submit' value='Submit'>\n");
		print("</td>\n");
		print("</tr>\n");		
		print("<tr>\n");		
		print("<td>");
		print("<input type = 'hidden' name = 'txttype' value = '".$type."'");
		print("</td>\n");
		print("<td>");
		print("<input type = 'hidden' name = 'txtid' value = '".$id."'");		
		print("</td>\n");
		print("</tr>\n");		
		print("</table>\n");
		print("</form>\n"); 
		print("</div>\n");		
		?>
		<script language = "javascript">
		function func_onclick()
		{
				if(document.form1.chkdownloadurl.checked)
				{
					document.form1.txtchk.value = 1;
					document.form1.downloadurl.value = document.form1.txtsitename.value+"/audio/"+document.form1.song_path.value;
				}
				else
				{
					document.form1.txtchk.value = 0;
					document.form1.downloadurl.value = "";
				}
		}
		function func_check()
		{		
			
			
			stype = document.form1.txttype.value;			
			sid = document.form1.txtid.value;
			smod = document.form1.txtmod.value;
			
			if(smod == 1 )
			{
				smod = 1;
			
			}
			else
			{
				smod = 0;
			}
			
			
			
			if(document.form1.song_path.value == "")
			{
				alert("Song Path must not be empty");
				document.form1.song_path.focus();
				return false;
			}
			if(smod == 0)
			{
				if( document.form1.downloadurl.value != "")
				{
					if(document.form1.song_path.value != document.form1.downloadurl.value)
					{
						alert("Song Path and Download Url must be same");
						document.form1.downloadurl.focus();
						return false;
					}
				}
			}
/**/
			//var smod = 0;
			document.form1.action = "?action=song&page="+stype+"&save=yes&id="+sid+"&mod="+smod+"";
			document.form1.submit();
		}
		</script> 
		<?
	}
	
	function delSong($id)
	{
		global $HTTP_POST_VARS,$HTTP_GET_VARS,$HTTP_SERVER_VARS,$HTTP_SESSION_VARS,$HTTP_COOKIE_VARS;

		if( $HTTP_GET_VARS['save'] ) {
			$query = "DELETE FROM song WHERE id = '".$id."'";
			
			mysql_query($query);
			print("<div id='logomain'><div id='logotopmain'><div style='font-weight:bold;font-size:12px;color:#000;padding-top:14px;padding-left:4px'>Add Songs</div></div></div><table width='100%' cellspacing='6' id='submenu'><tr><td align='left'><a href='adminpanel.php?action=songdir&org=1'>Add Multiple Songs at once</a></td><td align='right'><a href='news.php'>Admin Home</a></td></tr></table><div id='description'>This section will allow you to add or edit an existing song. If you wish to edit or delete the songs, scroll down and edit or delete song by clicking on X link.</div>");
			print("<p>Song \"".$HTTP_POST_VARS['song_name']."\" deleted succesfully.</p>");						
		} else {
			$query = "SELECT * FROM song WHERE id = '".$id."'";
			$row = mysql_fetch_assoc( mysql_query($query) );
			
			$song = $row['song_name'];
		
			// Form
			print("<form action='?action=song&page=del&save=yes&id=".$id."' method='post' name='form' id='form'>\n");
			print("<div id='logomain'><div id='logotopmain'><div style='font-weight:bold;font-size:12px;color:#000;padding-top:14px;padding-left:4px'>Add Songs</div></div></div><table width='100%' cellspacing='6' id='submenu'><tr><td align='left'><a href='adminpanel.php?action=songdir&org=1'>Add Multiple Songs at once</a></td><td align='right'><a href='news.php'>Admin Home</a></td></tr></table><div id='description'>This section will allow you to add or edit an existing song. If you wish to edit or delete the songs, scroll down and edit or delete song by clicking on X link.</div>");
			print("<p>Are you sure that you would like to delete the song \"".$song."\"?");
			print("<input type='hidden' name='song_name' value='".$song."'></p>\n");
			print("<p><input name='Submit' type='submit' class='year' id='Submit' value='Confirm Delete'>\n");
			print("</p></form>\n");
		}
	}
	 
	/********** Upload Song Functions **********/
	
	function songupload()
	{
		global $HTTP_POST_VARS,$HTTP_GET_VARS,$HTTP_SERVER_VARS,$HTTP_SESSION_VARS,$HTTP_COOKIE_VARS;
		
		//Collect Control Index by Post and Check according to selected  
		//check box give proper value

		$num = $HTTP_POST_VARS['num'];

		//Check (checkbox Values)
		if( $HTTP_POST_VARS['song_'.$num] != "" ){
			//Approve	
			$page = "approve";
			$id = $HTTP_POST_VARS['song_'.$num];		//song id
			
		} else if( $HTTP_POST_VARS['den_'.$num] != "" ) {
			//deny
			$page = "deny";
			$id = $HTTP_POST_VARS['den_'.$num];		//song id
			
		}

//		$page = $HTTP_GET_VARS['page'];

		switch( $page ) {
		case 'approve':			
			$this->approveupload_Song(addslashes($id));
			break;
		case 'deny':			
			$this->denyupload_Song(addslashes($id));//infoupload_Song('deny');
			break;
		default:	// default new
			$this->infoupload_Song('new');
			break;		
		}

		$this->songDirListing('');

		
		
	
	}
	function infoupload_Song($type)
	{
		global $HTTP_POST_VARS,$HTTP_GET_VARS,$HTTP_SERVER_VARS,$HTTP_SESSION_VARS,$HTTP_COOKIE_VARS,$HTTP_POST_FILES;

		$id = addslashes($HTTP_GET_VARS['id']); 
		print("<div id='info'>\n");
		
		// Save Information?
		if( $HTTP_GET_VARS['save'] == 'yes' ) {

			 $susername = $HTTP_SESSION_VARS["username"];
			 $suserid = $HTTP_SESSION_VARS["userid"];
	   
			$strfolderename = $susername.$suserid;
			@mkdir("/audio/".$strfolderename);			
		//	@include_once("zip.php");
			if( $type == 'new' ) 
			{

					for($i=0;$i<5;$i++)
					{
						$str_upload		=	trim(basename($HTTP_POST_FILES["upload_song_path".$i]["name"]));

						$str = substr(trim($HTTP_POST_FILES["upload_song_path".$i]["name"]),0,4);

						if( (strtolower($str) == "www.") || (strtolower($str) == "http") )
						{
							$spath = trim($HTTP_POST_FILES["upload_song_path".$i]["name"]);
						}
						else
						{
							$spath = $strfolderename."/".$str_upload;
						}
						
						if($HTTP_POST_VARS['song_name'.$i] != "")
						{
							$str_size = $HTTP_POST_FILES["upload_song_path".$i]["size"];
							if($str_size < 20000000)
							{
								$query = "INSERT INTO upload_song ( song_name, artist_id, album_id, format_id, song_path,user_name ) VALUES ";
								$query .= "('".addslashes(trim($HTTP_POST_VARS['song_name'.$i]))."','".$HTTP_POST_VARS['artist_id'.$i]."','".$HTTP_POST_VARS['album_id'.$i]."','".$HTTP_POST_VARS['format_id'.$i]."','".$spath."','".$susername."')";				

								if(@mysql_query($query))
								{
									
									/************************************************************
                       Upload Songs
									************************************************************/
								
									//$str_upload		=	trim(basename($HTTP_POST_FILES["upload_song_path".$i]["name"]));
										
									$UPLOAD_PATH = "../audio/$strfolderename/";

									if(@is_uploaded_file($HTTP_POST_FILES["upload_song_path".$i]["tmp_name"]))
									{
										@move_uploaded_file($HTTP_POST_FILES["upload_song_path".$i]["tmp_name"],$UPLOAD_PATH.$str_upload);				
									}

									$toggle =1 ;
								}
							}
						}
					}
				/************************************************************/
			} else {
				$query = "UPDATE song SET song_name = '".addslashes($HTTP_POST_VARS['song_name'])."', artist_id = '".$HTTP_POST_VARS['artist_id']."', album_id='".$HTTP_POST_VARS['album_id']."', format_id='".$HTTP_POST_VARS['format_id']."', song_path='".addslashes($HTTP_POST_VARS['song_path'])."' WHERE id = '".$id."'";			
			}
			
			// Run Query
			if($toggle ) {
				print("<table width='500' border='0' cellspacing='0' cellpadding='0'   align='center'><tr><td><div align='left'><img src='../template/images/target_left.jpg' width='13' height='26' border=0></div></td><td width='500' class='target'><div align='center'><p><b>Success! We were able to  upload the songs&nbsp; <img src='../template/images/success.gif' width='16' height='16' alt='Success' border='0'></b></p></td><td><div align='right'><img src='../template/images/target_right.jpg' width='13' height='26' border=0></div></td></tr></table>");
			} else {
				print("<br><table width='500' border='0' cellspacing='0' cellpadding='0' align='center'><tr><td><div align='left'><img src='../template/images/targetred_left.jpg' width='13' height='26' border=0></div></td><td width='500' class='targetred'><div align='center'><p><b><img src='../template/images/fail.gif' width='16' height='16' alt='Success' border='0'>&nbsp;Warning: We were unable to upload the songs : File size must be less than  20Mb</p>");
			}
			
		}
		
		// Determine Type of Form
		if( $type == 'new' ) {
			print("<div class='tableborder'><div class='maintitle'>Upload Song</div>\n");
			$song_name = "";
			$artist_id = "";
			$album_id = "";
			$length_min = 0;
			$length_sec = 0;
			$format_id = "";
			$song_path = "";
			$song_price="0.00";
			$song_tax="0.00";
			//$song_path = $this->musicpath;
		} else {
		
			print("<div class='tableborder'><div class='maintitle'>Edit Song</div>\n");
			$query = "SELECT * FROM song WHERE id = '".$id."'";
			$row = mysql_fetch_assoc( mysql_query($query) );
			
			$song_name = $row['song_name'];
			$artist_id = $row['artist_id'];
			$album_id = $row['album_id'];
			$length_min = floor($row['length']/60);
			$length_sec = $row['length']%60;
			$format_id = $row['format_id'];
			$song_path = $row['song_path'];
			$song_price=$row[price];
			$song_tax=$row[tax];
			
		}
		
		// Form
		print("<form action='?upflag=1&action=upolad_songs&page=".$type."&save=yes&id=".$id."' method='post' name='form' id='form' enctype = 'multipart/form-data'>\n");
		print("<table width='100%' cellspacing='0' cellpadding='5' align='center' border='0'>\n");  
		
		for($vloop=0;$vloop<5;$vloop++)
		{
		print("<tr>\n");
		print("<td class='tdrow1'  width='40%'  valign='middle'>Song Name </td>");
		print("<td class='tdrow2'  width='60%'  valign='middle'><input class = 'para' name='song_name$vloop' type='text' id='song_name$vloop' maxlength='255' value='".$song_name."'></td>\n"); 
		rint("<td class='tdrow1'  width='40%'  valign='middle'>Artist Name </td>\n");
		print("<td class='tdrow2'  width='60%'  valign='middle'><select class = 'para' name='artist_id$vloop' id='artist_id$vloop'>\n");
		$query = "SELECT * FROM artist ORDER BY name ASC";
		$result = mysql_query($query);
		while( $row = mysql_fetch_assoc($result) ) {
			print("<option value='".$row['id']."' ".(($row['id']==$artist_id)?'SELECTED':'').">".$row['name']."</option>\n");
		}
		print("</select></td>\n");
		print("<td class='tdrow1'  width='40%'  valign='middle'>Album Name </td>\n");
		print("<td class='tdrow2'  width='60%'  valign='middle'><select class = 'para' name='album_id$vloop' id='album_id$vloop'>\n");		
		$query = "SELECT * FROM album ORDER BY album_name ASC";
		$result = mysql_query($query);
		while( $row = mysql_fetch_assoc($result) ) {
			print("<option value='".$row['id']."' ".(($row['id']==$album_id)?'SELECTED':'').">".$row['album_name']."</option>\n");
		}
		print("</select></td>\n");
		print("<td class='tdrow1' width='40%'  valign='middle'>Format:</td>\n");
		print("<td class='tdrow2' width='60%'  valign='middle'><select class = 'para' name='format_id$vloop' id='format_id$vloop'>\n");
		$query = "SELECT * FROM format ORDER BY format ASC";
		$result = mysql_query($query);
		while( $row = mysql_fetch_assoc($result) ) {
			print("<option value='".$row['id']."' ".(($row['id']==$format_id)?'SELECTED':'').">".$row['format']."</option>\n");
		}
		print("</select></td>\n");
		print("<td class='tdrow1'  width='40%'  valign='middle'>Song Path: </td>\n");
		print("<td class='tdrow2'  width='60%'  valign='middle'><input class = 'para' name='upload_song_path$vloop'  type='file'></td>\n");
		print("</tr>\n");		
		
		}
		print("<tr>\n");
		print("<td colspan = '10'>\n");
		print("&nbsp;</td>\n");
		print("</tr>\n");
		print("</table><br>\n");
		print("<table align=center><tr>\n"); 
		print("<td class='tdrow1'><input name='Submit'  type='submit' class='year' id='Submit' value='Submit'>\n");
		print("<input name='Reset' type='reset'  class='year' id='Reset' value='Reset'><input name='Submit' type='submit' class='year' id='Submit' value='Submit'>\n");
		print("</td>\n");
		print("</tr>\n");
		print("</table>\n");
		print("</form></p>\n");
		
		print("</div>\n");		
	}
	
	function approveupload_Song($id)
	{
		global $HTTP_POST_VARS,$HTTP_GET_VARS,$HTTP_SERVER_VARS,$HTTP_SESSION_VARS,$HTTP_COOKIE_VARS;



		if( $HTTP_GET_VARS['save'] ) {
			$query = "UPDATE upload_song SET status = 1 WHERE id = '".$id."'";
			mysql_query($query);
			$this->insertintoartisttable($id);
			$this->insertintoalbumtable($id);
			//$this->insertintoformattable($id);
			$this->insertintosongtable($id);			

			print("<table bgcolor='#ff9dbb'><tr><td>Song \"".$HTTP_POST_VARS['song_name']."\" Approved succesfully.</td></tr></table>");								
		} else {
			$query = "SELECT * FROM song WHERE id = '".$id."'";
			$row = mysql_fetch_assoc( mysql_query($query) );
			
			$song = $row['song_name'];
		
			// Form
			print("<form action='?upflag=1&action=upolad_songs&page=approve&save=yes&id=".$id."' method='post' name='form' id='form'>\n");
			print("<table bgcolor='#ff9dbb'><tr><td>Are you sure that you would like to Appove the song \"".$song."\"?</td></tr></table>");
			print("<input type='hidden' name='song_name' value='".$song."'></p>\n");
			print("<p><input name='Submit' type='submit' class='year' id='Submit' value='Confirm Approve'>\n");
			print("</p></form>\n");
		}
	}
	function denyupload_Song($id)
	{
		global $HTTP_POST_VARS,$HTTP_GET_VARS,$HTTP_SERVER_VARS,$HTTP_SESSION_VARS,$HTTP_COOKIE_VARS;

		if( $HTTP_GET_VARS['save'] ) {
				
			$query1 = "select * from upload_song WHERE id = '".$id."'";
			$result1 = @mysql_query($query1);
			$rows1 = @mysql_fetch_array($result1);
			
			$str_path = "/audio/".$rows1["song_path"];

			@unlink($str_path);


			$query = "delete from upload_song WHERE id = '".$id."'";
			mysql_query($query);
			print("<p>Song \"".$HTTP_POST_VARS['song_name']."\" Deny succesfully.</p>");								
		} else {
			$query = "SELECT * FROM song WHERE id = '".$id."'";
			$row = mysql_fetch_assoc( mysql_query($query) );
			
			$song = $row['song_name'];
		
			// Form
			print("<form action='?upflag=1&action=upolad_songs&page=deny&save=yes&id=".$id."' method='post' name='form' id='form'>\n");
			print("<table bgcolor='#ff9dbb'><tr><td>Are you sure that you would like to Appove the song \"".$song."\"?</td></tr></table>");
			print("<input type='hidden' name='song_name' value='".$song."'></p>\n");
			print("<p><input name='Submit' type='submit' class='year' id='Submit' value='Confirm Deny'>\n");
			print("</p></form>\n");
		}
	}
	function insertintoartisttable($id)
	{
			global $HTTP_POST_VARS,$HTTP_GET_VARS,$HTTP_SERVER_VARS,$HTTP_SESSION_VARS,$HTTP_COOKIE_VARS;

		$query1 = "SELECT * FROM upload_song WHERE id = '".$id."'";
		$result1 = @mysql_query($query1);
		$row1 = @mysql_fetch_array($result1) ;

		$query2 = "select * from artist where name = '".$row1["artist_name"]."'";
		$result2 = @mysql_query($query2);
		$row2 = @mysql_fetch_array($result2) ;
		$numrows2 = @mysql_num_rows($result2) ;
		if($numrows2 == 0)
		{
			$query3 = "insert into artist (name) values ('".$row1["artist_name"]."')";
			$result3 = @mysql_query($query3);		

			$query4 = "select max(id) as id from artist";
			$result4 = @mysql_query($query4);
			$rows4 = @mysql_fetch_array($result4);

			$query5 = "update upload_song set artist_id = '".$rows4["id"]."' WHERE id = '".$id."'";
			$result5 = @mysql_query($query5);

		}
	}
	function insertintoalbumtable($id)
	{
			global $HTTP_POST_VARS,$HTTP_GET_VARS,$HTTP_SERVER_VARS,$HTTP_SESSION_VARS,$HTTP_COOKIE_VARS;


		$query1 = "SELECT * FROM upload_song WHERE id = '".$id."'";
		$result1 = @mysql_query($query1);
		$row1 = @mysql_fetch_array($result1) ;

		$query2 = "select * from album where name = '".$row1["album_name"]."'";
		$result2 = @mysql_query($query2);
		$row2 = @mysql_fetch_array($result2) ;
		$numrows2 = @mysql_num_rows($result2) ;
		if($numrows2 == 0)
		{
			$query3 = "insert into album (album_name,artist_id) values ('".$row1["album_name"]."','".$row1["artist_id"]."')";
			$result3 = @mysql_query($query3);	
			
			$query4 = "select max(id) as id from album";
			$result4 = @mysql_query($query4);
			$rows4 = @mysql_fetch_array($result4);

			$query5 = "update upload_song set album_id = '".$rows4["id"]."' WHERE id = '".$id."'";
			$result5 = @mysql_query($query5);
		}
	}
	function insertintoformattable($id)
	{
			global $HTTP_POST_VARS,$HTTP_GET_VARS,$HTTP_SERVER_VARS,$HTTP_SESSION_VARS,$HTTP_COOKIE_VARS;

		$query1 = "SELECT * FROM upload_song WHERE id = '".$id."'";
		$result1 = @mysql_query($query1);
		$row1 = @mysql_fetch_array($result1) ;

		$query2 = "select * from format where format = '".$row1["format_name"]."'";
		$result2 = @mysql_query($query2);
		$row2 = @mysql_fetch_array($result2) ;
		$numrows2 = @mysql_num_rows($result2) ;
		if($numrows2 == 0)
		{
			$query3 = "insert into format (format) values ('".$row1["format_name"]."')";
			$result3 = @mysql_query($query3);	
			
			$query4 = "select max(id) as id from format";
			$result4 = @mysql_query($query4);
			$rows4 = @mysql_fetch_array($result4);

			$query5 = "update upload_song set format_id = '".$rows4["id"]."' WHERE id = '".$id."'";
			$result5 = @mysql_query($query5);
		}
	}
	function insertintosongtable($id)
	{
			global $HTTP_POST_VARS,$HTTP_GET_VARS,$HTTP_SERVER_VARS,$HTTP_SESSION_VARS,$HTTP_COOKIE_VARS;

		$query1 = "SELECT * FROM upload_song WHERE id = '".$id."'";
		$result1 = @mysql_query($query1);
		$row1 = @mysql_fetch_array($result1) ;
		
		if($row1["song_id"] == 0)
		{
			$query2 = "INSERT INTO song ( song_name, artist_id, album_id, format_id, song_path, user_name ) VALUES ";
			$query2 .= "('".$row1["song_name"]."','".$row1["artist_id"]."','".$row1["album_id"]."','".$row1["format_id"]."','".$row1["song_path"]."','".$row1["user_name"]."')";
			@mysql_query($query2);

			$query3 = "SELECT max(id) as id FROM song ";
			$result3 = @mysql_query($query3)or die(mysql_error());
			$row3 = @mysql_fetch_array($result3);

			$query4 = "UPDATE upload_song SET song_id = '".$row3["id"]."' WHERE id = '".$id."'";
			@mysql_query($query4);
		}


	}

	function viewsongs()
	{
		global $HTTP_POST_VARS,$HTTP_GET_VARS,$HTTP_SERVER_VARS,$HTTP_SESSION_VARS,$HTTP_COOKIE_VARS;

		$page = $HTTP_GET_VARS['page'];
		$username = $HTTP_POST_VARS["txtuser"];	
		if($username == "")
		{
			$username = $HTTP_GET_VARS["txtuser"];	
		}

		if($page  == 'del') 
		{				
			$this->delusersong($HTTP_GET_VARS["id"]);
		}
		else if($page  == 'edit') 
		{					
			$this->editusersong($HTTP_GET_VARS["id"]);
		}		

		$query = "select id , song_name from song where user_name = '".$username."'";

		if( $result = mysql_query($query) ) { //$this->mysqlTable($result,array('Delete'=>'page=del','Edit'=>'page=edit'),"?action=viewsongs&id=[id]&",false); 
		$this->mysqlTable($result,array('Delete'=>'page=del'),"?txtuser=$username&action=viewsongs&id=[id]&",false);
		}
	}
	function delusersong($id)
	{
			global $HTTP_POST_VARS,$HTTP_GET_VARS,$HTTP_SERVER_VARS,$HTTP_SESSION_VARS,$HTTP_COOKIE_VARS;

			
			$query = "DELETE FROM song WHERE id = '".$id."'";
			mysql_query($query);
			print("<p>Song deleted succesfully.</p>");								
			
		
	} 
	/***********************************************************************************/
	function songDirListing( $path ) {
	
		global $HTTP_POST_VARS,$HTTP_GET_VARS,$HTTP_SERVER_VARS,$HTTP_SESSION_VARS,$HTTP_COOKIE_VARS;

		
		if( sizeof($this->extensions) == 0 ){
			die("Error: Must define formats supported by player first");
		}
	/***********************************/
	//			ORG
	/***********************************/
		if($HTTP_GET_VARS["org"]==1)
		{
		      print("<div id='logomain'><div id='logotopmain'><div style='font-weight:bold;font-size:12px;color:#000;padding-top:14px;padding-left:4px'>Add Multiple Songs</div></div></div><table width='100%' cellspacing='6' id='submenu'><tr><td align='left'><a href='adminpanel.php?action=songdir&org=1'>Add Multiple Songs at once</a></td><td align='right'><a href='news.php'>Admin Home</a></td></tr></table><div id='description'>This section will allow you to add multiple songs at once. Just select the songs you wanted to add to your database and click on submit once.</div>");
			print("<div class='tableborder'><div class='maintitle'>Browse Add Songs</div>\n");
		}
	/******************************/
		// Get Song Info

		if( $HTTP_GET_VARS['page'] == 'details' ) {
		
			if( $HTTP_GET_VARS['save'] == 'yes' ) {
				
				$artist_id = -1;
				$album_id = -1;
			
				if( $HTTP_POST_VARS['artist_id'] != -1 ) {
					$artist_id = $HTTP_POST_VARS['artist_id'];
				}
				
				if( $HTTP_POST_VARS['album_id'] != -1 ) {
					$album_id = $HTTP_POST_VARS['album_id'];
				}
// 
#$t_elements_no = $HTTP_POST_VARS['chkelement_no'];
#$arr_element_no  = explode("-",$t_elements_no);

#echo($t_elements_no);exit;

//for($j= 1 ; $j < count($arr_element_no) ; $j++)
//{
//	$t = $arr_element_no[$j] ;

for($t = 7; (isset($HTTP_POST_VARS[($t-5).'song_name']) && isset($HTTP_POST_VARS[($t-4).'artist_id'])) ; $t = $t + 8)
{

  $query = "INSERT INTO song ( song_name, artist_id, album_id, format_id, song_path,url,price,tax) VALUES ";
  $query .= "('".addslashes($HTTP_POST_VARS[($t-5).'song_name'])."','".(($artist_id==-1)?$HTTP_POST_VARS[($t-4).'artist_id']:$artist_id)."','".(($album_id==-1)?$HTTP_POST_VARS[($t-3).'album_id']:$album_id)."','".$HTTP_POST_VARS[($t-2).'format_id']."','".addslashes($HTTP_POST_VARS[($t-1).'song_path'])."','".addslashes($HTTP_POST_VARS[($t+2)."dnldurl"])."','".addslashes($HTTP_POST_VARS[($t+2)."price"])."','".addslashes($HTTP_POST_VARS[($t+2)."tax"])."')";

  mysql_query($query) or die(mysql_error());
}

				// Loop through all
				 
				for( $i=0 ; $HTTP_POST_VARS[$i.'artist_id'] != '' ; $i++ ) {
				  echo($i);exit;
					if($HTTP_POST_VARS["txtchk".$i]==1)
					{
						$query = "INSERT INTO song ( song_name, artist_id, album_id, format_id, song_path,url,price,tax) VALUES ";
						$query .= "('".addslashes($HTTP_POST_VARS[$i.'song_name'])."','".(($artist_id==-1)?$HTTP_POST_VARS[$i.'artist_id']:$artist_id)."','".(($album_id==-1)?$HTTP_POST_VARS[$i.'album_id']:$album_id)."','".$HTTP_POST_VARS[$i.'format_id']."','".addslashes($HTTP_POST_VARS[$i.'song_path'])."','".addslashes($HTTP_POST_VARS[$i."dnldurl"])."','".addslashes($HTTP_POST_VARS[$i."price"])."','".addslashes($HTTP_POST_VARS[$i."tax"])."')";

						mysql_query($query) or die(mysql_error());
					
					}
					else
					{
						$query = "INSERT INTO song ( song_name, artist_id, album_id, format_id, song_path,url,price,tax) VALUES ";
						$query .= "('".addslashes($HTTP_POST_VARS[$i.'song_name'])."','".(($artist_id==-1)?$HTTP_POST_VARS[$i.'artist_id']:$artist_id)."','".(($album_id==-1)?$HTTP_POST_VARS[$i.'album_id']:$album_id)."','".$HTTP_POST_VARS[$i.'format_id']."','".addslashes($HTTP_POST_VARS[$i.'song_path'])."','".addslashes($HTTP_POST_VARS[$i."dnldurl"])."','".addslashes($HTTP_POST_VARS[$i."price"])."','".addslashes($HTTP_POST_VARS[$i."tax"])."')";

						mysql_query($query) or die(mysql_error());
						#echo(1);exit;
					}
					

				
					/**********************************************************/ 
						// For update the status of upload_song table set status = 1 so that in manage upload link this song will not be shown in the list again
				
					/**********************************************************/
						$str_us = "update upload_song set status = 1 where song_path = '".addslashes($HTTP_POST_VARS[$i.'song_path'])."'";						
						@mysql_query($str_us);
					/**********************************************************/
					
					//print("dnldurl : ".$HTTP_POST_VARS[$i."dnldurl"]."<br>");
				
				}

				//** if song Approved by admin

				print("<div id='logomain'><div id='logotopmain'><div style='font-weight:bold;font-size:12px;color:#000;padding-top:14px;padding-left:4px'>Songs Saved</div></div></div><table width='100%' cellspacing='6' id='submenu'><tr><td align='left'><a href='adminpanel.php?action=songdir&org=1'>Add Multiple Songs at once</a></td><td align='right'><a href='news.php'>Admin Home</a></td></tr></table><div id='description'>All songs have been added to your database and you can edit or delete them at any time by going to Songs page.</div>");
				
				print("<table width='500' border='0' cellspacing='0' cellpadding='0'   align='center'><tr><td><div align='left'><img src='../template/images/target_left.jpg' width='13' height='26' border=0></div></td><td width='500' class='target'><div align='center'><p><b>Songs succesfully saved &nbsp; <img src='../template/images/success.gif' width='16' height='16' alt='Success' border='0'></b></p></td><td><div align='right'><img src='../template/images/target_right.jpg' width='13' height='26' border=0></div></td></tr></table>");

			print("<div class='tableborder'><div class='maintitle'>Congractulations!</div>\n");			
				print("<table align=left><tr><td>How to edit or delete Songs ? Visit <a href='adminpanel.php?action=song&mod=1'>songs page</a> and scroll down and click on 'X' to edit or delete songs.</td></tr></table>");
				return;
			
			}
		      print("<div id='logomain'><div id='logotopmain'><div style='font-weight:bold;font-size:12px;color:#000;padding-top:14px;padding-left:4px'>Add Multiple Songs</div></div></div><table width='100%' cellspacing='6' id='submenu'><tr><td align='left'><a href='adminpanel.php?action=songdir&org=1'>Add Multiple Songs at once</a></td><td align='right'><a href='news.php'>Admin Home</a></td></tr></table><div id='description'>This section will allow you to select artist and album to your selected songs into the mysql database, you can even add remote url downloads and remote audio files.</div>");
			print("<div class='tableborder'><div class='maintitle'>Apply Details to All Songs</div>\n");
			print("<form action='javascript:func_chk(".$count.");' method='post' name='form1' id='form1'>"); 
			print("<table width='100%' cellspacing='0' cellpadding='5' align='center' border='0'><tr>\n"); 
		print("<td class='tdrow1'  width='40%'  valign='middle'><b>Artist Name</b></td>\n");
			print("<td class='tdrow2'  width='60%'  valign='middle'><select name='artist_id' id='artist_id'>\n");
			print("<option value='-1' SELECTED>-------</option>\n");
			$query = "SELECT * FROM artist WHERE 1";
			$result = mysql_query($query);
			while( $row = mysql_fetch_assoc($result) ) {
				print("<option value='".$row['id']."'>".$row['name']."</option>\n");
			}
			print("</select></td>\n");
			print("</tr>\n");
			print("<tr>\n");
			print("<td class='tdrow1'  width='40%'  valign='middle'><b>Album Name  </td>\n");
			print("<td class='tdrow2'  width='60%'  valign='middle'><select name='album_id' id='album_id'>\n");
			print("<option value='-1' SELECTED>-------</option>\n");
			$query = "SELECT * FROM album ORDER BY album_name ASC";
			$result = mysql_query($query);
			while( $row = mysql_fetch_assoc($result) ) {
				print("        <option value='".$row['id']."' ".(($row['id']==$album_id)?'SELECTED':'').">".$row['album_name']."</option>\n");
			}
			print("</select></td>\n");
			print("</tr>\n");
			print("</table>\n");
			$count=1;
			print("<div class='tableborder'><div class='maintitle'>Individual Song Details</div>\n");
			foreach( $HTTP_POST_VARS as $song ) {
			
				// Determine song name
				$temp = split("/",$song);
				$element = count($temp)-1;
				list($song_name, $song_ext) = split("\.",$temp[$element]);				
				
				print("<table width='100%' cellspacing='0' cellpadding='5' align='center' border='0'><tr>\n"); 
		        print("<td class='tdrow1'  width='40%'  valign='middle'><b>Song Name</b></td>\n");
				print("<td class='tdrow2'  width='60%'  valign='middle'><input name='".($count+1)."song_name' type='text' id='".($count+1)."song_name' value='".$song_name."'></td>\n");
				print("</tr>\n");
				print("<tr>\n");
				print("<td class='tdrow1'  width='40%'  valign='middle'><b><b>Artist Name</b> </td>\n");
				print("<td class='tdrow2'  width='60%'  valign='middle'><select name='".($count+2)."artist_id' id='".($count+2)."artist_id'>\n");
				$query = "SELECT * FROM artist WHERE 1";
				$result = mysql_query($query);
				while( $row = mysql_fetch_assoc($result) ) {
					print("<option value='".$row['id']."'>".$row['name']."</option>\n");
				}
				print("</select></td>\n");
				print("</tr>\n");
				print("<tr>\n");
				print("<td class='tdrow1'  width='40%'  valign='middle'><b>Album Name</b></td>\n");
				print("<td class='tdrow2'  width='60%'  valign='middle'><select name='".($count+3)."album_id' id='".($count+3)."album_id'>\n");
				$query = "SELECT * FROM album ORDER BY album_name ASC";
				$result = mysql_query($query);
				while( $row = mysql_fetch_assoc($result) ) {
					print("<option value='".$row['id']."' ".(($row['id']==$album_id)?'SELECTED':'').">".$row['album_name']."</option>\n");
				}
				print("</select></td>\n");
				print("</tr>\n");
				print("<tr>\n");
				print("<td class='tdrow1'  width='40%'  valign='middle'><b>Format</b></td>\n");
				print("<td class='tdrow2'  width='60%'  valign='middle'><select name='".($count+4)."format_id' id='".($count+4)."format_id'>\n");
				$query = "SELECT * FROM format ORDER BY format ASC";
				$result = mysql_query($query);
				while( $row = mysql_fetch_assoc($result) ) {
					print("<option value='".$row['id']."' ".(preg_match("/".$song_ext."$/i",$row['extension'])?'SELECTED':'').">".$row['format']."</option>\n");
				}
				print("</select></td>\n");
				print("</tr>\n");
				print("<tr height = '25'>\n");
				print("<td class='tdrow1'  width='40%'  valign='middle'><b>Song Path</b></td>\n");
				print("<td class='tdrow2'  width='60%'  valign='middle'><input name='".($count+5)."song_path' type='hidden' id='".($count+5)."song_path' value='".$song."'>".$song."</td>\n");				
				print("</tr>\n");
				/*********************************************************/
					//For Download url

				print("<tr>\n");
				print("<td class='tdrow1'  width='40%'  valign='middle'><b>Allow Download</b></td>\n");
				print("<td class='tdrow2'  width='60%'  valign='middle'><input type = 'checkbox' name = '".($count+6)."chkdnldurl' onclick = 'javascript:func_onclick(".($count+6).");'><input type = 'hidden' name = 'txtchk".($count+7)."'></td>\n");
				print("</tr>\n");

				print("<tr>\n");
				print("<td class='tdrow1'  width='40%'  valign='middle'><b>Download url</b> </td>\n");
				print("<td class='tdrow2'  width='60%'  valign='middle'><input type = 'textbox' name = '".($count+8)."dnldurl' ></td>\n");
				print("</tr>\n");
				 
				 if(is_store_active())
				{
				 print("<tr>\n");
				 print("<td class='tdrow1'  width='40%'  valign='middle'><b>Price</b></td>\n");
				 print("<td class='tdrow2'  width='60%'  valign='middle'><input type = 'textbox' name = '".($count+8)."price'></td>\n");
				 print("</tr>\n");				
				 print("<tr>\n");
				 print("<td class='tdrow1'  width='40%'  valign='middle'><b>Tax</b></td>\n");
				 print("<td class='tdrow2'  width='60%'  valign='middle'><input type = 'textbox' name = '".($count+8)."tax' ></td>\n");
				 print("</tr>\n");				
                }
				else
				{
				 print("<input type = 'hidden' name = '".($count+8)."price' >");
				 print("<input type = 'hidden' name = '".($count+8)."tax' >\n");
				}				

				/*********************************************************/
				print("</table></p>\n");
				
				$count = $count+8 ;
			} 
			print("<input name='total' type='hidden' id='total' value='0'><input name='chkelement_no' type='hidden' id='chkelement_no' value='0'><input type = 'hidden' name = 'txtsitename' value = '".SITE_NAME."'>\n");
			print("<table align=center><tr>\n"); 
		print("<td class='tdrow1'><input name='Submit' type='submit' class='year' id='Submit' value='Submit'></td>\n");
			print("</form></tr></table>\n");
?>
	<script language = "javascript">
		function func_onclick(count)
		{
			//alert(count);
			t = count+1 ;
			p = t+1;
			q = count-1 ;
		
			
				if(document.forms['form1'][count+'chkdnldurl'].checked)
				{
					document.forms['form1']['chkelement_no'].value = document.forms['form1']['chkelement_no'].value + "-"+ count;

					document.form1.elements['txtchk' + t].value = 1;
					document.forms['form1'][p+'dnldurl'].value = document.forms['form1']['txtsitename'].value+"/audio"+document.forms['form1'][q+'song_path'].value;
				}
				else
				{
					document.form1.elements['txtchk' + t].value = 0;
					document.forms['form1'][p+'dnldurl'].value = "";
				}
			
		}

		function func_chk(count)
			{
			
				
					document.forms['form1'].action = "?action=songdir&page=details&save=yes";
					document.forms['form1'].submit();
			}
	</script>
<?
			
					
		} else {

		
			
/*	
	/***********************************/
	//			ORG
	/***********************************/
		if($HTTP_GET_VARS["org"]==1)
		{
			print("<table width='100%' cellspacing='0' cellpadding='5' align='center' border='0'><tr>\n"); 
		print("<td class='tdrow1'  width='40%'  valign='middle'><b>Audio (root)</b></td>\n");
		print("<td class='tdrow2'  width='60%'  valign='middle'><form action='?action=songdir&page=details&usflag=1' method='post' name='form1' id='form1'>\n"); 
			$this->dirListing($path);
			print("</td>\n");
		    print("</tr>\n"); 
			print("</table><br>\n");
		    print("<table align=center><tr>\n"); 
		    print("<td class='tdrow1'><input type='submit' class='year' id='Submit' value='Submit'>\n");
			print("</form>\n");
			print("</td></tr></table>"); 
			print("<div class='tableborder'><div class='maintitle'>Add Song Download Link</div>");
		print("<table width='100%' cellspacing='0' cellpadding='5' align='center' border='0'><tr>\n"); 
		print("<tr>\n");
		print("<td class='tdrow1'  width='80%' align=center valign='middle'><label for='genre'><b><a href='../index.php?action=songlink' style='font-weight:bold'>Add Song Download Link Manually.</a></td></tr></table>");
				
		}
		else
		{

	

				$songflag = $HTTP_GET_VARS["songflag"];
				if($songflag == "")
				{
					$songflag = $HTTP_POST_VARS["tsongflag"];
				}
				

						if ($songflag == 0) 
						{
							 print("<div id='logomain'><div id='logotopmain'><div style='font-weight:bold;font-size:12px;color:#000;padding-top:14px;padding-left:4px'>Uploaded Songs</div></div></div><table width='100%' cellspacing='6' id='submenu'><tr><td align='left'><a href='adminpanel.php?action=addlyrics'>Approve or Delete Uploaded Songs</a></td><td align='right'><a href='news.php'>Admin Home</a></td></tr></table><div id='description'>This section will allow you to approve or delete songs uploaded by your users and admins.</div>");
							 print("<div class='tableborder'><div class='maintitle'>Users Who Uploaded Songs</div>\n");
print("<table width='100%' cellspacing='0' cellpadding='5' align='center' border='0'><tr>\n"); 
		print("<tr>\n");
		print("<td class='tdrow1'  width='80%' align=center valign='middle'><label for='genre'><b><a href='../index.php?action=songlink' style='font-weight:bold'>Add Song Download Link Manually.</a></td></tr></table>");
		
							print("<table width='100%' cellspacing='0' cellpadding='5' align='center' border='0'><form action='' name='f_user'>");

							$qry = "SELECT DISTINCT(user_name) FROM upload_song ";			
							$qry_result = mysql_query($qry) or die(mysql_error());

							while($row = mysql_fetch_array($qry_result))
							{			
								/*//Get Username
								$qry_uname = "SELECT username FROM users WHERE userid = '".$row[0]."'";
								$result_qry = mysql_query($qry_uname) or die(mysql_error());
								$row_username = mysql_fetch_array($result_qry);
			*/
								print("<tr><td class='tdrow1'  width='100%'  valign='middle'><b><li><a href = '?action=songdir&songflag=1&username=".$row[0]."'>".$row[0]."</a></li></b></td></tr>\n");

							}
							print("</form></table>");



						}
						else if ($songflag == 1) 
						{
				

					$str_user = $HTTP_GET_VARS["username"];
					
					if($str_user == "")
					{
						$str_user = $HTTP_POST_VARS["tusername"];			
					}

							//$this->dirListing($path);
			/***********************************/
										$query = "SELECT  * from upload_song where user_name = '".$str_user."' and status = 0";
										$result = mysql_query($query) or die(mysql_error());
										$rec = mysql_num_rows($result);
								     print("<div id='logomain'><div id='logotopmain'><div style='font-weight:bold;font-size:12px;color:#000;padding-top:14px;padding-left:4px'>Uploaded Songs</div></div></div><table width='100%' cellspacing='6' id='submenu'><tr><td align='left'><a href='adminpanel.php?action=addlyrics'>Approve or Delete Uploaded Songs</a></td><td align='right'><a href='news.php'>Admin Home</a></td></tr></table><div id='description'>This section will allow you to approve or delete uploaded songs by your users or admins.</div>");
							 print("<div class='tableborder'><div class='maintitle'>Songs Uploaded By ".$str_user."</div>\n");		 
									 
									if($rec == 0)
									{
										printf("No records");
									}
										$i = 0;		
										$vcount = 0;
									//	for( $i = 0 ; $row = mysql_fetch_assoc($result); $i++ ) {	
										while($row = mysql_fetch_array($result))
										{			
											
											
											$filename = $row['song_path'];
											
											$str = strtolower(substr($filename,0,4));

											if( ($str == "http") || ($str == "www.") ) 
											{
												if($str == "www.")
												{
													$download_path = "http://".$filename ;
												}
												else
												{
													$download_path = $filename ;
												}
											}
											else
											{
												$download_path = SITE_NAME."/audio/".$filename ;
											}

											$sflag = 1;

											print("<form name='listing' action='?action=upolad_songs&save=yes' method='post'>\n");
											//print("<form name='listing_$vcount' action='javascript:func_move1();' method='post'>\n");
											print("<table width='100%' cellspacing='0' cellpadding='5' align='center' border='0'><tr>\n");  
			print("<input type = 'hidden' name ='tusername'  value = ".$str_user.">");
			print("<input type = 'hidden' name ='tsongflag'  value = ".$sflag.">");
											print("<td class='tdrow1' width='40%'  valign='middle'><b>Approve: <input type='checkbox' name='song_".$count."' value='".$row['id']."' style='width:15px' onclick = 'javascript:func_app($vcount);' checked>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Deny: <input type='checkbox' name='den_".$count."' value='".$row['id']."' style='width:15px' onclick = 'javascript:func_deny($vcount);'></td><td class='tdrow2' width='60%'  valign='middle'><b>Song</b> :&nbsp; <input type= 'hidden' name = 'song_name' value = ".$row['song_name']."><a href='".$download_path."'>".$row['song_name']."</a></td></tr>\n");
											print("<tr><td class='tdrow1' width='40%'  valign='middle'><b><span style='font-weight:bold;'>Artist Name</span></td><td class='tdrow2'  width='60%'  valign='middle'> ".$row['artist_name']."</td></tr>\n");
											print("<tr><td class='tdrow1' width='40%'  valign='middle'><b><span style='font-weight:bold;'>Album Name</span></td><td class='tdrow2'  width='60%' valign='middle'> ".$row['album_name']."</td></tr>\n");
											print("<tr><td class='tdrow1' width='40%'  valign='middle'><b><span style='font-weight:bold'><b>Download URL</b></span></td>\n");
											print("<td class='tdrow2' width='60%'  valign='middle'><b><span style='font-weight:bold'><a href='".$download_path."'>".$download_path."</a></span></td></tr>\n");
																				
											print("</td></tr></table>\n");	
											print("<table align=center class='tdrow1'><tr><td><input type='hidden' name='num' value=".$count."> <input type='submit' value='Submit'></td></tr>\n"); 
											print("</td></tr>\n");	 
											print("</table></form>\n"); 
											$count++;
											$vcount++;													
									}
													?>
													<script language = 'javascript'>
													function func_app(formno)
													{											
																											
														if(document.forms[formno].elements[3].checked)
														{
															document.forms[formno].elements[3].checked = false;
														}
														
													}
													function func_deny(formno)
													{											
																											
														if(document.forms[formno].elements[2].checked)
														{
															document.forms[formno].elements[2].checked = false;
														}
														
													}
												</script>
												<?
			/*****************************************/
						}
						else if ($songflag == 1) 
						{
					
							$this->dirListing($path);
						}
						
				//		print("<p><input type='submit' class='year' id='Submit' value='Submit'>\n");
				//		print("</p></table></form>\n");

			}
		}
		
	}
	
	function dirListing( $path ) {
	
		global $HTTP_POST_VARS,$HTTP_GET_VARS,$HTTP_SERVER_VARS,$HTTP_SESSION_VARS,$HTTP_COOKIE_VARS;
		$count = 0;

        $ta = explode("audio",$path);

		if( $handle = @opendir($path) ) {

			while( false !== ($file = readdir($handle))) {				
				if( $file == "." || $file == ".." ) {					
					// do nothing
				} else if( is_dir($path."/".$file) ) {
						
					print("</td></tr>
<td class='tdrow1'  width='40%'  valign='middle'><b>".$file."</b>\n");
					print("</td>
<td class='tdrow2'  width='60%'  valign='middle'><blockquote>\n");

					$this->dirListing( $path."/".$file );
					print("</blockquote>\n");
				} else {
					foreach( $this->extensions as $ext)
					{	

						if( preg_match("/\.".$ext."$/i",$file))	{
							
							$v = $ta[1]."/".$file;

							///$query = "SELECT id FROM song WHERE song_path = '".$path."/".$file."'";

							//$query = "SELECT id FROM song WHERE song_path = '".$file."'";

							$query = "SELECT id FROM song WHERE song_path = '".$v."'";

							$result = mysql_query($query) or die(mysql_error());
							
							if( $oldfile = mysql_fetch_assoc($result))
							{								

							} else 
								{
								
								//print("<p><input type='checkbox' class='checkbox' name='".$path."/".$file."' value='".$path."/".$file."'>".$file."</p>\n");
								/*********************************/ 
								//print("<p><input type='checkbox' class='checkbox' name='".$path."/".$file."' value='".$file."'>".$file."</p>\n");
								print("<p><input type='checkbox' class='checkbox' name='".$path."/".$file."' value='".$v."'>".$file."</p>\n");
								/*********************************/
								
								}	
					}
					
				}
			
				}
			}
		
		}
		
		if ($handle) 
            @closedir($handle); 
	
	}
	
	 function addlyrics() {
	
		global $HTTP_POST_VARS,$HTTP_GET_VARS,$HTTP_SERVER_VARS,$HTTP_SESSION_VARS,$HTTP_COOKIE_VARS;
        print("<div id='logomain'><div id='logotopmain'><div style='font-weight:bold;font-size:12px;color:#000;padding-top:14px;padding-left:4px'>Approve or Delete Lyrics</div></div></div><table width='100%' cellspacing='6' id='submenu'><tr><td align='left'><a href='adminpanel.php?action=addlyrics'>Approve or Delete Lyrics</a></td><td align='right'><a href='news.php'>Admin Home</a></td></tr></table><div id='description'>This section will allow you to approve or delete lyrics submitted by your users or admins.</div>");
			
		$page = $HTTP_GET_VARS["page"];
		if($page  == 'del') 
		{				 
			$this->dellyrics($HTTP_GET_VARS["id"]);
		}		

		$save = addslashes($HTTP_GET_VARS['save']);
		
		if( $save == 'yes' ) {
			for( $i = 0 ; $i < $HTTP_POST_VARS['num'] ; $i++ ) {
			
				if( $HTTP_POST_VARS['song_'.$i] != "" ) {
					$query = "UPDATE song SET lyrics_approved = '1', lyric_id = '".$HTTP_POST_VARS['lyric_'.$i]."' WHERE id = '".$HTTP_POST_VARS['song_'.$i]."'";
					mysql_query($query) or die(mysql_error());
					print("<table width='500' border='0' cellspacing='0' cellpadding='0'   align='center'><tr><td><div align='left'><img src='../template/images/target_left.jpg' width='13' height='26' border=0></div></td><td width='500' class='target'><div align='center'><p><b>Lyric ".$HTTP_POST_VARS['lyric_'.$i]." approved&nbsp; <img src='../template/images/success.gif' width='16' height='16' alt='Success' border='0'></b></p></td><td><div align='right'><img src='../template/images/target_right.jpg' width='13' height='26' border=0></div></td></tr></table>");	
				} else if( $HTTP_POST_VARS['del_'.$i] != "" ) {
					$query = "UPDATE song SET lyrics_approved = '0', lyric_id = '0' WHERE id = '".$HTTP_POST_VARS['song_'.$i]."'";
					mysql_query($query) or die(mysql_error());
										
					$query = "DELETE FROM lyric WHERE id ='".$HTTP_POST_VARS['lyric_'.$i]."'";
					mysql_query($query) or die(mysql_error());
					
					print("<table width='500' border='0' cellspacing='0' cellpadding='0'   align='center'><tr><td><div align='left'><img src='../template/images/target_left.jpg' width='13' height='26' border=0></div></td><td width='500' class='target'><div align='center'><p><b>Lyric ".$HTTP_POST_VARS['lyric_'.$i]." removed&nbsp; <img src='../template/images/success.gif' width='16' height='16' alt='Success' border='0'></b></p></td><td><div align='right'><img src='../template/images/target_right.jpg' width='13' height='26' border=0></div></td></tr></table>");
				}
				
				$query = "UPDATE lyric SET lyrics = '".addslashes($HTTP_POST_VARS["lyrics_".$i])."' WHERE id = '".$HTTP_POST_VARS['lyric_'.$i]."'";
				mysql_query($query) or die(mysql_error());
				print("<table width='500' border='0' cellspacing='0' cellpadding='0'   align='center'><tr><td><div align='left'><img src='../template/images/target_left.jpg' width='13' height='26' border=0></div></td><td width='500' class='target'><div align='center'><p><b>Lyric ".$HTTP_POST_VARS['lyric_'.$i]." updated&nbsp; <img src='../template/images/success.gif' width='16' height='16' alt='Success' border='0'></b></p></td><td><div align='right'><img src='../template/images/target_right.jpg' width='13' height='26' border=0></div></td></tr></table>");
			}
		}
		
		if($page  == 'edit') 
		{				
			
			$query = "SELECT song.lyrics_approved as lyrics_approved , AVG(song.rating/song.num_rating) as average_rating, album.album_name as album, song.lyric_id, album.id as album_id, artist.id as artist_id, artist.name AS artist_name, lyric.lyrics, song.song_name, song.id as song_id FROM song, album, artist, lyric WHERE album.id = song.album_id AND artist.id = song.artist_id AND lyric.id = song.lyric_id AND lyric.id = ".$HTTP_GET_VARS["id"]." GROUP BY song.id";
		}	
		else
		 {
		$query = "SELECT AVG(song.rating/song.num_rating) as average_rating, album.album_name as album, song.lyric_id, album.id as album_id, artist.id as artist_id, artist.name AS artist_name, lyric.lyrics, song.song_name, song.id as song_id FROM song, album, artist, lyric WHERE album.id = song.album_id AND artist.id = song.artist_id AND lyric.id = song.lyric_id AND song.lyric_id != '0' AND song.lyrics_approved != '1' GROUP BY song.id";
		 }
	

		$result = mysql_query($query) or die(mysql_error()); 
		print("<div class='tableborder'><div class='maintitle'>Approve or Delete Lyrics</div>\n");
		print("<form name='listing' action='?action=addlyrics&save=yes' method='post'>\n");
		print("<table width='100%' cellspacing='0' cellpadding='5' align='center' border='0'><tr>\n");
		$i = 0;
		for( $i = 0 ; $row = mysql_fetch_assoc($result); $i++ ) {				
				if($page  == 'edit')  
				{
					if($row["lyrics_approved"] == 1) 
					{
						print("<td class='tdrow1'  width='40%'  valign='middle'>Approve: <input type='checkbox' name='song_".$i."' value='".$row['song_id']."' style='width:15px' checked>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Delete: <input type='checkbox' name='del_".$i."' value='".$row['song_id']."' style='width:15px'>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Song: <a href='index.php?action=song&id=".$row['song_id']."' target='_blank'>".$row['song_name']."</a></td></tr>\n");
					}
					else
					{
						print("<tr><td class='tdrow2'  width='40%'  valign='middle'>Approve: <input type='checkbox' name='song_".$i."' value='".$row['song_id']."' style='width:15px'>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Delete: <input type='checkbox' name='del_".$i."' value='".$row['song_id']."' style='width:15px'>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Song: <a href='index.php?action=song&id=".$row['song_id']."' target='_blank'>".$row['song_name']."</a></td></tr>\n");
					}
				}
				else
				{
					print("<tr><td class='tdrow2' width='40%'  valign='middle'>Approve: <input type='checkbox' name='song_".$i."' value='".$row['song_id']."' style='width:15px'>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Delete: <input type='checkbox' name='del_".$i."' value='".$row['song_id']."' style='width:15px'>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Song: <a href='index.php?action=song&id=".$row['song_id']."' target='_blank'>".$row['song_name']."</a></td></tr>\n");
				}
		//	print("<tr><td class='tdrow2' width='40%' valign='middle'>Approve: <input type='checkbox' name='song_".$i."' value='".$row['song_id']."' style='width:15px'>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Delete: <input type='checkbox' name='del_".$i."' value='".$row['song_id']."' style='width:15px'>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Song: <a href='index.php?action=song&id=".$row['song_id']."' target='_blank'>".$row['song_name']."</a></td></tr>\n");
			print("<tr><td class='tdrow2' width='40%' valign='middle'><span style='font-weight:bold;'>Artist Name</span> <a href='index.php?action=artist&id=".$row['artist_id']."' target='_blank'>".$row['artist_name']."</a></td></tr>\n");
			print("<tr><td class='tdrow2' width='40%' valign='middle'><span style='font-weight:bold;'>Album Name</span> <a href='index.php?action=album&id=".$row['album_id']."' target='_blank'>".$row['album']."</a></td></tr>\n");
			print("<tr><td class='tdrow1' width='40%' valign='middle'><input type='hidden' name='lyric_".$i."' value='".$row['lyric_id']."' style='width:15px'><textarea name='lyrics_".$i."' cols=65 rows=7>".$row['lyrics']."</textarea></td></tr>\n");	
			print("</table>\n");	
		}
		if( $i == 0 ) {
			print("<tr><td class='tdrow2'  width='40%'  valign='middle'>No lyrics submitted</td></tr></table>\n");
		}
		print("<table width=100%><tr><td class='tdrow2' align=center><input type='hidden' name='num' value='".$i."'><input type='submit' value='Submit Now'></td></tr>\n");
		print("</table></form>\n");
	

	print("<div class='tableborder'><div class='maintitle'>Approved Lyrics</div>");

		//$query2 = "SELECT song.id as id, song.song_name as Song_Name, ar.name as Artist_Name, al.album_name as album_Name FROM album as al, artist as ar, song WHERE song.artist_id = ar.id AND song.album_id = al.id ORDER BY ar.name ASC, al.album_name ASC, song.song_name ASC";

		$query2 = "SELECT lyric.id as id, song.song_name as Song_Name, lyric.lyrics as lyrics FROM song,lyric WHERE song.lyric_id = lyric.id and song.lyrics_approved = 1 ORDER BY lyric.id ASC, song.song_name ASC";
//print($query2);
		if( $result = mysql_query($query2) ) 
		{ 
			$this->mysqlTable($result,array('Delete'=>'page=del','Edit'=>'page=edit'),"?action=addlyrics&id=[id]&",false); 
		}
	}
	function dellyrics($id)
	{
			global $HTTP_POST_VARS,$HTTP_GET_VARS,$HTTP_SERVER_VARS,$HTTP_SESSION_VARS,$HTTP_COOKIE_VARS;

			$query0 = "select * from song where lyric_id = ".$id."";
			$result0 = mysql_query($query0) or die(mysql_error());
			$rows0 = mysql_fetch_array($result0)or die(mysql_error());
			$songid = $rows0[0];

					$query = "UPDATE song SET lyrics_approved = '0', lyric_id = '0' WHERE id = '".$songid."'";
					mysql_query($query) or die(mysql_error());
										
					$query = "DELETE FROM lyric WHERE id ='".$id."'";
					mysql_query($query) or die(mysql_error());
					
					print("<table width='500' border='0' cellspacing='0' cellpadding='0'   align='center'><tr><td><div align='left'><img src='../template/images/target_left.jpg' width='13' height='26' border=0></div></td><td width='500' class='target'><div align='center'><p><b>Lyric ".$HTTP_POST_VARS['lyric_'.$i]." removed&nbsp; <img src='../template/images/success.gif' width='16' height='16' alt='Success' border='0'></b></p></td><td><div align='right'><img src='../template/images/target_right.jpg' width='13' height='26' border=0></div></td></tr></table>");							
			
		
	}

function artistgallery()
    {
    global $HTTP_POST_VARS,$HTTP_GET_VARS,$HTTP_SERVER_VARS,$HTTP_SESSION_VARS,$HTTP_COOKIE_VARS,$HTTP_POST_FILES;
       $page=$HTTP_GET_VARS['page'];
       switch( $page ) {
		case 'del':
			$this->delartistgallery($HTTP_GET_VARS['imid'], $HTTP_GET_VARS['aid']);
			break;
        case 'upload':
			$this->uploadartistgallery();
			break;
		default:	// default new
			$this->infoartistgallery();
			break;
		}

    }

    function avaitingartistgallery()
    {
    global $HTTP_POST_VARS,$HTTP_GET_VARS,$HTTP_SERVER_VARS,$HTTP_SESSION_VARS,$HTTP_COOKIE_VARS,$HTTP_POST_FILES;
       $page=$HTTP_GET_VARS['page'];
       switch( $page ) {
		case 'del':
			$this->delavaitingartist($HTTP_GET_VARS['gid']);
			break;
        case 'approve':
			$this->approveavaitingartist($HTTP_GET_VARS['gid']);
			break;
		default:	// default new
			$this->generalavaitingartist();
			break;
		}

    }

    function generalavaitingartist()
    {
    global $HTTP_POST_VARS,$HTTP_GET_VARS,$HTTP_SERVER_VARS,$HTTP_SESSION_VARS,$HTTP_COOKIE_VARS,$HTTP_POST_FILES;
	echo ("<div id='logomain'><div id='logotopmain'><div style='font-weight:bold;font-size:12px;color:#000;padding-top:14px;padding-left:4px'>Approve Artist Gallery</div></div></div><table width='100%' cellspacing='6' id='submenu'><tr><td align='left'><a href='adminpanel.php?action=artistgallery'>Add New Artist Image</a></td><td align='right'><a href='news.php'>Admin Home</a></td></tr></table><div id='description'>This section will allow you to approve or delete an artist image uploaded by users. If you wish to edit or delete the artist images, scroll down and edit or delete artist image by clicking on X link.</div>");
 	echo ("<div class='tableborder'><div class='maintitle'>Artist images, waiting approvals</div>\n");  
 
    echo "<table class='tdrow1' border = '0' style='width:100%;border-collapse:collapse;border-spacing:0px;' cellspacing='0' cellpadding='5'>
       <tr>
         <th class='tdrow5'>Image</th>
          <th class='tdrow5'>Artist Name</th>
          <th class='tdrow5'>Image URL</th>
          <th class='tdrow5'>Approve</th>
          <th class='tdrow5'>Delete</th>
       </tr>";
    $sql_aartist=mysql_query("SELECT * FROM avaiting_artist");
    while($aartist_row = mysql_fetch_array($sql_aartist)) {
       $gid=$aartist_row["gid"];
       $id_artist=$aartist_row["id_artist"];
       $im_name=$aartist_row["url"];
       $ainfo=mysql_query("SELECT * FROM artist WHERE id='$id_artist'");
       $aname=mysql_fetch_array($ainfo);
       $aname=$aname["name"];

       $smallpath=substr($im_name, 0, strpos($im_name, strrchr($im_name, "/")));
       $twopart=substr($im_name, strpos($im_name, strrchr($im_name, "/"))+1, strlen($im_name));
       $smallpath="../".$smallpath."/small-".$twopart;

       echo "<tr onMouseOver=\"this.bgColor='#DFE7EF'\" onMouseOut=\"this.bgColor=''\">
          <td><a target=blank href=images.php?type=waitartist&id=".$gid."><img src=".$smallpath."></a></td>
          <td>".$aname."</td>
          <td>".$im_name."</td>
          <td style='text-align: center'>[ <a href='?action=avaitingartistgallery&page=approve&gid=".$gid."'>X</a> ]</td>
          <td style='text-align: center'>[ <a href='?action=avaitingartistgallery&page=del&gid=".$gid."'>X</a> ]</td>
       </tr>";
    }
    echo "</table></p>";
    }

    function approveavaitingartist($gid)
    {
    global $HTTP_POST_VARS,$HTTP_GET_VARS,$HTTP_SERVER_VARS,$HTTP_SESSION_VARS,$HTTP_COOKIE_VARS,$HTTP_POST_FILES;
    $result=mysql_query("SELECT * FROM avaiting_artist WHERE gid='$gid'");
    $row=mysql_fetch_array($result);
    $aid=$row["id_artist"];
    $im_url=$row["url"];
    mysql_query("INSERT INTO artist_gallery(id_artist, url) VALUES('$aid', '$im_url')");
    mysql_query("DELETE FROM avaiting_artist WHERE gid='$gid'");
    print("<center><b><a href=?action=avaitingartistgallery>Back</a>\n");
    }

    function delavaitingartist($gid)
    {
    mysql_query("DELETE FROM avaiting_artist WHERE gid='$gid'");
    print("<center><b><a href=?action=avaitingartistgallery>Back</a>\n");
    }


    function avaitingalbumgallery()
    {
    global $HTTP_POST_VARS,$HTTP_GET_VARS,$HTTP_SERVER_VARS,$HTTP_SESSION_VARS,$HTTP_COOKIE_VARS,$HTTP_POST_FILES;
       $page=$HTTP_GET_VARS['page'];
       switch( $page ) {
		case 'del':
			$this->delavaitingalbum($HTTP_GET_VARS['gid']);
			break;
        case 'approve':
			$this->approveavaitingalbum($HTTP_GET_VARS['gid']);
			break;
		default:	// default new
			$this->generalavaitingalbum();
			break;
		}

    }

    function generalavaitingalbum()
    {
    global $HTTP_POST_VARS,$HTTP_GET_VARS,$HTTP_SERVER_VARS,$HTTP_SESSION_VARS,$HTTP_COOKIE_VARS,$HTTP_POST_FILES;
    echo ("<div id='logomain'><div id='logotopmain'><div style='font-weight:bold;font-size:12px;color:#000;padding-top:14px;padding-left:4px'>Approve Album Gallery</div></div></div><table width='100%' cellspacing='6' id='submenu'><tr><td align='left'><a href='adminpanel.php?action=albumgallery'>Add New Album Image</a></td><td align='right'><a href='news.php'>Admin Home</a></td></tr></table><div id='description'>This section will allow you to approve or delete an album image uploaded by users. If you wish to edit or delete the album images, scroll down and edit or delete album image by clicking on X link.</div>");
 	echo ("<div class='tableborder'><div class='maintitle'>Album images, waiting approvals</div>\n");   
    echo "<table class='tdrow1' border = '0' style='width:100%;border-collapse:collapse;border-spacing:0px;' cellspacing='0' cellpadding='5'>
       <tr>
         <th class='tdrow5'>Image</th>
          <th class='tdrow5'>Artist Name</th>
          <th class='tdrow5'>Album Name</th>
          <th class='tdrow5'>Image URL</th>
          <th class='tdrow5'>Approve</th>
          <th class='tdrow5'>Delete</th>
       </tr>";
       $sql_aartist=mysql_query("SELECT * FROM avaiting_album");
    while($aartist_row = mysql_fetch_array($sql_aartist)) {
       $gid=$aartist_row["gid"];
       $id_artist=$aartist_row["id_artist"];
       $id_album=$aartist_row["id_album"];
       $im_name=$aartist_row["url"];
       $ainfo=mysql_query("SELECT * FROM artist WHERE id='$id_artist'");
       $aname=mysql_fetch_array($ainfo);
       $aname=$aname["name"];

       $smallpath=substr($im_name, 0, strpos($im_name, strrchr($im_name, "/")));
       $twopart=substr($im_name, strpos($im_name, strrchr($im_name, "/"))+1, strlen($im_name));
       $smallpath="../".$smallpath."/small-".$twopart;

       $ainfo=mysql_query("SELECT * FROM album WHERE artist_id='$id_artist'");
       $albname=mysql_fetch_array($ainfo);
       $albname=$albname["album_name"];
       echo "<tr onMouseOver=\"this.bgColor='#DFE7EF'\" onMouseOut=\"this.bgColor=''\">
          <td><a target=blank href=images.php?type=waitalbum&id=".$gid."><img src=".$smallpath."></a></td>
          <td>".$aname."</td>
          <td>".$albname."</td>
          <td>".$im_name."</td>
          <td style='text-align: center'>[ <a href='?action=avaitingalbumgallery&page=approve&gid=".$gid."'>X</a> ]</td>
          <td style='text-align: center'>[ <a href='?action=avaitingalbumgallery&page=del&gid=".$gid."'>X</a> ]</td>
       </tr>";
    }
    echo "</table>";
    }

    function approveavaitingalbum($gid)
    {
    global $HTTP_POST_VARS,$HTTP_GET_VARS,$HTTP_SERVER_VARS,$HTTP_SESSION_VARS,$HTTP_COOKIE_VARS,$HTTP_POST_FILES;
    $result=mysql_query("SELECT * FROM avaiting_album WHERE gid='$gid'");
    $row=mysql_fetch_array($result);
    $aid=$row["id_artist"];
    $albid=$row["id_album"];
    $im_url=$row["url"];
    mysql_query("INSERT INTO album_gallery(id_artist, id_album, url) VALUES('$aid', '$albid', '$im_url')");
    mysql_query("DELETE FROM avaiting_album WHERE gid='$gid'");
    print("<center><b><a href=?action=avaitingalbumgallery>Back</a>\n");
    }

    function delavaitingalbum($gid)
    {
    mysql_query("DELETE FROM avaiting_album WHERE gid='$gid'");
    print("<center><b><a href=?action=avaitingalbumgallery>Back</a>\n");
    }


    function albumgallery()
    {
    global $HTTP_POST_VARS,$HTTP_GET_VARS,$HTTP_SERVER_VARS,$HTTP_SESSION_VARS,$HTTP_COOKIE_VARS,$HTTP_POST_FILES;
       $page=$HTTP_GET_VARS['page'];
       switch( $page ) {
		case 'del':
			$this->delalbumgallery($HTTP_GET_VARS['imid'], $HTTP_GET_VARS['albid'], $HTTP_GET_VARS['aid']);
			break;
        case 'step':
			$this->albumgallerystep2();
			break;
        case 'upload':
			$this->uploadartistgallery();
			break;
		default:	// default new
			$this->infoalbumgallery();
			break;
		}

    }


    function infoalbumgallery()
    {
    global $HTTP_POST_VARS,$HTTP_GET_VARS,$HTTP_SERVER_VARS,$HTTP_SESSION_VARS,$HTTP_COOKIE_VARS,$HTTP_POST_FILES;
    if( $HTTP_GET_VARS['save'] == 'yes' ) {
       $str_upload		=	trim(basename($HTTP_POST_FILES["userfile"]["name"]));
       $UPLOAD_PATH = $this->url.ROOT_DIR."/album_gallery/";
	   if(@is_uploaded_file($HTTP_POST_FILES["userfile"]["tmp_name"])) {
	      @move_uploaded_file($HTTP_POST_FILES["userfile"]["tmp_name"],$UPLOAD_PATH.$str_upload);
          $aid=$HTTP_POST_VARS['aid'];
          $albid=$HTTP_POST_VARS['albid'];
          mysql_query("INSERT INTO album_gallery(id_artist, id_album, url) VALUES('$aid', '$albid', 'album_gallery/$str_upload')");
          //******************************
          $filename="../album_gallery/".$str_upload;
          $smallpath=substr($filename, 0, strpos($filename, strrchr($filename, "/")));
          $twopart=substr($filename, strpos($filename, strrchr($filename, "/"))+1, strlen($filename));
          $smallpath=$smallpath."/small-".$twopart;
          $it=substr($filename, strlen($filename)-3, strlen($filename));
          if ($it=="jpg") {
             $img=ImageCreateFromJPEG($filename);
             $dstW=imagesx($img);
             $dstH=imagesy($img);
             $srcW=150;
             $srcH=150;
             $rimg=imagecreatetruecolor($srcW, $srcH);
             imagecopyresized($rimg, $img, 0, 0, 0, 0, $srcW, $srcH, $dstW, $dstH);
             imagejpeg($rimg, $smallpath);
          }
         if ($it=="gif") {
            $img=ImageCreateFromGIF($filename);
            $dstW=imagesx($img);
            $dstH=imagesy($img);
            $srcW=150;
            $srcH=150;
            $rimg=imagecreatetruecolor($srcW, $srcH);
            imagecopyresized($rimg, $img, 0, 0, 0, 0, $srcW, $srcH, $dstW, $dstH);
            imagegif($rimg, $smallpath);
         }
          //******************************
	   }
    }
	echo ("<div id='logomain'><div id='logotopmain'><div style='font-weight:bold;font-size:12px;color:#000;padding-top:14px;padding-left:4px'>Album Gallery</div></div></div><table width='100%' cellspacing='6' id='submenu'><tr><td align='left'><a href='adminpanel.php?action=albumgallery'>Add New Album Image</a></td><td align='right'><a href='news.php'>Admin Home</a></td></tr></table><div id='description'>This section will allow you to add or edit an existing album image. If you wish to edit or delete the album images, scroll down and edit or delete album image by clicking on X link.</div>");
        echo ("<div class='tableborder'><div class='maintitle'>Upload new image to album gallery</div>\n");  

    //$aid=$HTTP_GET_VARS['aid'];
    //if (!isset($aid)) {
       print("<form action='?action=albumgallery&page=step' metod='post'>\n");
       print("<input type=\"hidden\" name=\"action\" value=\"albumgallery\">\n");
       print("<input type=\"hidden\" name=\"page\" value=\"step\">\n");
       print("<table width='100%' cellspacing='0' cellpadding='5' align='center' border='0'><tr>\n"); 
       print("<td class='tdrow1'  width='40%'  valign='middle'><b><font size=2><b>Select Artist</b></font>\n");
       print("<td class='tdrow2'  width='60%'  valign='middle'><select name=\"aid\">\n");
       $sql_artist=mysql_query("SELECT * FROM artist");
       while($artist_row = mysql_fetch_array($sql_artist)) {
          $aid=$artist_row["id"];
          $aname=$artist_row["name"];
          print("<option value=\"".$aid."\">".$aname."\n");
       }
       print("</select></td>\n");
       print("</tr></table><br>\n");
       print("<table class=tdrow1 align=center><tr><td><input name='Submit' type='submit' class='year' id='Submit' value='Submit'>\n");
       print("<input name='Reset' type='reset' class='year' id='Reset' value='Reset'><input name='Submit' type='submit' class='year' id='Submit' value='Submit'>\n");
       print("</td>\n");
       print("</tr>\n");
	   print("</table>\n");
	   print("</form>\n");
    echo "<table class='tdrow1' border = '0' style='width:100%;border-collapse:collapse;border-spacing:0px;' cellspacing='0' cellpadding='5'>
       <tr>
         <th class='tdrow5'>Image</th>
          <th class='tdrow5'>Artist Name</th>
           <th class='tdrow5'>Album Name</th>
           <th class='tdrow5'>Delete</th>
       </tr>";
    $sql_agallery=mysql_query("SELECT * FROM album_gallery");
    while($artist_row = mysql_fetch_array($sql_agallery)) {
       $id_artist=$artist_row["id_artist"];
       $im_id=$artist_row["id"];
       $albid=$artist_row["id_album"];
       $ainfo=mysql_query("SELECT * FROM artist WHERE id='$id_artist'");
       $aname=mysql_fetch_array($ainfo);
       $aname=$aname["name"];
       $albinfo=mysql_query("SELECT * FROM album WHERE artist_id='$id_artist'");
       $albname=mysql_fetch_array($albinfo);
       $albname=$albname["album_name"];

       $url=$artist_row["url"];
       $smallpath=substr($url, 0, strpos($url, strrchr($url, "/")));
       $twopart=substr($url, strpos($url, strrchr($url, "/"))+1, strlen($url));
       $smallpath="../".$smallpath."/small-".$twopart;
       echo "<tr onMouseOver=\"this.bgColor='#DFE7EF'\" onMouseOut=\"this.bgColor=''\">
          <td><a target=blank href=images.php?id=".$im_id."&aid=".$id_artist."&albid=".$albid."><img src=".$smallpath."></a></td>
          <td>".$aname."</td>
          <td>".$albname."</td>
          <td style='text-align: center'>[ <a href='?action=albumgallery&page=del&imid=".$im_id."&aid=".$id_artist."&albid=".$albid."'>X</a> ]</td>
       </tr>";
    }
    echo "</table></p>";
    }

    function albumgallerystep2()
    {
    global $HTTP_POST_VARS,$HTTP_GET_VARS,$HTTP_SERVER_VARS,$HTTP_SESSION_VARS,$HTTP_COOKIE_VARS,$HTTP_POST_FILES;
       $aid=$HTTP_GET_VARS['aid'];
       $sql_artist=mysql_query("SELECT name FROM artist WHERE id='$aid'");
       $aname=mysql_fetch_row($sql_artist);
       $aname=$aname[0];
	   echo ("<div id='logomain'><div id='logotopmain'><div style='font-weight:bold;font-size:12px;color:#000;padding-top:14px;padding-left:4px'>Album Gallery</div></div></div><table width='100%' cellspacing='6' id='submenu'><tr><td align='left'><a href='adminpanel.php?action=albumgallery'>Add New Album Image</a></td><td align='right'><a href='news.php'>Admin Home</a></td></tr></table><div id='description'>This section will allow you to add or edit an existing album image. If you wish to edit or delete the album images, scroll down and edit or delete album image by clicking on X link.</div>");
        echo ("<div class='tableborder'><div class='maintitle'>Upload new image to album gallery</div>\n");  
       print("<form action='?action=albumgallery&save=yes&aid=".$aid."' method='post' enctype = 'multipart/form-data'>\n");
       print("<input type=\"hidden\" name=\"action\" value=\"albumgallery\">\n");
       print("<input type=\"hidden\" name=\"page\" value=\"upload\">\n");
       print("<input type=\"hidden\" name=\"aid\" value=\"".$aid."\">\n");
       print("<table width='100%' cellspacing='0' cellpadding='5' align='center' border='0'><tr>\n"); 
       print("<td class='tdrow1'  width='40%'  valign='middle'><font size=2><b>Step 2, Select any <b>\"".$aname."\"</b> Album</b></font></td>\n");
       print("<td class='tdrow2'  width='60%'  valign='middle'><select name=\"albid\">\n");
       $sql_album=mysql_query("SELECT * FROM album WHERE artist_id='$aid'");
       while($album_row = mysql_fetch_array($sql_album)) {
          $aid=$album_row["id"];
          $aname=$album_row["album_name"];
          print("<option value=\"".$aid."\">".$aname."\n");
       }
       print("</select></td>\n");
       print("</tr>\n");
        print("<td class='tdrow1'  width='40%'  valign='middle'><font size=2><b>Choose image file </b></font></tr>\n");
        print("<td class='tdrow2'  width='60%'  valign='middle'><input name='userfile' type='file'></tr>\n");
		print("</table><br>\n");
       print("<table class=tdrow1 align=center><td><input name='Submit' type='submit' class='year' id='Submit' value='Submit'>\n");
       print("<input name='Reset' type='reset' class='year' id='Reset' value='Reset'><input name='Submit' type='submit' class='year' id='Submit' value='Submit'>\n");
       print("</td>\n");
       print("</tr>\n");
	   print("</table>\n");
	   print("</form>\n");
    }

    function delalbumgallery($imid, $albid, $aid)
    {
    mysql_query("DELETE FROM album_gallery WHERE id_artist='$aid' AND id='$imid' AND id_album='$albid'");
    echo "<center><b>Done</b></center>";
    echo "<center><a href=?action=albumgallery>Back</a></center>";
    }


    function delartistgallery($imid, $aid)
    {
    mysql_query("DELETE FROM artist_gallery WHERE id_artist='$aid' AND id='$imid'");
    echo "<center><b>Done</b></center>";
    echo "<center><a href=?action=artistgallery>Back</a></center>";
    }


    function infoartistgallery()
    {
    global $HTTP_POST_VARS,$HTTP_GET_VARS,$HTTP_SERVER_VARS,$HTTP_SESSION_VARS,$HTTP_COOKIE_VARS,$HTTP_POST_FILES;

    if( $HTTP_GET_VARS['save'] == 'yes' ) {
       $str_upload		=	trim(basename($HTTP_POST_FILES["userfile"]["name"])); 
       $UPLOAD_PATH = $this->url.ROOT_DIR."/artist_gallery/";
	   if(@is_uploaded_file($HTTP_POST_FILES["userfile"]["tmp_name"])) {
	      @move_uploaded_file($HTTP_POST_FILES["userfile"]["tmp_name"],$UPLOAD_PATH.$str_upload);
          $aid=$HTTP_POST_VARS['aid'];
          mysql_query("INSERT INTO artist_gallery(id_artist, URL) VALUES('$aid', 'artist_gallery/$str_upload')");
          //******************************
          $filename="../artist_gallery/".$str_upload;
          $smallpath=substr($filename, 0, strpos($filename, strrchr($filename, "/")));
          $twopart=substr($filename, strpos($filename, strrchr($filename, "/"))+1, strlen($filename));
          $smallpath=$smallpath."/small-".$twopart;
          $it=substr($filename, strlen($filename)-3, strlen($filename));
          if ($it=="jpg") {
             $img=ImageCreateFromJPEG($filename);
             $dstW=imagesx($img);
             $dstH=imagesy($img);
             $srcW=150;
             $srcH=150;
             $rimg=imagecreatetruecolor($srcW, $srcH);
             imagecopyresized($rimg, $img, 0, 0, 0, 0, $srcW, $srcH, $dstW, $dstH);
             imagejpeg($rimg, $smallpath);
          }
         if ($it=="gif") {
            $img=ImageCreateFromGIF($filename);
            $dstW=imagesx($img);
            $dstH=imagesy($img);
            $srcW=150;
            $srcH=150;
            $rimg=imagecreatetruecolor($srcW, $srcH);
            imagecopyresized($rimg, $img, 0, 0, 0, 0, $srcW, $srcH, $dstW, $dstH);
            imagegif($rimg, $smallpath);
         }
          //******************************
	   }
    }
    	echo ("<div id='logomain'><div id='logotopmain'><div style='font-weight:bold;font-size:12px;color:#000;padding-top:14px;padding-left:4px'>Artist Gallery</div></div></div><table width='100%' cellspacing='6' id='submenu'><tr><td align='left'><a href='adminpanel.php?action=artistgallery'>Add New Artist Image</a></td><td align='right'><a href='news.php'>Admin Home</a></td></tr></table><div id='description'>This section will allow you to add or edit an existing artist image. If you wish to edit or delete the artist images, scroll down and edit or delete artist image by clicking on X link.</div>");
        echo ("<div class='tableborder'><div class='maintitle'>Upload new image to Artist gallery</div>\n"); 
		print("<form action='?action=artistgallery&save=yes' method='post' enctype = 'multipart/form-data'>\n");
        print("<input type=\"hidden\" name=\"action\" value=\"artistgallery\">\n");
        print("<input type=\"hidden\" name=\"page\" value=\"upload\">\n");
        print("<table width='100%' cellspacing='0' cellpadding='5' align='center' border='0'><tr>\n"); 
        print("<td class='tdrow1'  width='40%'  valign='middle'><font size=2><b>Select Artist</b></font></td>\n");
        print("<td class='tdrow2'  width='60%'  valign='middle'><select name=\"aid\">\n");
        $sql_artist=mysql_query("SELECT * FROM artist");
        while($artist_row = mysql_fetch_array($sql_artist)) {
           $aid=$artist_row["id"];
           $aname=$artist_row["name"];
           print("<option value=\"".$aid."\">".$aname."\n");
        }
        print("</select></td>\n");
		print("</tr>\n");
        print("<td class='tdrow1'  width='40%'  valign='middle'><font size=2><b>Upload image File </b></font></tr>\n");
        print("<td class='tdrow2'  width='60%'  valign='middle'><input name='userfile' type='file'></tr>\n");
		print("</table><br><table align=center class=tdrow1><tr>\n");
		print("<td><input name='Submit' type='submit' class='year' id='Submit' value='Submit'>\n");
		print("<input name='Reset' type='reset' class='year' id='Reset' value='Reset'><input name='Submit' type='submit' class='year' id='Submit' value='Submit'>\n");
		print("</td>\n");
		print("</tr>\n");
		print("</table>\n");
		print("</form>\n"); 
		print("</div>\n");

    $sql_agallery=mysql_query("SELECT * FROM artist_gallery");
    echo "<table class='tdrow1' border = '0' style='width:100%;border-collapse:collapse;border-spacing:0px;' cellspacing='0' cellpadding='5'>
       <tr>
         <th class='tdrow5'><b>Image</b></th>
          <th class='tdrow5'><b>Artist Name</b></th>
          <th class='tdrow5'><b>Delete</b></th>
       </tr>";
    while($artist_row = mysql_fetch_array($sql_agallery)) {
       $id_artist=$artist_row["id_artist"];
       $im_id=$artist_row["id"];
       $ainfo=mysql_query("SELECT * FROM artist WHERE id='$id_artist'");
       $aname=mysql_fetch_array($ainfo);
       $aname=$aname["name"];
       $url=$artist_row["url"];

       $smallpath=substr($url, 0, strpos($url, strrchr($url, "/")));
       $twopart=substr($url, strpos($url, strrchr($url, "/"))+1, strlen($url));
       $smallpath="../".$smallpath."/small-".$twopart;
       echo "<tr id='row0' onMouseOver=\"this.bgColor='#DFE7EF'\" onMouseOut=\"this.bgColor=''\">";
       echo "<td><a target=blank href=images.php?id=".$im_id."&aid=".$id_artist."><img src=".$smallpath."></a></td>
             <td>".$aname."</td>
          <td style='text-align: center'>[ <a href='?action=artistgallery&page=del&imid=".$im_id."&aid=".$id_artist." '>X</a> ]</td>
       </tr>";
    }
    echo "</table></p>";
    }


}
	
// Login stuff
 
function is_store_active()
{
 global $site_options;
 if(!isset($site_options[store_active]))
 {
  //check wether store is active or not
  //mysql_select_db ($dbDatabase, $db) or die ("Could not select database.");
  //echo "SELECT * FROM config where name='STORE ACTIVE' and value='1'<BR><BR><BR><BR>B<R>B<R>B<R>B<R>";
  $sql_songs = mysql_query("SELECT * FROM config where name='STORE ACTIVE' and value='1' ") or die(mysql_error());
  $site_options[store_active]=mysql_num_rows($sql_songs);
  mysql_free_result($sql_songs);
  //
 }//if(!isset($site_options[store_active]))
 return $site_options[store_active];
}//function is_store_active()
$myadmin = new Admin($action);

echo "<table width='100%' cellspacing='6' id='submenu'><tr><td align='center'>Copyright &copy; 2007 - All rights reserved.</td></tr></table>";
?>

<script>
function ValidUplodFileType(frmName, field, msg)
{
	var total_ext = eval("document."+frmName+".allowed_song_format_cnt").value;
	var y= eval("document."+frmName+"."+field).value;
	var imglen = y.length;
	var imgdotpos = y.lastIndexOf(".");
	var imgext = y.substring(imgdotpos+1,imglen);
	var flag = 0;
	
	for(var i=0;i<total_ext;i++)
	{
		var cur_ext = eval("document."+frmName+".allowed_song_format"+i).value;
		if(y.value!="")
		{
			if((imgext.toLowerCase()!=cur_ext) )
			{
				flag++;
			}
		}
	}
	
	if(flag == total_ext)
	{
		alert("Please Upload Allowed Extention Files Only...!");
		//eval("document."+frmName+"."+field).focus();
		return false;
	}
	return true;
}
</script>